/*************************************************************************** 
*  amx_cal_adminconversion.sma  version 0.90 ALPHA              Date: 07/06/2003 
*  Author: Chris Mobarek        Calzinger@hotmail.com 
*  Nick: Calzinger              AIM: XSOULHELLTEMPLAR
*
*
*   AdminMod Conversion
*   By Calzinger
*
*     This plugin will allow you to use AdminMod's commands in AMX's function.
*     This is mainly for those who cannot get enough of AdminMod's commands and
*     need something to comfort those needs. If you are too used to AdminMod's
*     usage, and you keep using admin_tsay instead of amx_tsay, this plugin will
*     simply read admin_tsay as an AMX command. It is useful for those who are used
*     to AdminMod and who are new to AMX.
*     **WARNING: MAKE SURE YOU ARE NOT RUNNING ADMINMOD WHILE RUNNING THIS PLUGIN.
*     **WARNING: This plugin is running as an ALPHA.
*
*   Required modules:
*    -  None
*
*   Admin Commands:
*    -  admin_kick                Kicks specified client
*    -  admin_ban                 Bans specified client
*    -  admin_unban               Unbans specified uniqueid
*    -  admin_slap                Slaps specified client
*    -  admin_slay                Slays specified client
*    -  admin_say                 Prints message as plain text
*    -  admin_chat                Prints message as plain text to other administrators
*    -  admin_psay                Prints message as plain text to specified user as
*                                        a private message
*    -  admin_tsay                Prints message as printed text
*    -  admin_vote_map            Starts a vote for specified maps (up to 4)
*    -  admin_vote_kick           Starts a vote to kick a specified client
*    -  admin_vote_ban            Starts a vote to ban & kick a specified client
*    -  admin_vsay                Starts a vote in general (<question> <answer #1> <answer #2>)
*    -  admin_pause               Pauses a specified plugin
*    -  admin_cvar                Sets a specified VAR value
*    -  admin_cfg                 Executes a specified config name (.rc or .cfg) 
*    -  admin_rcon                Executes command line on console
*
*   Changelog: 
*   v0.90:
*      - [CREATED]
*
* 
**************************************************************************/ 

#include <amxmod>
#include <amxmisc>

#define MAX_CLR 7

new ncolors[MAX_CLR][] = {"white","red","green","blue","yellow","magenta","cyan"}
new vcolors[MAX_CLR][3] = {{255,255,255},{255,0,0},{0,255,0},{0,0,255},
													{255,255,0},{255,0,255},{0,255,255}}

new msgchannel = 0
new logfilename[256]

public admin_chat(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new message[192], name[32], players[32], inum, authid[16], userid
	read_args(message,191)
	remove_quotes(message)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	userid = get_user_userid(id)
	get_players(players,inum)
	log_to_file(logfilename,"Chat: ^"%s<%d><%s><>^" chat ^"%s^"",name,userid,authid,message)
	log_message("^"%s<%d><%s><>^" triggered ^"amx_chat^" (text ^"%s^")",name,userid,authid,message)
	format(message,191,"(ADMINS) %s :   %s",name,message)
	console_print(id,message)
	for(new i = 0; i < inum; ++i){
		if ( get_user_flags(players[i]) & ADMIN_CHAT )
			client_print(players[i],print_chat,message)
	}
	return PLUGIN_HANDLED
}

public admin_say(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new message[192], name[32],authid[16], userid
	read_args(message,191)
	remove_quotes(message)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	userid = get_user_userid(id)
	client_print(0,print_chat,"(ALL) %s :   %s",name,message)
	console_print(id,"(ALL) %s :   %s",name,message)
	log_to_file(logfilename,"Chat: ^"%s<%d><%s><>^" say ^"%s^"",	name,userid,authid,message)
	log_message("^"%s<%d><%s><>^" triggered ^"amx_say^" (text ^"%s^")",name,userid,authid,message)
	return PLUGIN_HANDLED
}

public admin_psay(id,level,cid){
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	new name[32]
	read_argv(1,name,31)
	new priv = cmd_target(id,name,0)
	if (!priv) return PLUGIN_HANDLED
	new length = strlen(name)+1
	new message[192], name2[32],authid[16],authid2[16], userid, userid2
	get_user_authid(id,authid,15)
	get_user_name(id,name2,31)
	userid = get_user_userid(id)	
	read_args(message,191)
	if (message[0]=='"' && message[length]=='"'){// HLSW fix
		message[0]=message[length]=' '
		length+=2
	}
	remove_quotes(message[length])
	get_user_name(priv,name,31)
	if (id&&id!=priv) client_print(id,print_chat,"(%s) %s :   %s",name,name2,message[length])
	client_print(priv,print_chat,"(%s) %s :   %s",name,name2,message[length])
	console_print(id,"(%s) %s :   %s",name,name2,message[length])
	get_user_authid(priv,authid2,15)
	userid2 = get_user_userid(priv)
	log_to_file(logfilename,"Chat: ^"%s<%d><%s><>^" psay ^"%s<%d><%s><>^" ^"%s^"",
			name2,userid,authid,name,userid2,authid2,message[length])
	log_message("^"%s<%d><%s><>^" triggered ^"amx_psay^" against ^"%s<%d><%s><>^" (text ^"%s^")",
		name2,userid,authid,name,userid2,authid2,message[length])
	return PLUGIN_HANDLED
}

public admin_tsay(id,level,cid){
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	new color[12], message[192], name[32], authid[16], userid = 0
	read_args(message,191)
	remove_quotes(message)
	parse(message,color,11)
	new found = 0,a = 0
	for(new i=0;i<MAX_CLR;++i)
		if (equal(color,ncolors[i])) {
			a = i
			found = 1
			break
		}
	new length = found ? (strlen(color) + 1) : 0
	if (++msgchannel>6||msgchannel<3)
		msgchannel = 3
	new Float:verpos = 0.55 + float(msgchannel) / 35.0
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	userid = get_user_userid(id)
	set_hudmessage(vcolors[a][0], vcolors[a][1], vcolors[a][2], 0.05, verpos, 0, 6.0, 6.0, 0.5, 0.15, msgchannel)
	show_hudmessage(0,"%s :   %s",name,message[length])
	client_print(0,print_notify,"%s :   %s",name,message[length])
	console_print(id,"%s :   %s",name,message[length])
	log_to_file(logfilename,"Chat: ^"%s<%d><%s><>^" tsay ^"%s^"",name,userid,authid,message[length])
	log_message("^"%s<%d><%s><>^" triggered ^"amx_tsay^" (text ^"%s^") (color ^"%s^")",
		name,userid,authid,message[length],ncolors[a])
	return PLUGIN_HANDLED
}


public admin_kick(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,31)
	new player = cmd_target(id,arg,1)
	if (!player) return PLUGIN_HANDLED
	new authid[16],authid2[16],name2[32],name[32],userid2, arg2[32]
	get_user_authid(id,authid,15)
	get_user_authid(player,authid2,15)
	get_user_name(player,name2,31)
	get_user_name(id,name,31)
	userid2 = get_user_userid(player)
	read_argv(2,arg2,31)
	log_to_file(logfilename,"Kick: ^"%s<%d><%s><>^" kick ^"%s<%d><%s><>^" (reason ^"%s^")", 
		name,get_user_userid(id),authid, name2,userid2,authid2,arg2 )
		
	switch(get_cvar_num("amx_show_activity"))	{
	case 2:	client_print(0,print_chat,"ADMIN %s: kick %s",name,name2)
	case 1:	client_print(0,print_chat,"ADMIN: kick %s",name2)
	}
		
	server_cmd("kick #%d",userid2)
	console_print(id,"Client ^"%s^" kicked",name2)
	return PLUGIN_HANDLED
}

public admin_unban(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32],authid[16],name[32]
	get_user_name(id,name,31)	
	read_argv(1,arg,31)
	if (contain(arg,".")!=-1)	{
		server_cmd("removeip ^"%s^";writeip",arg)
		console_print(id,"Ip ^"%s^" removed from ban list", arg  )
	}
	else {
		server_cmd("removeid ^"%s^";writeid",arg)
		console_print(id,"Authid ^"%s^" removed from ban list", arg  )
	}
	switch(get_cvar_num("amx_show_activity"))	{
		case 2:	client_print(0,print_chat,"ADMIN %s: unban %s",name,arg)
		case 1:	client_print(0,print_chat,"ADMIN: unban %s",arg)
	}
	get_user_authid(id,authid,15)
	log_to_file(logfilename,"Cmd: ^"%s<%d><%s><>^" unban ^"%s^"", 
		name,get_user_userid(id),authid, arg )
	return PLUGIN_HANDLED
}

public admin_ban(id,level,cid){
	if (!cmd_access(id,level,cid,3))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(2,arg,31)
	new player = cmd_target(id,arg,9)
	if (!player) return PLUGIN_HANDLED
	new minutes[32],authid[16],name2[32],authid2[16],name[32], arg3[32]
	new userid2 = get_user_userid(player)	
	read_argv(1,minutes,31)
	get_user_authid(player,authid2,15)
	get_user_authid(id,authid,15)
	get_user_name(player,name2,31)
	get_user_name(id,name,31)
	read_argv(3,arg3,31)
	log_to_file(logfilename,"Ban: ^"%s<%d><%s><>^" ban and kick ^"%s<%d><%s><>^" (minutes ^"%s^") (reason ^"%s^")", 
		name,get_user_userid(id),authid, name2,userid2,authid2,minutes,arg3 )
	
	if (equal("4294967295",authid2)){ /* lan */
		new ipa[32]
		get_user_ip(player,ipa,31,1)
		server_cmd("addip %s %s;writeip",minutes,ipa)
	}
	else
		server_cmd("banid %s #%d kick;writeid",minutes,userid2)
		
	new activity = get_cvar_num("amx_show_activity")
	if (activity)	{
		new temp[64], temp2[64]
		if (activity == 1)
			copy(temp,63,"ADMIN:")
		else
			format(temp,63,"ADMIN %s:",name)
		if (strtonum(minutes))
			format(temp2,63,"for %s min.",minutes)	
		else
			copy(temp2,63,"permanently")
		client_print(0,print_chat,"%s ban %s %s",temp,name2,temp2)
	}	
	
	console_print(id,"Client ^"%s^" banned",name2)
	return PLUGIN_HANDLED
}

public admin_slay(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,31)
	new player = cmd_target(id,arg,5)
	if (!player) return PLUGIN_HANDLED
	user_kill(player)
	new authid[16],name2[32],authid2[16],name[32]
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	get_user_authid(player,authid2,15)
	get_user_name(player,name2,31)
	log_to_file(logfilename,"Cmd: ^"%s<%d><%s><>^" slay ^"%s<%d><%s><>^"",
		name,get_user_userid(id),authid, name2,get_user_userid(player),authid2 )
		
	switch(get_cvar_num("amx_show_activity"))	{
	case 2:	client_print(0,print_chat,"ADMIN %s: slay %s",name,name2)
	case 1:	client_print(0,print_chat,"ADMIN: slay %s",name2)
	}		
		
	console_print(id,"Client ^"%s^" slayed",name2)
	return PLUGIN_HANDLED
}

public admin_slap(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,31)
	new player = cmd_target(id,arg,5)
	if (!player) return PLUGIN_HANDLED
	new power2[32],authid[16],name2[32],authid2[16],name[32]
	read_argv(2,power2,31)
	new damage = strtonum(power2)
	user_slap(player,damage)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	get_user_authid(player,authid2,15)
	get_user_name(player,name2,31)
	log_to_file(logfilename,"Cmd: ^"%s<%d><%s><>^" slap with %d damage ^"%s<%d><%s><>^"",
		name,get_user_userid(id),authid, damage,name2,get_user_userid(player),authid2 )
		
	switch(get_cvar_num("amx_show_activity"))	{
	case 2:	client_print(0,print_chat,"ADMIN %s: slap %s with %d damage",name,name2,damage)
	case 1:	client_print(0,print_chat,"ADMIN: slap %s with %d damage",name2,damage)
	}				
			
	console_print(id,"Client ^"%s^" slaped with %d damage",name2,damage)	
	return PLUGIN_HANDLED
}

public delayed_map(mapname[])
	server_cmd("changelevel %s",mapname)

public admin_map(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	new len = read_argv(1,arg,31)
	if (is_map_valid(arg)==0){
		console_print(id,"Map with that name not found or map is invalid")
		return PLUGIN_HANDLED
	}
	console_print(id,"Changing map")
	if (read_argc() > 2){
		message_begin(MSG_ALL, SVC_INTERMISSION)
		message_end()
		new arg2[32]
		read_argv(2,arg2,31)
		new Float:ftime = floatstr(arg2)
		if (ftime < 0.0) ftime = 0.0
		set_task( ftime + 0.5 ,"delayed_map",0,arg,len + 1)
	}
	else {
		set_task(0.5,"delayed_map",0,arg,len + 1)
	}
	new authid[16],name[32]
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	
	switch(get_cvar_num("amx_show_activity"))	{
		case 2:	client_print(0,print_chat,"ADMIN %s: changelevel %s",name,arg)
		case 1:	client_print(0,print_chat,"ADMIN: changelevel %s",arg)
	}
	
	log_to_file(logfilename,"Cmd: ^"%s<%d><%s><>^" changelevel ^"%s^"",
		name,get_user_userid(id),authid, arg)
	return PLUGIN_HANDLED
}

#define CVARRCONSET 8
new cvar_rcon[CVARRCONSET][] = { 
"rcon_password",
"amx_show_activity",
"amx_mode",
"amx_password_field",
"amx_default_access",
"amx_reserved_slots",
"amx_reservation",
"amx_conmotd_file"
}

bool:cvars_only_with_rcon(arg[]) {
	for(new a=0; a<CVARRCONSET;++a)
		if ( equal(arg,cvar_rcon[a]) )
			return true
	return false
}

public admin_cvar(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32], arg2[64]
	read_argv(1,arg,31)
	read_argv(2,arg2,63)
	if (!cvar_exists(arg)){
		console_print(id,"Unknown cvar")
		return PLUGIN_HANDLED	
	}
	if ( cvars_only_with_rcon(arg) && !(get_user_flags(id) & ADMIN_RCON)){
		console_print(id,"You have no access to that cvar")
		return PLUGIN_HANDLED
	}
	else if (equal(arg,"sv_password") && !(get_user_flags(id) & ADMIN_PASSWORD)){
		console_print(id,"You have no access to that cvar")
		return PLUGIN_HANDLED
	}
	if (read_argc() < 3){
		get_cvar_string(arg,arg2,63)
		console_print(id,"Cvar ^"%s^" is ^"%s^"",arg,arg2)
		return PLUGIN_HANDLED
	}
	new authid[16],name[32]
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	log_to_file(logfilename,"Cmd: ^"%s<%d><%s><>^" set cvar (name ^"%s^") (value ^"%s^")",
		name,get_user_userid(id),authid, arg,arg2)
	set_cvar_string(arg,arg2)
	
	new activity = get_cvar_num("amx_show_activity")
	if (activity)	{
		new temp[64]
		if (activity == 1)
			copy(temp,63,"ADMIN:")
		else
			format(temp,63,"ADMIN %s:",name)
		client_print(0,print_chat,"%s set cvar %s to ^"%s^"",temp,arg,equal(arg,"rcon_password") ? "*** PROTECTED ***" : arg2)
	}	
	
	console_print(id,"Cvar ^"%s^" changed to ^"%s^"",arg,arg2)
	return PLUGIN_HANDLED
}

public admin_cfg(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[128]
	read_argv(1,arg,127)
	if (!file_exists(arg)){
		console_print(id,"File ^"%s^" not found",arg)
		return PLUGIN_HANDLED	
	}
	new authid[16],name[32]
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	log_to_file(logfilename,"Cmd: ^"%s<%d><%s><>^" execute cfg (file ^"%s^")",
		name,get_user_userid(id),authid, arg)
	console_print(id,"Executing file ^"%s^"",arg)
	server_cmd("exec %s",arg)
	
	switch(get_cvar_num("amx_show_activity"))	{
			case 2:	client_print(0,print_chat,"ADMIN %s: execute config %s",name,arg)
			case 1:	client_print(0,print_chat,"ADMIN: execute config %s",arg)
	}
	
	return PLUGIN_HANDLED
}

new pausecon
new Float:fpausable
new bool:bpaused 

public pause_success(){ 
    set_cvar_float("pausable",fpausable)
    console_print(pausecon,"Server %s", bpaused ? "unpaused" : "paused") 
    bpaused = !bpaused
    return PLUGIN_HANDLED
}

public admin_pause(id,level,cid){ 
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED 
	new authid[16],name[32],slayer = id
	get_user_authid(id,authid,15) 
	get_user_name(id,name,31) 
	fpausable = get_cvar_float("pausable")
	if (!slayer) slayer = find_player("h") 
	if (!slayer){ 
		console_print(id,"Server was unable to pause the game. Real players on server are needed") 
		return PLUGIN_HANDLED  
	}
	set_cvar_float("pausable",1.0) 
	client_cmd(slayer,"pause;pause_loopback")
	log_to_file(logfilename,"Cmd: ^"%s<%d><%s><>^" %s server", 
		name,get_user_userid(id),authid, bpaused ? "unpause" : "pause" )
	console_print(id,"Server proceed %s", bpaused ? "unpausing" : "pausing")
	
	switch(get_cvar_num("amx_show_activity"))	{
		case 2:	client_print(0,print_chat,"ADMIN %s: %s server",name,bpaused ? "unpause" : "pause")
		case 1:	client_print(0,print_chat,"ADMIN: %s server",bpaused ? "unpause" : "pause")
	}
	
	pausecon = id
	return PLUGIN_HANDLED
} 

public admin_rcon(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[128],authid[16],name[32]
	read_args(arg,127)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	log_to_file(logfilename,"Cmd: ^"%s<%d><%s><>^" server console (cmdline ^"%s^")",
		name,get_user_userid(id),authid, arg)
	console_print(id,"Commmand line ^"%s^" sent to server console",arg)
	server_cmd(arg)
	return PLUGIN_HANDLED
}

public admin_who(id,level,cid){
	new players[32], inum, authid[16],name[32], flags, sflags[32]
	get_players(players,inum)
	console_print(id,"^nClients on server:^n #  %-32.31s %-12s %-8s %-4.3s %-4.3s %s",
		"nick","authid","userid","imm","res","access")
	for(new a = 0; a < inum; ++a)	{
			get_user_authid(players[a],authid,15)
			get_user_name(players[a],name,31)
			flags = get_user_flags(players[a])
			get_flags(flags,sflags,31)
			console_print(id,"%2d  %-32.31s %-12s %-8d %-4.3s %-4.3s %s",	players[a],name,authid,
			get_user_userid(players[a]),(flags&ADMIN_IMMUNITY)?"yes":"no",
			(flags&ADMIN_RESERVATION)?"yes":"no",sflags)
	}
	console_print(id,"Total %d",inum)
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	log_to_file(logfilename,"Cmd: ^"%s<%d><%s><>^" ask for players list",name,get_user_userid(id),authid)	
	return PLUGIN_HANDLED
}

has_tag(name[],ltags[4][32],ltagsnum){
	for(new a=0;a<ltagsnum;++a)
		if (contain(name,ltags[a])!=-1)
			return a
	return -1
}

public admin_leave(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new argnum = read_argc()
	new ltags[4][32]
	new ltagsnum = 0
	for(new a=1;a<5;++a){
		if (a<argnum)
			read_argv(a,ltags[ltagsnum++],31)
		else
			ltags[ltagsnum++][0] = 0
	}
	new nick[32], ires, pnum = get_maxplayers() + 1, count = 0
	for(new b=1;b<pnum;++b){
		if (!is_user_connected(b)&&!is_user_connecting(b)) continue
		get_user_name(b,nick,31)
		ires = has_tag(nick,ltags,ltagsnum)
		if (ires!=-1){
			console_print(id,"Skipping ^"%s^" because client match with ^"%s^"",nick,ltags[ires])
			continue
		}
		if (get_user_flags(b)&ADMIN_IMMUNITY){
			console_print(id,"Skipping ^"%s^" because client has immunity",nick)			
			continue
		}
		console_print(id,"Kicking ^"%s^"",nick)
		if (is_user_bot(b))
			server_cmd("kick #%d",get_user_userid(b))
		else
			client_cmd(b,"echo * You have been dropped because admin has left only specified group of clients;disconnect")
		count++
	}
	console_print(id,"Kicked %d clients",count)
	new authid[16],name[32]
	get_user_authid(id,authid,15)
	get_user_name(id,name,31)
	log_to_file(logfilename,"Kick: ^"%s<%d><%s><>^" leave some group (tag1 ^"%s^") (tag2 ^"%s^") (tag3 ^"%s^") (tag4 ^"%s^")",
		name,get_user_userid(id),authid,ltags[0],ltags[1],ltags[2],ltags[3] )
		
	switch(get_cvar_num("amx_show_activity"))	{
		case 2:	client_print(0,print_chat,"ADMIN %s: leave %s %s %s %s",name,ltags[0],ltags[1],ltags[2],ltags[3])
		case 1:	client_print(0,print_chat,"ADMIN: leave %s %s %s %s",ltags[0],ltags[1],ltags[2],ltags[3])
	}	
		
	return PLUGIN_HANDLED
}

new bool:cstrike_running

new answer[128] 
new option_name[4][32] 
new option[4] 
new valid_maps = 0 
new Float:vote_ratio 
new yesnovote
new bool:executeresult

public delay_action(cmd[]) 
	server_cmd(cmd)

public check_votes() { 
	new players[32], inum, best = 0
	get_players(players,inum,"c")
	for(new a = 0; a < 4; ++a)
		if (option[a] > option[best])
			best = a
	new Float:result_v = inum ? (float(option[best]) / float(inum)) : 0.0
	if (result_v<vote_ratio){
		if (yesnovote)
			client_print(0,print_chat,"* Voting failed (yes ^"%d^") (no ^"%d^") (needed ^"%.2f^")",
				option[0], inum-option[0] ,vote_ratio)
		else
			client_print(0,print_chat,"* Voting failed (ratio ^"%.2f^") (needed ^"%.2f^")",
				result_v,	vote_ratio)
		log_to_file(logfilename,"Vote: Voting failed (ratio ^"%.2f^") (needed ^"%.2f^")",
				result_v, vote_ratio)   
		return PLUGIN_HANDLED
	}
	new execute[256]
	new len = format(execute,255,answer,option_name[best])
	if (executeresult){
		executeresult = false
		set_task(2.0,"delay_action",0,execute,len + 1)
	}
	client_print(0,print_chat,"* Voting successful (ratio ^"%.2f^") (needed ^"%.2f^"). The result: %s",
		result_v,vote_ratio,execute) 
	log_to_file(logfilename,"Vote: Voting successful (ratio ^"%.2f^") (needed ^"%.2f^") (result ^"%s^")", 
		result_v,vote_ratio,execute)
	return PLUGIN_HANDLED
} 

public vote_count(id,key){ 
	if (get_cvar_float("amx_vote_answers")) { 
		new name[32] 
		get_user_name(id,name,31)
		if (yesnovote)
			client_print(0,print_chat,"* %s voted %s",name,key ? "against" : "for" )
		else
			client_print(0,print_chat,"* %s voted for option #%d",name,key+1)
	} 
	if (yesnovote){
		if (!key) ++option[key]
	}
	else
		++option[key]
	return PLUGIN_HANDLED 
} 

public admin_votemap(id,level,cid) { 
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new Float:voting = get_cvar_float("amx_last_voting")
	if (voting > get_gametime()){ 
		console_print(id,"There is already one voting...") 
		return PLUGIN_HANDLED 
	} 
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		console_print(id,"Voting not allowed at this time") 
		return PLUGIN_HANDLED 
	} 
	new argc = read_argc() 
	if (argc > 5) 
		argc = 5
	valid_maps = 0
	option_name[0][0] = option_name[1][0] = option_name[2][0] = option_name[3][0] = 0
	for(new i = 1; i < argc; ++i){ 
		read_argv(i,option_name[valid_maps],31) 
		if (is_map_valid(option_name[valid_maps])) 
			valid_maps++; 
	} 
	if (valid_maps == 0) { 
		console_print(id,"Given %s not valid",(argc==2)?"map is":"maps are") 
		return PLUGIN_HANDLED 
	} 
	new menu_msg[256] 
	new keys = 0 	
	if (valid_maps > 1){
		keys = (1<<9)
		if(cstrike_running) 
			copy(menu_msg,255,"\yAMX Choose map \w^n^n") 
		else 
			copy(menu_msg,255,"AMX Choose map ^n^n")
		new temp[128] 
		for(new a = 0; a < valid_maps; ++a){ 
			format(temp,127,"%d.  %s^n",a+1,option_name[a]) 
			add(menu_msg,255,temp) 
			keys |= (1<<a) 
		} 
		add(menu_msg,255,"^n0.  None")
		yesnovote = 0	
	}
	else{ 
		if(cstrike_running) 
			format(menu_msg,255,"\yAMX Change map to %s?\w^n^n1.  Yes^n2.  No",option_name[0]) 
		else 
			format(menu_msg,255,"AMX Change map to %s?^n^n1.  Yes^n2.  No",option_name[0])
		keys = (1<<0)|(1<<1)
		yesnovote = 1
	}
	new authid[16],name[32] 
	get_user_authid(id,authid,15) 
	get_user_name(id,name,31)
	if (argc==2)
		log_to_file(logfilename,"Vote: ^"%s<%d><%s><>^" vote map (map ^"%s^")",
			name,get_user_userid(id),authid,option_name[0])
	else
		log_to_file(logfilename,"Vote: ^"%s<%d><%s><>^" vote maps (map#1 ^"%s^") (map#2 ^"%s^") (map#3 ^"%s^") (map#4 ^"%s^")",
			name,get_user_userid(id),authid,option_name[0],option_name[1],option_name[2],option_name[3])
			
	switch(get_cvar_num("amx_show_activity"))	{
	case 2:	client_print(0,print_chat,"%s %s: vote map(s)",name,
			(get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN")
	case 1:	client_print(0,print_chat,"%s: vote map(s)",
			(get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN")
	}
			
	executeresult = true
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time )
	vote_ratio = get_cvar_float("amx_votemap_ratio") 
	copy(answer,127,"changelevel %s") 
	show_menu(0,keys,menu_msg,floatround(vote_time)) 
	set_task(vote_time,"check_votes") 
	console_print(id,"Voting has started...") 
	for(new j=0;j<4;++j)option[j]=0
	return PLUGIN_HANDLED 
} 

public admin_vote(id,level,cid) { 
	if (!cmd_access(id,level,cid,4))
		return PLUGIN_HANDLED
	new Float:voting = get_cvar_float("amx_last_voting")
	if (voting > get_gametime()){ 
		console_print(id,"There is already one voting...") 
		return PLUGIN_HANDLED 
	} 
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		console_print(id,"Voting not allowed at this time") 
		return PLUGIN_HANDLED 
	}
	new quest[48] 
	read_argv(1,quest,47) 
	if ((contain(quest,"sv_password")!=-1)||(contain(quest,"rcon_password")!=-1)||
		(contain(quest,"kick")!=-1)||(contain(quest,"addip")!=-1)||(contain(quest,"ban")!=-1)){ 
		console_print(id,"Voting for that has been forbidden")
		return PLUGIN_HANDLED
	} 
	read_argv(2,option_name[0],31) 
	read_argv(3,option_name[1],31) 

	new authid[16],name[32] 
	get_user_authid(id,authid,15) 
	get_user_name(id,name,31) 
	log_to_file(logfilename,"Vote: ^"%s<%d><%s><>^" vote custom (question ^"%s^") (option#1 ^"%s^") (option#2 ^"%s^")", 
		name,get_user_userid(id),authid,quest,option_name[0],option_name[1]) 

	switch(get_cvar_num("amx_show_activity"))	{
	case 2:	client_print(0,print_chat,"%s %s: vote custom",
		(get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN",name )
	case 1:	client_print(0,print_chat,"%s: vote custom",
		(get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN")
	}

	new menu_msg[256] 
	new keys = (1<<0)|(1<<1) 
	if(cstrike_running) 
		format(menu_msg,255,"\yAMX Vote: %s?\w^n^n1.  %s^n2.  %s",quest,option_name[0],option_name[1]) 
	else 
		format(menu_msg,255,"AMX Vote: %s?^n^n1.  %s^n2.  %s",quest,option_name[0],option_name[1])
	
	executeresult = false
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time )
	vote_ratio = get_cvar_float("amx_vote_ratio") 
	format(answer,127,"%s %%s",quest)
	show_menu(0,keys,menu_msg,floatround(vote_time)) 
	set_task(vote_time,"check_votes") 
	console_print(id,"Voting has started...") 
	for(new j=0;j<4;++j)option[j]=0
	yesnovote = 0	
	return PLUGIN_HANDLED 
} 

public admin_votekickban(id,level,cid) { 
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new Float:voting = get_cvar_float("amx_last_voting")
	if (voting > get_gametime()){ 
		console_print(id,"There is already one voting...") 
		return PLUGIN_HANDLED 
	} 
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		console_print(id,"Voting not allowed at this time") 
		return PLUGIN_HANDLED 
	} 
	new cmd[32] 
	read_argv(0,cmd,31)
	new voteban = equal(cmd,"amx_voteban") ? 1 : 0 
	new arg[32] 
	read_argv(1,arg,31)
	new player = cmd_target(id,arg,1)
	if (!player) return PLUGIN_HANDLED
	if (voteban && is_user_bot(player))   { 
		new imname[32]
		get_user_name(player,imname,31)
		console_print(id,"That action can't be performed on bot ^"%s^"",imname)
		return PLUGIN_HANDLED
	}

	new keys = (1<<0)|(1<<1)
	new menu_msg[256]
	get_user_name(player,arg,31) 
	if(cstrike_running)
		format(menu_msg,255,"\yAMX %s %s?\w^n^n1.  Yes^n2.  No", voteban ? "Ban" : "Kick", arg)
	else
		format(menu_msg,255,"AMX %s %s?^n^n1.  Yes^n2.  No", voteban ? "Ban" : "Kick", arg)
	yesnovote = 1		
	if (voteban) 
		get_user_authid(player,option_name[0],31) 
	else 
		num_to_str(get_user_userid(player),option_name[0],31) 
	new authid[16],name[32]
	get_user_authid(id,authid,15) 
	get_user_name(id,name,31) 
	log_to_file(logfilename,"Vote: ^"%s<%d><%s><>^" vote %s (target ^"%s^")", 
		name,get_user_userid(id),authid,voteban ? "ban" : "kick",arg)
	
	switch(get_cvar_num("amx_show_activity"))	{
	case 2:	client_print(0,print_chat,"%s %s: vote %s for %s",
		(get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN",name,voteban ? "ban" : "kick",arg )
	case 1:	client_print(0,print_chat,"%s: vote %s for %s",
		(get_user_flags(id) & ADMIN_USER) ? "PLAYER" : "ADMIN",voteban ? "ban" : "kick",arg)
	}
	
	executeresult = true
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting",  get_gametime() + vote_time )
	vote_ratio = get_cvar_float(voteban ? "amx_voteban_ratio" : "amx_votekick_ratio") 
	copy(answer,127, voteban ? "banid 30.0 %s kick" : "kick #%s") 
	show_menu(0,keys,menu_msg,floatround(vote_time)) 
	set_task(vote_time,"check_votes") 
	console_print(id,"Voting has started...") 
	for(new j=0;j<4;++j)option[j]=0
	return PLUGIN_HANDLED 
} 

public plugin_init(){
	register_plugin("AdminMod Conversion","0.90 ALPHA","Calzinger")
	register_concmd("admin_kick","admin_kick",ADMIN_KICK,"<authid, nick or #userid> [reason]")
	register_concmd("admin_ban","admin_ban",ADMIN_BAN,"<minutes> <authid, nick or #userid> [reason]")
	register_concmd("admin_unban","admin_unban",ADMIN_BAN,"<authid or ip>")
	register_concmd("admin_slay","admin_slay",ADMIN_SLAY,"<authid, nick or #userid>")
	register_concmd("admin_slap","admin_slap",ADMIN_SLAY,"<authid, nick or #userid> [power]")
	register_concmd("admin_leave","admin_leave",ADMIN_KICK,"<tag> [tag] [tag] [tag]")
	register_concmd("admin_who","admin_who",0,"- displays who is on server")
	register_concmd("admin_say","admin_say",ADMIN_CHAT,"<message>")
	register_concmd("admin_chat","admin_chat",ADMIN_CHAT,"<message>")
	register_concmd("admin_psay","admin_psay",ADMIN_CHAT,"<authid, nick or #userid> <message>")
	register_concmd("admin_tsay","admin_tsay",ADMIN_CHAT,"<color> <message>")
	register_concmd("admin_votemap","admin_votemap",ADMIN_VOTE,"<map> [map] [map] [map]")
	register_concmd("admin_votekick","admin_votekickban",ADMIN_VOTE,"<authid, nick or #userid>")
	register_concmd("admin_voteban","admin_votekickban",ADMIN_VOTE,"<authid, nick or #userid>")
	register_concmd("admin_vote","admin_vote",ADMIN_VOTE,"<question> <answer#1> <answer#2>")
	register_concmd("admin_pause","admin_pause",ADMIN_CVAR,"- pause or unpause the game")
	register_clcmd("admin_map","admin_map",ADMIN_MAP,"<mapname> [delay in sec.]")
	register_clcmd("admin_cvar","admin_cvar",ADMIN_CVAR,"<cvar> <value>")
	register_clcmd("admin_cfg","admin_cfg",ADMIN_CFG,"<fliename>")
	register_clcmd("aadmin_rcon","admin_rcon",ADMIN_RCON,"<command line>")
	get_time("addons/amx/logs/admin%m%d.log",logfilename,255)
	return PLUGIN_CONTINUE
}
