/***********************************************************************
 * amx_ejl_cmdlistgenerator.sma     version 1.0      July 19/2003
 *  By:  Eric Lidman	Alias: Ludwig van      ejlmozart@hotmail.com
 *  Upgrade: http://lidmanmusic.com/cs/plugins.html  
 *
 *  This is basically amx_help with a twist. Use amx_help in game, 
 *   but use this plugin to create command lists for your admins in an
 *   html page format. I wrote this plugin because my admins are always
 *   asking me to send them a command list by email. But since my server 
 *   constantly changes as I write and add/subtract stuff, its hard to 
 *   keep a list up to date. Now I can with ease and I can taylor the
 *   list to the admin's access level. An html file is created in your
 *   amx folder when you execute this command with all the commands that
 *   are currently on your server.
 *
 * Commands:
 *
 *   amx_writehelp <flags>  --Writes a list of all the commands that an
 *                            admin with the flags you enter has access to.
 *                            If no flags are given, all flags are used.
 *
 *************************************************************************/

#include <amxmod>
#include <amxmisc>

public admin_writehelp(id,level,cid){
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED
	new arg1[32],oldcmd[32],filename[128],sflags[32],info[128],cmd[32],conclist[256],heading[192]
	new flags,eflags
	read_argv(1,arg1,31)
	if(!arg1[0])
		flags = read_flags("abcdefghijklmnopqrstuvwxyz")
	else
		flags = read_flags(arg1)
	new clcmdsnum = get_concmdsnum(flags,id)
	get_flags(flags,sflags,31)
	format(filename,127,"addons/amx/AMX_Command_List_for_access_%s.html",sflags)
	format(heading,191,"<div align=^"center^" style=^"font-size:20pt^" style=^"color:white^"><font face=^"Arial^">\
	AMX COMMAND LIST FOR FLAGS: %s</div><br>",sflags) 
	if(file_exists(filename))
		delete_file(filename)
	console_print(id,"[AMX] Creating html help file in amx folder.")
	write_file(filename,"<html><head><title>AMX Command List</title></head><body bgcolor=^"Green^">",-1)	
	write_file(filename,heading,-1)
	write_file(filename,"<table width=^"100%^" border=^"1^" bgcolor=^"Silver^" bordercolordark=^"Black^" \
	bordercolorlight=^"Black^" cellpadding=^"1^">",-1)	
	write_file(filename,"<tr><td>Command</td><td>Usage / description</td><td>Access flag required</td></tr><br>",-1) 
	for (new i = 0; i < clcmdsnum; i++){
		get_concmd(i,cmd,31,eflags,info,127,flags,id)
		if(id == 0)
			console_print(id,"[AMX] Creating html help file. Progress: %d / %d",i+1,clcmdsnum)
		get_flags(eflags,sflags,31)
		for(new rp = 0;rp<strlen(info) / 3;rp++){
			replace(info,127,"<","[")
			replace(info,127,">","]")
		}
		format(conclist,255,"<div style=^"font-size:12pt^" style=^"color:white^"><font face=^"Arial^"><tr><td>%s</td>\
		<td>%s</td><td><div align=^"center^">%s</div></td></tr></div>",cmd,info,sflags) 
		if(!equal(oldcmd,cmd))
			write_file(filename,conclist,-1)
		copy(oldcmd,31,cmd)
	}
	write_file(filename,"</table></body></html>",-1)
	console_print(id,"[AMX] Done.")	
	return PLUGIN_HANDLED 
}

public plugin_init() {
	register_plugin("Write help to html file","0.1","EJL") 
	register_concmd("amx_writehelp","admin_writehelp",ADMIN_RCON,"<flags> prints help for commands with this access level")
	return PLUGIN_CONTINUE
}
