/***************************************************************************
 * amx_ejl_podbotenhance.sma     version 1.4.1              Date: 8/16/2003
 *  Author: Eric Lidman      ejlmozart@hotmail.com
 *  Alias: Ludwig van        Upgrade: http://lidmanmusic.com/cs/plugins.html
 *
 *  This plugin acts as a central controller for podbots and allows them to
 *   issue chat which can be reacted to by other amx plugins, it allows you 
 *   to make podbots say things on the fly as well. All bot chat is filtered
 *   through this plugin and set out to the other plugins such as ones that
 *   trigger sound clips through chat, say kamikazi to become a timebomb, 
 *   roll the dice and gamble like a real player, use the "Beam me up scotty"
 *   player teleport system, and more. Besides chat, the plugin allows bots
 *   to use a large number of my amx plugins including special weapons like
 *   my laser weapon, flamethrower, and CS missiles. Also this plugin
 *   enhances podbots jetpack usage. Basically it allows bots to act more 
 *   like real players on a crazy fun server using the mods etc. Its the 
 *   only way to play if you have no friends.
 *
 *  The latest versions of my plugins are required, ones that have been
 *   updated to interface with podbots have been included in a zip file 
 *   attached to the forum post for this plugin. This should provide you with
 *   a basis for making more plugins bot accessible so that they can issue
 *   other client commands or even admin commands.
 *
 *  REQUIREMENT: vexd_utilities module 0.2.0.5, get from amx modules forum
 *  REQUIREMENT: xtrafun module 1.2 from amx modules forum
 *
 *  For 1.4.0 new jetpack enhancements to work, you need my jetpack 2.8
 *
 *  Current list of my plugins this plugin allows bots to use:
 *
 *      CS Missiles
 *      Laser weapon for any mod
 *      Flamethrower weapon for any mod
 *      Beam me up scotty (teleport)
 *      Kamikazi
 *      Ludwig vans roll the dice
 *      Playsounds
 *      Smokin-N-Drinkin
 *      Jetpack Model No.Lud1337
 *      BATGIRL's automatic crazy votes
 *      Hurry up and die
 *      Lud's modified adminvote plugin
 *      Matrix jumping 
 *
 *  ADMIN COMMAND:
 *  
 *   amx_botsay <player> <message> : make bots say stuff.
 *
 *  CVARS:
 *
 *   amx_autoscotty_bots 1           --makes bots inclined to use scotty
 *                                     teleport system
 *   amx_automissile_bots 1          --makes bots use missiles
 *   amx_automissile_bots_freq 2.0   --make number higher to make bots 
 *                                     missile launch freqency less
 *   amx_automissile_bots_d 7.0      --delay after round start bots start
 *                                     using missiles
 *   amx_autolaser_bots 1            --makes bots use lasers
 *   amx_autolaser_bots_freq 0.3     --make number higher to make bots 
 *                                     laser firing freqency less
 *   amx_autolaser_bots_d 5.0        --delay after round start bot laser use
 *   amx_autolivechat_bots 1         --makes bots chat more while live
 *                                     (geared for roll the dice, kamikaze,
 *                                     and drunkmode)
 *   amx_autolivechat_bots_freq 30.0 --make number higher to make bots live
 *                                     chat freqency less
 *   amx_autolivechat_bots_d 2.0     --delay after round start bots live chat
 *   amx_autoflame_bots 1            --makes bots use flamethrower
 *   amx_autoflame_bots_freq 1.0     --make number higher to make flamethrower
 *                                     use less likely
 *   amx_enhancejetpack_bots 1       --give bits a little extra push in x and
 *                                     y directions so they can move around
 *                                     much easier on thier jetpacks.
 *   amx_autovotegravity_bots 1      --if server gravity is set above 200, 
 *                                     bots will complain or try to start a 
 *                                     graviy vote by saying vote_gravity
 *                                     set to 0 to disable this feature
 *   amx_autovotescotty_bots 0       --if server scotty teleport mode is less, 
 *                                     than "crazy", bots will complain or try
 *                                     to start a scotty teleport mode vote by
 *                                     saying vote_scotty set to 1 to enable 
 *                                     this feature
 *   amx_allowbotvotes 1             --cvar to control wheather bots can vote
 *                                     or not and also controls whether they
 *                                     are even taken into consideration for
 *                                     the playercount in votes that require
 *                                     a majority of vote eligable players. 
 *                                     Set to 0 to totally leave bots out of
 *                                     the voting process. Requires all my 
 *                                     latest plugins which involve votes.
 *   amx_usebotchat 1                --uses plugin's own independent botchat
 *                                     system. Allows bots to react to certain
 *                                     game events, players voting them into
 *                                     timebombs and even admins abusing them.
 *                                     This is beginning to and will include 
 *                                     more bot chat AI. 0 to turn off.
 *
 *
 *  CONFIGS:                           bot_chats.txt  ... goes in amx folder
 *
 *   You can set up a special bot chat file to use instewad of or in addition 
 *   to the chat system that comes with your bots. This just offers more/diff 
 *   possiblilies and will be developed further. All these are limited to 
 *   certain ammounts of chat to save memory, but can be modified easily in
 *   the defines below in the source file to include more options. (%s = name)
 *   Explanation of heading tags in bot_chats.txt: 
 *
 *   [NOT-UNDERSTAND] -- (Limit 20) when a bot cant figure out what you mean
 *   [GRUDGEBOT]      -- (limit 20) what a bot says the next time he spawns
 *                       to a player that killed him
 *   [VICTIMBOT]      -- (limit 20) what a bot says when he is killed, usually
 *                       there is a little delay to take realistic typing
 *                       time, put ! in front of word for no delay
 *   [ATTACKERBOT]    -- (limit 20) what a bot says after killing a player
 *   [HELLO-RESPOND]  -- (limit 20) if you say hi and a bot's name, the bot 
 *                       responds by saying hi to you
 *   [NAME-RESPOND1]  -- (limit 20) if you say bot's name alone, bot responds
 *   [BOMB-REVENGE]   -- (limit 20) if you do amx_votetimebomb on a bot, the 
 *                       bot will express its resentment of that and then pro-
 *                       ceed to start a vote to timebomb you.
 *   [ADMIN-ABUSE]    -- (limit 20) if you do amx_slay, amx_slay2, amx_timebomb 
 *                       amx_zap, amx_slap, or amx_grav on a bot, the bot may
 *                       become upset, express its grief, and if it really 
 *                       gets mad, it will try to start a vote to timebomb you.
 *                       Responses are usually delayed to simulate typing time
 *                       and given when he knows admin can hear them (both 
 *                       same alive dead status). Responses that are immediate
 *                       should be preceeded by a ! (NOTE: In order for this 
 *                       feature to work, this plugin must be placed before
 *                       the admin commnand plugins in the plugins.ini)             
 *
 ****************************************************************************/

#define use_vexd 1

#include <amxmod>
#include <amxmisc>
#if use_vexd == 1
#include <Vexd_Utilities>
#endif

stock get_user_velocity(id, velocity[3]) {
  new Float:vel[3]
  entity_get_vector(id, EV_VEC_velocity, vel)
  FVecIVec(vel, velocity)
}

stock set_user_velocity(id, velocity[3]) {
  new Float:vel[3]
  IVecFVec(velocity, vel)
  entity_set_vector(id, EV_VEC_velocity, vel)
}

#define MAX_BS_LENGTH 36 // # of characters allowed in a line of bot_chats.txt
#define MAX_TYPE0 20     // [NOT-UNDERSTAND]
#define MAX_TYPE1 20     // [GRUDGEBOT]
#define MAX_TYPE2 20     // [VICTIMBOT]
#define MAX_TYPE3 20     // [ATTACKERBOT]
#define MAX_TYPE4 20     // [HELLO-RESPOND]
#define MAX_TYPE5 20     // [NAME-RESPOND1]
#define MAX_TYPE6 20     // [BOMB-REVENGE]
#define MAX_TYPE7 20     // [ADMIN-ABUSE]

#define ALIVE_BOT 1
#define DEAD_BOT 0
#define MAX_BHC 25

new gmsgSayText
new Float:g_botlastsay[33]
new g_botsaycount
new buffer[100]
new Float:LS[33]
new Float:LastBotScottyL[33]
//new scotty_lock[33][3]
new cmd_jetpackrun[33]
new old_location[33][3]
new bool:cstrike_running
new bool:dod_running
new dod_team[33]
new rst
new counter
new wantgravvote
new wantscottyvote
new botnames[20][24]
new botids[20]
new botnamecounter
new angrybot[33]
new bombvoterevenge[33]
new needswelcome[33]
new welcome1
new beenhere[MAX_BHC][16]
new beenherecounter
new isAbused[33]
new abuserevenge[33]
new talkingto[33][4] //[id][botid,countdown,

new TYPE0[MAX_TYPE0][MAX_BS_LENGTH]
new TYPE1[MAX_TYPE1][MAX_BS_LENGTH]
new TYPE2[MAX_TYPE2][MAX_BS_LENGTH]
new TYPE3[MAX_TYPE3][MAX_BS_LENGTH]
new TYPE4[MAX_TYPE4][MAX_BS_LENGTH]
new TYPE5[MAX_TYPE5][MAX_BS_LENGTH]
new TYPE6[MAX_TYPE6][MAX_BS_LENGTH]
new TYPE7[MAX_TYPE7][MAX_BS_LENGTH]
new type0index
new type1index
new type2index
new type3index
new type4index
new type5index
new type6index
new type7index

public admin_botsay(id,level,cid){
	if (!cmd_access(id,level,cid,2))
		return PLUGIN_HANDLED
	new arg[32]
	read_argv(1,arg,31)
	new player = cmd_target(id,arg,1)
	if (!player) return PLUGIN_HANDLED
	if(!is_user_bot(player)){
		console_print(id,"[AMX]  This action can only be performed on bots")
		return PLUGIN_HANDLED
	}
	new len = strlen(arg)
	new args[128]
	read_args(args,127)
	make_botsay(args,player,len)

	new name[32],authid[16]
	get_user_name(id,name,31)
	get_user_authid(id,authid,15)
	log_to_file("addons/amx/admin.log","^"%s<%d><%s><>^" BOTSAY ^"%s^"", name,get_user_userid(id),authid,args)

	return PLUGIN_HANDLED
}

make_botsay(args[],player,len){
	new saystuff[128]	
	format(saystuff,127,"%s",args[len+1])
	new text[128]
	new name[32]
	get_user_name(player,name,31)
	if(is_user_alive(player))
		format(text,127,"%c%s :    %s", 2, name,saystuff)
	else
		format(text,127,"%c*DEAD*%s :    %s", 2, name,saystuff)
	server_cmd("botsay %d %d %s",g_botsaycount,player,text)

	new taskargs[136]
	taskargs[0] = g_botsaycount
	taskargs[1] = player
	copy(taskargs[2],127,text)
	set_task(0.5,"do_botsay",0,taskargs,136)
	g_botsaycount +=1
	if(g_botsaycount > 99)
		g_botsaycount = 0
	buffer[g_botsaycount] = 0
}

public do_botsay(taskargs[]){
	new msid = taskargs[0]
	new player = taskargs[1]
	new text[128]
	copy(text,127,taskargs[2])
	if(buffer[msid] == 0){
		new players[32],inum
		if(is_user_alive(player))
			get_players(players,inum,"a")
		else
			get_players(players,inum,"b")
		for(new i=0;i<inum;i++){
			message_begin( MSG_ONE,gmsgSayText,{0,0,0},players[i])  
			write_byte( player )
			write_string( text )
			message_end()
		}
	}
	g_botlastsay[player] = get_gametime()
	return PLUGIN_CONTINUE
}

public handle_SayText(){
	new iarg1,sarg2[256]
	iarg1 = read_data(1)
	read_data(2,sarg2,255)
	if(get_gametime() > LS[iarg1] + 0.2){
		LS[iarg1] = get_gametime()
		if(is_user_bot(iarg1)){
			new OnlySay[192]
			new len = strlen(sarg2)
			new start = contain(sarg2,":    ")
			copy(OnlySay,len-11-start+5,sarg2[start+5])
			make_botsay(OnlySay,iarg1,-1)
			#if use_vexd == 1
			MessageBlock(gmsgSayText, BLOCK_ONCE)
			#endif
		}
	#if use_vexd == 1
	}else{
		if(get_gametime() < LS[iarg1] + 0.2){
			if(is_user_bot(iarg1))
				MessageBlock(gmsgSayText, BLOCK_ONCE)			
		}else{
			MessageBlock(gmsgSayText, BLOCK_NOT)
		}
	}
	#else
	}
	#endif
	return PLUGIN_CONTINUE
}

public handle_bsr(){
	new arg1[8],arg2[8]
	read_argv(1,arg1,7)
	read_argv(2,arg2,7)
	buffer[strtonum(arg1)] = strtonum(arg2)
	return PLUGIN_CONTINUE
}

public plugin_log(){
	new args = read_logargc()
	if(args == 2){
		new msg[32]
		read_logargv(1,msg,31)
		if(msg[6] == 'S')
			round_start()
	}
	else if(args == 3){
		new msg[32]
		read_logargv(1,msg,31)
		if(equal(msg,"joined t",8)){
			new clinfo[64],won[32],cutoff,bcount
			new classinfo[32]	
			read_logargv(0,clinfo,63)
			read_logargv(2,classinfo,31)
			new tcbackw = strlen(clinfo)
			new cbackw = tcbackw
			for(new i=0;i<tcbackw;i++){
				cbackw -= 1
				if(cbackw > 0){
					if(clinfo[cbackw] == '<'){
						bcount +=1
						if(bcount == 3){
							copy(won,i-cutoff,clinfo[cbackw+1]) 
						}
						else if(bcount == 2)
							cutoff = i + 2						
					}
				}
			}
			new iwon = strtonum(won)
			new playerl = find_player("k",iwon)
			if(!playerl) return PLUGIN_CONTINUE
			if(equali(classinfo,"Axis"))
				dod_team[playerl] = 1
			else
				dod_team[playerl] = 2
		}	
	} 		
	return PLUGIN_CONTINUE
}

round_start(){
	if(get_cvar_num("amx_autoscotty_bots")){
		remove_task(34020)
		remove_task(34021)
		set_task(2.0,"rs_scotty_e",34020)
		set_task(20.0,"rs_scotty_l",34021)
	}
	if(get_cvar_num("amx_automissile_bots")){
		remove_task(34022)
		set_task(get_cvar_float("amx_automissile_bots_d") + get_cvar_float("mp_freezetime"),"rs_missile",34023)
	}
	if(get_cvar_num("amx_autolaser_bots")){
		remove_task(34024)
		set_task(get_cvar_float("amx_autolaser_bots_d") + get_cvar_float("mp_freezetime"),"rs_laser",34025)
	}
	if(get_cvar_num("amx_autoflame_bots")){
		remove_task(34028)
		set_task(get_cvar_float("amx_autoflame_bots_freq"),"chk_flame",34028)
	}
	if(get_cvar_num("amx_autolivechat_bots")){
		remove_task(34026)
		set_task(get_cvar_float("amx_autolivechat_bots_d") + get_cvar_float("mp_freezetime"),"rs_livechat",34027)
	}
	if( (get_cvar_num("sv_gravity") > 200) && (get_cvar_num("amx_autovotegravity_bots")) )
		wantgravvote = 1
	new mode[16]
	get_cvar_string("amx_startrek_teleportmode",mode,15)
	if( (!((equal(mode,"crazy")) || (equal(mode,"insane"))) ) && (get_cvar_num("amx_autovotescotty_bots")) )
		wantscottyvote = 1
}

public round_end(){
	if(get_cvar_num("amx_autoscotty_bots")){
		remove_task(34020)
		remove_task(34021)
	}
	if(get_cvar_num("amx_automissile_bots")){
		remove_task(34022)
		remove_task(34023)
	}
	if(get_cvar_num("amx_autolaser_bots")){
		remove_task(34024)
		remove_task(34025)
	}
	if(get_cvar_num("amx_autoflame_bots")){
		remove_task(34028)
	}
	if(get_cvar_num("amx_autolivechat_bots")){
		remove_task(34026)
		remove_task(34027)
	}
}

public rs_scotty_e(){
	if(!get_cvar_num("amx_autoscotty_bots"))
		return PLUGIN_CONTINUE
	new players[32],inum
	new maxpl = get_maxplayers()
	for(new a = 1; a < maxpl; a++) {
		if(is_user_connected(a)){
			if(is_user_bot(a)){
				if(is_user_alive(a)){
					players[inum] = a
					inum++
				}
			}
		}
	}
	new team_alive
	new guy = random_num(0,inum)
	new guy2 = random_num(0,inum)
	if(dod_running){
		if( (guy != guy2) && (dod_team[players[guy2]] == dod_team[players[guy]]) )
			team_alive = 1
	}else{
		if( (guy != guy2) && (get_user_team(players[guy2]) == get_user_team(players[guy])) )
			team_alive = 1
	}
	new to_person[64],bname[32]
	get_user_name(players[guy2],bname,31)
	format(to_person,63,"scotty beam me to %s",bname)
	new args[128],rd
	if(team_alive)
		rd = random_num(0,8)
	else
		rd = random_num(0,6)
	switch(rd){
		case 0: copy(args,18,"beam me up scotty")
		case 1: copy(args,16,"scotty energize")
		case 2: copy(args,16,"scotty energize")
		case 3: copy(args,16,"scotty energize")
		case 4: copy(args,16,"scotty energize")
		case 5: copy(args,16,"scotty energize")
		case 6: copy(args,16,"scotty energize")
		case 7: copy(args,26,"scotty beam me to my team")
		case 8: copy(args,63,to_person)
	}
	if(players[guy] > 0 && players[guy] < get_maxplayers()+1){
		if(g_botlastsay[players[guy]] < get_gametime() - 3.0)
			make_botsay(args,players[guy],-1)
	}

	new Float:botsnumfactor = float(inum - 6)
	if(botsnumfactor < 0)
		botsnumfactor = (botsnumfactor * -3.0) + 3.0
	else
		botsnumfactor = 10.0
	new Float:hinum = 45.0
	if(hinum < botsnumfactor+1.0)
		hinum = botsnumfactor + 1.0
	new Float:nexttime = random_float(botsnumfactor,hinum)

	set_task(nexttime,"rs_scotty_e",34020)
	return PLUGIN_CONTINUE
}

public rs_scotty_l(){
	if(!get_cvar_num("amx_autoscotty_bots"))
		return PLUGIN_CONTINUE
	new players[32],inum
	new maxpl = get_maxplayers()
	for(new a = 1; a < maxpl; a++) {
		if(is_user_connected(a)){
			if(is_user_bot(a)){
				if(is_user_alive(a)){
					players[inum] = a
					inum++
				}
			}
		}
	}
	new guy = random_num(0,inum)
	new args[128]
	copy(args,11,"scotty lock")
	if( (players[guy] > 0 && players[guy] < get_maxplayers()+1) && (LastBotScottyL[players[guy]] < get_gametime() - 15.0) ){
		LastBotScottyL[players[guy]] = get_gametime()
		if(g_botlastsay[players[guy]] < get_gametime() - 3.0)
			make_botsay(args,players[guy],-1)
	}

	new Float:botsnumfactor = float(inum - 6)
	if(botsnumfactor < 0)
		botsnumfactor = (botsnumfactor * -3.0) + 5.0
	else
		botsnumfactor = 10.0
	new Float:hinum = 40.0
	if(hinum < botsnumfactor+1.0)
		hinum = botsnumfactor + 1.0
	new Float:nexttime = random_float(botsnumfactor,hinum)

	set_task(nexttime,"rs_scotty_l",34021)
	return PLUGIN_CONTINUE
}

public rs_missile(){
	if(!get_cvar_num("amx_automissile_bots"))
		return PLUGIN_CONTINUE
	new players[32],inum
	new maxpl = get_maxplayers()
	for(new a = 1; a < maxpl; a++) {
		if(is_user_connected(a)){
			if(is_user_bot(a)){
				if(is_user_alive(a)){
					players[inum] = a
					inum++
				}
			}
		}
	}
	new guy = random_num(0,inum)
	new cmd[32],rd
	rd = random_num(0,19)
	switch(rd){
		case 0: copy(cmd,11,"amx_missile")
		case 1: copy(cmd,11,"amx_missile")
		case 2: copy(cmd,11,"amx_missile")
		case 3: copy(cmd,11,"amx_missile")
		case 4: copy(cmd,11,"amx_missile")
		case 5: copy(cmd,11,"amx_missile")
		case 6: copy(cmd,23,"amx_laserguided_missile")
		case 7: copy(cmd,23,"amx_laserguided_missile")
		case 8: copy(cmd,23,"amx_ropeseeking_missile")
		case 9: copy(cmd,23,"amx_heatseeking_missile")
		case 10: copy(cmd,23,"amx_heatseeking_missile")
		case 11: copy(cmd,23,"amx_heatseeking_missile")
		case 12: copy(cmd,23,"amx_heatseeking_missile")
		case 13: copy(cmd,23,"amx_heatseeking_missile")
		case 14: copy(cmd,25,"amx_swirlingdeath_missile")
		case 15: copy(cmd,25,"amx_swirlingdeath_missile")
		case 16: copy(cmd,25,"amx_swirlingdeath_missile")
		case 17: copy(cmd,25,"amx_swirlingdeath_missile")
		case 18: copy(cmd,25,"amx_swirlingdeath_missile")
		case 19: copy(cmd,25,"amx_swirlingdeath_missile")
	}
	if(players[guy] > 0 && players[guy] < get_maxplayers()+1)
		server_cmd("bot_missile %d %s",players[guy],cmd)

	new Float:botsnumfactor = float(inum - 6)
	if(botsnumfactor < 0)
		botsnumfactor = (botsnumfactor * -0.7) + 0.1
	else
		botsnumfactor = 0.1
	new Float:hinum = get_cvar_float("amx_automissile_bots_freq")
	if(hinum < botsnumfactor+1.0)
		hinum = botsnumfactor + 1.0
	new Float:nexttime = random_float(botsnumfactor,hinum)

	set_task(nexttime,"rs_missile",34022)
	return PLUGIN_CONTINUE
}

public rs_laser(){
	if(!get_cvar_num("amx_autolaser_bots"))
		return PLUGIN_CONTINUE
	new players[32],inum
	new maxpl = get_maxplayers()
	for(new a = 1; a < maxpl; a++) {
		if(is_user_connected(a)){
			if(is_user_bot(a)){
				if(is_user_alive(a)){
					players[inum] = a
					inum++
				}
			}
		}
	}
	new guy = random_num(0,inum)
	if(players[guy] > 0 && players[guy] < get_maxplayers()+1)
		server_cmd("bot_laser %d",players[guy])

	new Float:botsnumfactor = float(inum - 6)
	if(botsnumfactor < 0)
		botsnumfactor = (botsnumfactor * -0.1) + 0.1
	else
		botsnumfactor = 0.1
	new Float:hinum = get_cvar_float("amx_autolaser_bots_freq")
	if(hinum < botsnumfactor+1.0)
		hinum = botsnumfactor + 1.0
	if(inum < 2)
		hinum = 4.0
	new Float:nexttime = random_float(botsnumfactor,hinum)

	set_task(nexttime,"rs_laser",34024)
	return PLUGIN_CONTINUE
}

public rs_livechat(){
	if(!get_cvar_num("amx_autolivechat_bots"))
		return PLUGIN_CONTINUE
	new players[32],inum
	new maxpl = get_maxplayers()
	for(new a = 1; a < maxpl; a++) {
		if(is_user_connected(a)){
			if(is_user_bot(a)){
				if(is_user_alive(a)){
					players[inum] = a
					inum++
				}
			}
		}
	}
	new guy = random_num(0,inum)
	new args[128],rd

	if(wantgravvote == 1){
		rd = random_num(0,4)
		switch(rd){
			case 0: copy(args,19,"I want low gravity")
			case 1: copy(args,26,"hey! the grav it too high")
			case 2: copy(args,13,"vote_gravity")
			case 3: copy(args,13,"vote_gravity")
			case 4: copy(args,35,"I think you gotta say vote_gravity")
		}
		wantgravvote = 0
	}
	else if(wantscottyvote == 1){
		rd = random_num(0,4)
		switch(rd){
			case 0: copy(args,44,"I wanna teleport! Turn scotty on crazy mode")
			case 1: copy(args,47,"hey! make scotty crazy cuz teleporting is cool")
			case 2: copy(args,12,"vote_scotty")
			case 3: copy(args,12,"vote_scotty")
			case 4: copy(args,56,"to enable teleporting I think you gotta say vote_scotty")
		}
		wantscottyvote = 0
	}else{
		rd = random_num(0,9)
		switch(rd){
			case 0: copy(args,13,"roll the dice")
			case 1: copy(args,13,"roll the dice")
			case 2: copy(args,13,"roll the dice")
			case 3: copy(args,13,"roll the dice")
			case 4: copy(args,12,"i feel lucky")
			case 5: copy(args,12,"i feel lucky")
			case 6: copy(args,12,"i feel lucky")
			case 7: copy(args,8,"kamikaze")
			case 8: copy(args,8,"kamikaze")
			case 9: copy(args,6,"/drink")
		}
	}
	if(players[guy] > 0 && players[guy] < get_maxplayers()+1){
		if(g_botlastsay[players[guy]] < get_gametime() - 3.0)
			make_botsay(args,players[guy],-1)
	}

	get_players(players,inum,"d")
	new Float:botsnumfactor = float(inum - 6)
	if(botsnumfactor < 0)
		botsnumfactor = (botsnumfactor * -1.5) + 5.0
	else
		botsnumfactor = 5.0

	new Float:hinum = get_cvar_float("amx_autolivechat_bots_freq")
	if(hinum < botsnumfactor+1.0)
		hinum = botsnumfactor + 1.0
	new Float:nexttime = random_float(botsnumfactor,hinum)
	set_task(nexttime,"rs_livechat",34026)
	return PLUGIN_CONTINUE
}

public chk_flame(){
	if(!get_cvar_num("amx_autoflame_bots"))
		return PLUGIN_CONTINUE

	new players[32],inum
	new maxpl = get_maxplayers()
	for(new a = 1; a < maxpl; a++) {
		if(is_user_connected(a)){
			if(is_user_bot(a)){
				if(is_user_alive(a)){
					players[inum] = a
					inum++
				}
			}
		}
	}
	new guy = random_num(0,inum-1)
	new vec[3] 
	new aimvec[3] 
	new velocityvec[3] 
	new length 	 
	new speed = 300
	if(!players[guy])
		return PLUGIN_CONTINUE
	get_user_origin(players[guy],vec) 
	get_user_origin(players[guy],aimvec,2)
	velocityvec[0]=aimvec[0]-vec[0] 
	velocityvec[1]=aimvec[1]-vec[1] 
	velocityvec[2]=aimvec[2]-vec[2] 
	length=sqrt(velocityvec[0]*velocityvec[0]+velocityvec[1]*velocityvec[1]+velocityvec[2]*velocityvec[2]) 
	velocityvec[0]=velocityvec[0]*speed/length 
	velocityvec[1]=velocityvec[1]*speed/length 
	velocityvec[2]=velocityvec[2]*speed/length
	vec[0] = vec[0] + velocityvec[0] 
	vec[1] = vec[1] + velocityvec[1] 
	vec[2] = vec[2] + velocityvec[2] 

	new done
	for(new a = 1; a < maxpl; a++) {
		if(is_user_connected(a)){
			if( (is_user_alive(a)) && (!done) ){
				new origin[3]
				get_user_origin(a,origin)
				if(get_distance(vec,origin) < 250){
					if(dod_running){
						if(dod_team[players[guy]] != dod_team[a]){
							done = 1
							server_cmd("bot_flamethrower %d",players[guy])
						}
					}else{
						if(get_user_team(players[guy]) != get_user_team(a)){
							done = 1
							server_cmd("bot_flamethrower %d",players[guy])
						}
					}
				}
			}
		}
	}
	set_task(get_cvar_float("amx_autoflame_bots_freq"),"chk_flame",34028)
	return PLUGIN_CONTINUE
}

public admin_bot_rs(id,level,cid){
	if (!cmd_access(id,level,cid,1))
		return PLUGIN_HANDLED
	if(rst){
		console_print(id,"[AMX]  Killing tasks already in progress.") 		
		return PLUGIN_HANDLED	
	}
	console_print(id,"[AMX]  Now killing all bot mod usage tasks.  Restarting tasks in 5 seconds.")
	remove_task(34020)
	remove_task(34021)
	remove_task(34022)
	remove_task(34023)
	remove_task(34024)
	remove_task(34025)
	remove_task(34026)
	remove_task(34027)
	remove_task(34028)
	remove_task(34029)
	rst = 1
	new ida[1]
	ida[0] = id
	set_task(5.0,"restart_tasks",0,ida,1)
	return PLUGIN_HANDLED
}

public restart_tasks(id[]){
	console_print(id[0],"[AMX]  Commencing the restarting of bot mod usage tasks.")
	set_task(2.0,"bot_jetpack",34029,"",0,"b")
	set_task(get_cvar_float("amx_autoflame_bots_freq"),"chk_flame",34028)
	set_task(2.0,"rs_scotty_e",34020)
	set_task(20.0,"rs_scotty_l",34021)
	set_task(get_cvar_float("amx_automissile_bots_d") + get_cvar_float("mp_freezetime"),"rs_missile",34023)
	set_task(get_cvar_float("amx_autolaser_bots_d") + get_cvar_float("mp_freezetime"),"rs_laser",34025)
	set_task(get_cvar_float("amx_autoflame_bots_freq"),"chk_flame",34028)
	set_task(get_cvar_float("amx_autolivechat_bots_d") + get_cvar_float("mp_freezetime"),"rs_livechat",34027)
	rst = 0
	return PLUGIN_HANDLED
}

public pluginstart(){
	set_task(2.0,"bot_jetpack",34029,"",0,"b")
	set_task(get_cvar_float("amx_autoflame_bots_freq"),"chk_flame",34028)
	if(!cstrike_running){
		set_task(2.0,"rs_scotty_e",34020)
		set_task(20.0,"rs_scotty_l",34021)
		set_task(get_cvar_float("amx_automissile_bots_d") + get_cvar_float("mp_freezetime"),"rs_missile",34023)
		set_task(get_cvar_float("amx_autolaser_bots_d") + get_cvar_float("mp_freezetime"),"rs_laser",34025)
		set_task(get_cvar_float("amx_autoflame_bots_freq"),"chk_flame",34028)
		set_task(get_cvar_float("amx_autolivechat_bots_d") + get_cvar_float("mp_freezetime"),"rs_livechat",34027)
	}
	return PLUGIN_CONTINUE	
}	

public sqrt(num) { 
	new div = num 
	new result = 1 
	while (div > result) { // end when div == result, or just below 
		div = (div + result) / 2 // take mean value as new divisor 
		result = num / div 
	} 
	return div 
} 

public jp_missile_ck(){
	new sid[4],sstat[4]
	read_argv(1,sid,3)
	read_argv(2,sstat,3)
	new id = strtonum(sid)
	if(id < 1 || id > 32)
		id = 32
	cmd_jetpackrun[id] = strtonum(sstat)
	return PLUGIN_CONTINUE
}

public bot_jetpack(){
	if(!get_cvar_num("amx_enhancejetpack_bots"))
		return PLUGIN_CONTINUE
	new maxpl = get_maxplayers()
	for(new a = 1; a < maxpl; a++) {
		if(is_user_connected(a)){
			if(is_user_bot(a)){
				new velocity[3]
				new location[3]
				get_user_velocity(a, velocity)
				get_user_origin(a,location)
				if(old_location[a][2] > location[2] + 50)
					server_cmd("bot_jetpackboost %d",a) 
				if(cmd_jetpackrun[a] == 1){
					new vec[3] 
					new aimvec[3] 
					new velocityvec[3] 
					new length 	 
					new speed = 600
					get_user_origin(a,vec) 
					get_user_origin(a,aimvec,2)
					velocityvec[0]=aimvec[0]-vec[0] 
					velocityvec[1]=aimvec[1]-vec[1] 
					velocityvec[2]=aimvec[2]-vec[2] 
					length=sqrt(velocityvec[0]*velocityvec[0]+velocityvec[1]*velocityvec[1]+velocityvec[2]*velocityvec[2]) 
					velocityvec[0]=velocityvec[0]*speed/length 
					velocityvec[1]=velocityvec[1]*speed/length 
					velocityvec[2]=velocityvec[2]*speed/length
					velocity[0] = velocity[0] + velocityvec[0] 
					velocity[1] = velocity[1] + velocityvec[1] 
					set_user_velocity(a, velocity)
				}
				old_location[a][2] = location[2]
			}
		}
	}
	return PLUGIN_CONTINUE
}

get_random_bot(isAlive){
	new players[32],inum
	new maxpl = get_maxplayers()
	if(isAlive){
		for(new a = 1; a < maxpl; a++) {
			if(is_user_connected(a)){
				if(is_user_bot(a)){
					if(is_user_alive(a)){
						players[inum] = a
						inum++
					}
				}
			}
		}
	}else{
		for(new a = 1; a < maxpl; a++) {
			if(is_user_connected(a)){
				if(is_user_bot(a)){
					if(!is_user_alive(a)){
						players[inum] = a
						inum++
					}
				}
			}
		}
	}
	new picked = random_num(0,inum)
	return players[picked]
}

public make_botvotes(){
	if(!get_cvar_num("amx_allowbotvotes"))
		return PLUGIN_CONTINUE
	counter = 0
	// cmd, #of options, type of vote
	// 0=crazy 1=gravity 2=map 3=adminvote 4=kick 5=HURRYUP 6=matrix 7=timebomb 8=scotty
	new arg1[8], arg2[8]
	read_argv(1,arg1,7)
	read_argv(2,arg2,7)
	new num_opt = strtonum(arg1)
	new vote_type =strtonum(arg2)

	new players[32],inum
	new maxpl = get_maxplayers()
	for(new a = 1; a < maxpl; a++) {
		if(is_user_connected(a)){
			if(is_user_bot(a)){
				players[inum] = a
				inum++
			}
		}
	}

	new Float:botsnumfactor = float(inum - 6)
	if(botsnumfactor < 0)
		botsnumfactor = (botsnumfactor * -0.1) + 0.1
	else
		botsnumfactor = 0.1
	new Float:nexttime = random_float(botsnumfactor,1.2)

	new args[40]
	args[0] = num_opt
	args[1] = inum
	args[2] = vote_type
	copy(args[4],32,players) 
	set_task(nexttime,"do_botvote",34030,args,40,"a",inum - 1)

	return PLUGIN_CONTINUE
}

public do_botvote(args[]){
	new num_opt = args[0]
	new inum = args[1]
	new vote_type = args[2]
	new players[32]
	copy(players,32,args[4])
	if(counter > inum)		
		return PLUGIN_CONTINUE
	new id = players[counter]
	new key = random_num(1,num_opt)
	if(vote_type == 1 && key == 1 && get_cvar_num("amx_autovotegravity_bots") )
		key = random_num(1,num_opt)
	else if(vote_type == 8 && key == 2 && get_cvar_num("amx_autovotescotty_bots") )
		key = random_num(1,num_opt)

	if(id > 0 && id < get_maxplayers()+1)
		server_cmd("bot_votesfor %d %d",id,key)
	counter++
	return PLUGIN_CONTINUE
}

public HandleSay(id) {
	if(!get_cvar_num("amx_usebotchat"))
		return PLUGIN_CONTINUE

	new Name[32],n1[32],n2[32]
	new Speech[40]
	new word[12][10] // only 0-5 used 
	read_args(Speech,39)
	remove_quotes(Speech)
	new argc = read_argc()

	parse(Speech, word[0], 9, word[1], 9, word[2], 9, word[3], 9, word[4], 9, word[5])
	new bot_pos = 100
	new found = 0
	for (new i = 0; i < 6;i++){
		if(found)
			continue
		found = find_botid(word[i])
		if(found){
			bot_pos = i
			talkingto[id][1] = 0
		}
	}
	if(!found){
		talkingto[id][1] +=1
		if(talkingto[id][0])
			found = talkingto[id][0]
	}
	if(g_botlastsay[found] > get_gametime() - 3.0)
		return PLUGIN_CONTINUE
	if(is_user_alive(id) != is_user_alive(found))
		return PLUGIN_CONTINUE
	if(found > 0 && found < get_maxplayers()+1){
		new verb_pos =-1   
		new verb_type = -1
		new wordinfo[6][2] = {{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1},{-1,-1}} //type,word
		new is_quest
		if(contain(Speech,"?")!=-1)
			is_quest = 1
		new botname[12]
		get_user_name(found,botname,11)
		if(bot_pos < 2){
			if(contain(word[bot_pos+1],"what")!=-1)
				is_quest = 2
 			else if(contain(word[bot_pos+1],"who")!=-1)
				is_quest = 3
			else if(equal(word[bot_pos+1],"when"))
				is_quest = 4 
			else if(equal(word[bot_pos+1],"where"))
				is_quest = 5
			else if(equal(word[bot_pos+1],"why"))
				is_quest = 6
			else if ( strlen(word[bot_pos]) > strlen(botname) ) {
				if( (equal(word[bot_pos+1],"is")) || (equal(word[bot_pos+1],"are")) )
					is_quest = 1
			}
		}else{ 
			if(contain(word[0],"what")!=-1)
				is_quest = 2
 			else if(contain(word[0],"who")!=-1)
				is_quest = 3
			else if(equal(word[0],"when"))
				is_quest = 4 
			else if(equal(word[0],"where"))
				is_quest = 5
			else if(equal(word[0],"why"))
				is_quest = 6
		}
		new rd
		get_user_name(id,Name,31)
		parse(Name,n1,31,n2,31)
		if(n2[0]){
			rd = random_num(0,1)
			if(rd)
				format(Name,31,n2)
			else
				format(Name,31,n1)
		}else
			format(Name,31,n1)
		new SayText[64]
		new fnd = 0
		for (new i = 0; i < 6;i++){
			if(fnd)
				continue
			if( (equal(word[i],"hi")) || (equal(word[i],"hey")) || (equal(word[i],"hello")) || (equal(word[i],"wazzup")) ){
				rd = random_num(0,type4index-1)
				format(SayText,63,TYPE4[rd],Name)
				fnd = 1
			}
			if(verb_type < 4){
				if( (equal(word[i],"am")) || (equal(word[i],"are")) || (equal(word[i],"is")) ){
					verb_pos = i
					verb_type = 2 // present
				}
				else if(equal(word[i],"will")){
					verb_pos = i
					verb_type = 3 // future
				}
				else if( (equal(word[i],"was")) || (equal(word[i],"were")) ){
					verb_pos = i
					verb_type = 1 // past
				}
				else if(equal(word[i],"shut",4)){
					if(talkingto[id][0] == found){
						talkingto[id][1] = 100
						rd = random_num(0,2)
						switch(rd){
							case 0: format(SayText,63,"sorry %s, ill shut up now",Name)
							case 1: format(SayText,63,"ok ok %s",Name)
							case 2: format(SayText,63,"fine, i wont talk to you anymore %s",Name)
						}
						fnd = 1
					}
				}
			}
			else if( (equal(word[i],"i")) || (equal(word[i],"me")) ){
				wordinfo[i][0] = 1
				wordinfo[i][1] = 1
			}
			else if(equal(word[i],"you")){
				wordinfo[i][0] = 1
				wordinfo[i][1] = 2
			}
			else if(equal(word[i],"this")){
				wordinfo[i][0] = 1
				wordinfo[i][1] = 3
			}
			else if(contain(word[i],"bot")){
				wordinfo[i][0] = 2
				wordinfo[i][1] = 1
			}
		}
		if(verb_type < 4 && is_quest && !fnd){
			switch(is_quest){
				case 2: {
					rd = random_num(0,3)
					switch(rd){
						case 0: format(SayText,63,"i dont know what")
						case 1: format(SayText,63,"i dont know %s",Name)
						case 2: format(SayText,63,"who cares")
						case 3: format(SayText,63,"afraid that was before i was around or paying attention")
					}			
					fnd = 1
				}
				case 3: {
					rd = random_num(0,4)
					switch(rd){
						case 0: format(SayText,63,"nobody")
						case 1: format(SayText,63,"we all do")
						case 2: format(SayText,63,"perhaps its you, %s",Name)
						case 3: format(SayText,63,"dunno %s",Name)
						case 4: format(SayText,63,"is it me?") 
					}			
					fnd = 1
				}
				case 4: {
					rd = random_num(0,6)
					switch(rd){
						case 0: format(SayText,63,"soon perhaps %s",Name)
						case 1: format(SayText,63,"probably later")
						case 2: format(SayText,63,"never")
						case 3: format(SayText,63,"what do i look like, a psychic?")
						case 4: format(SayText,63,"a few minutes, maybe an hour ... years?")
						case 5: format(SayText,63,"when? good question %s",Name)
						case 6: format(SayText,63,"dunno %s",Name)
					}			
					fnd = 1
				}
				case 5: {
					rd = random_num(0,6)
					switch(rd){
						case 0: format(SayText,63,"really want me to answer that?")
						case 1: format(SayText,63,"on the map?",Name)
						case 2: format(SayText,63,"who cares",Name)
						case 3: format(SayText,63,"afk?")
						case 4: format(SayText,63,"none of your buisiness where")
						case 5: format(SayText,63,"yeah, where?")
						case 6: format(SayText,63,"dunno %s",Name)
					}			
					fnd = 1
				}
				case 6: {
					rd = random_num(0,6)
					switch(rd){
						case 0: format(SayText,63,"dunno %s",Name)
						case 1: format(SayText,63,"why? just because %s",Name)
						case 2: format(SayText,63,"why is the sky blue?")
						case 3: format(SayText,63,"dont ask me %s, im just a bot",Name)
						case 4: format(SayText,63,"your asking the wrong person")
						case 5: format(SayText,63,"who knows?")
						case 6: format(SayText,63,"dunno %s",Name)
					}			
					fnd = 1
				}
				default : {
					switch(verb_type){
						case 1: {
							rd = random_num(0,3)
							switch(rd){
								case 0: format(SayText,63,"its true, %s %s %s %s %s %s",
									word[verb_pos+1],word[verb_pos],word[verb_pos+2],word[verb_pos+3],
									word[verb_pos+4],word[verb_pos+4])
								case 1: format(SayText,63,"Ya %s but thats in the past",Name)
								case 2: format(SayText,63,"Nah, but %s will %s again though %s",
									word[verb_pos+1],word[verb_pos+3],Name)
								case 3: format(SayText,63,"afraid that was before i was around or paying attention")
							}			
							fnd = 1
						}
						case 2: {
							rd = random_num(0,6)
							switch(rd){
								case 0: format(SayText,63,"its true, %s %s %s %s %s %s",
									word[verb_pos+1],word[verb_pos],word[verb_pos+2],word[verb_pos+3],
									word[verb_pos+4],word[verb_pos+5])
								case 1: format(SayText,63,"Ya %s thats true",Name)
								case 2: format(SayText,63,"maybe %s %s %s %s %s %s %s",
									word[verb_pos+1],word[verb_pos],word[verb_pos+2],word[verb_pos+3],
									word[verb_pos+4],word[verb_pos+5],Name)
								case 3: format(SayText,63,"dunno %s",Name)
								case 4: format(SayText,63,"i dont think so %s",Name)
								case 5: format(SayText,63,"yes")
								case 6: format(SayText,63,"no")					
							}			
							fnd = 1
						}
						case 3: {
							rd = random_num(0,9)
							switch(rd){
								case 0: format(SayText,63,"dunno %s",Name)
								case 1: format(SayText,63,"beats me %s",Name)
								case 2: format(SayText,63,"how should i know %s",Name)
								case 3: format(SayText,63,"dont ask me %s, im just a bot",Name)
								case 4: format(SayText,63,"your asking the wrong person")
								case 5: format(SayText,63,"what do i look like, a psychic?")
								case 6: format(SayText,63,"sure %s",Name)
								case 7: format(SayText,63,"i dont thin so %s",Name)
								case 8: format(SayText,63,"maybe")
								case 9: format(SayText,63,"dunno %s",Name)
							}			
							fnd = 1
						}
					}
				}
			}
		}else{
			switch(verb_type){
				case 1: {
					rd = random_num(0,2)
					switch(rd){
						case 0: format(SayText,63,"yeah %s, the key word being %s %s",
							Name,word[verb_pos],word[verb_pos+1])
						case 1: format(SayText,63,"Ya %s but thats in the past",Name)
						case 2: format(SayText,63,"%s will %s again though %s",
							word[verb_pos-1],word[verb_pos+1],Name)
					}			
					fnd = 1
				}
				case 2: {
					rd = random_num(0,2)
					switch(rd){
						case 0: format(SayText,63,"%s, what do you mean %s?",Name,word[verb_pos+1])
						case 1: format(SayText,63,"%s, what is a %s?",Name,word[verb_pos+1])
						case 2: format(SayText,63,"yeah i know %s is a %s ",
							word[verb_pos-1],word[verb_pos+1],Name)
					}			
					fnd = 1
				}
				case 3: {
					rd = random_num(0,2)
					switch(rd){
						case 0: format(SayText,63,"Are you sure thats going to happen %s?",Name)
						case 1: format(SayText,63,"%s, what will happen %s?",Name)
						case 2: format(SayText,63,"Are you saying %s will %s %s %s?",
							word[verb_pos-1],word[verb_pos+1],word[verb_pos+2],Name)
					}			
					fnd = 1
				}
			}
		}
		if(!fnd){
			if(argc > 1){
				rd = random_num(0,type0index-1)
				format(SayText,63,TYPE0[rd],Name)
			}else{
				rd = random_num(0,type5index-1)
				format(SayText,63,TYPE5[rd],Name)
			}
		}else{
			if(talkingto[id][1] != 100)
				talkingto[id][1] = 0
		}
		if(talkingto[id][1] > 2)
			talkingto[id][0] = 0
		else
			talkingto[id][0] = found
		new args[66]
		args[0] = found
		copy(args[1],63,SayText)
		set_task(1.5,"delay_response",0,args,66)
	}
	return PLUGIN_CONTINUE
}

public delay_response(args[]){
	new botid = args[0] 
	new SayText[64]
	format(SayText,63,args[1])
	make_botsay(SayText,botid,-1)	
	return PLUGIN_CONTINUE
}

find_botid(word[]){
	new found1 = 0
	for(new a = 0;a<botnamecounter;a++){
		if(found1)
			continue
		if(containi(word, botnames[a]) != -1)
			found1 = botids[a]
	}
	return found1
}

public handle_adm(){
	new arg1[8],arg2[8]
	read_argv(1,arg1,7)
	read_argv(2,arg2,7)
	g_death_event(strtonum(arg1),strtonum(arg2))			
	return PLUGIN_CONTINUE
}

public death_event(){
	g_death_event(read_data(1),read_data(2))		
	return PLUGIN_CONTINUE
}

g_death_event(attacker,victim){
	if(!get_cvar_num("amx_usebotchat"))
		return PLUGIN_CONTINUE
	if(attacker == 0 || attacker == victim)
		return PLUGIN_CONTINUE
	if(is_user_bot(victim)){
		new namea[32]
		get_user_name(attacker,namea,31)
		new rd = random_num(0,type2index * 5)
		if(rd > type2index * 2)
			return PLUGIN_CONTINUE
		else if(rd > type2index-1)
			angrybot[victim] = attacker
		else{
			new SayText[64]
			format(SayText,63,TYPE2[rd],namea)
			new args[66]
			args[0] = victim
			if(equal(SayText[0],"!",1)){
				copy(args[1],63,SayText[1])
				set_task(0.3,"delay_response",0,args,66)
			}else{
				copy(args[1],63,SayText)
				set_task(3.3,"delay_response",0,args,66)
			}
			talkingto[attacker][0] = victim
		}
	}
	else if(is_user_bot(attacker)){
		new namev[32]
		get_user_name(victim,namev,31)
		new rd = random_num(0,type3index * 4)
		if(rd < type3index){
			new SayText[64]
			format(SayText,63,TYPE3[rd],namev)
			new args[66]
			args[0] = attacker
			copy(args[1],63,SayText)
			set_task(1.0,"delay_response",0,args,66)
		}
	}
	return PLUGIN_CONTINUE		
}

public new_spawn(id){
	if(!get_cvar_num("amx_usebotchat"))
		return PLUGIN_CONTINUE
	if(abuserevenge[id]){
		new name[32]
		get_user_name(abuserevenge[id],name,31)		
		new SayText[64]
		format(SayText,63,"im still stewing about that abusin admin %s",name)
		new Float:delaytime = random_float(1.0,7.0)		
		new args[66]
		args[0] = id
		copy(args[1],63,SayText)
		set_task(delaytime,"delay_response",0,args,66)
		new br[2] 
		br[0] = id
		br[1] = get_user_userid(abuserevenge[id])
		set_task(11.0,"abuse_revenge",0,br,2)
		talkingto[abuserevenge[id]][0] = id
		new maxpl = get_maxplayers()+1
		for(new i=1;i<maxpl;i++)
			abuserevenge[i] = 0
	}
	else if(bombvoterevenge[id]){
		new name[32]
		get_user_name(bombvoterevenge[id],name,31)		
		new rd = random_num(0,type6index-1)
		new SayText[64]
		format(SayText,63,TYPE6[rd],name)
		new Float:delaytime = random_float(1.0,7.0)		
		new args[66]
		args[0] = id
		copy(args[1],63,SayText)
		set_task(delaytime,"delay_response",0,args,66)
		talkingto[bombvoterevenge[id]][0] = id
		new br[2] 
		br[0] = id
		br[1] = get_user_userid(bombvoterevenge[id])
		set_task(9.0,"bomb_revenge",0,br,2)
		new maxpl = get_maxplayers()+1
		for(new i=1;i<maxpl;i++)
			bombvoterevenge[i] = 0
	}
	else if(angrybot[id]){
		new name[32]
		get_user_name(angrybot[id],name,31)
		new rd = random_num(0,type1index-1)
		new SayText[64]
		format(SayText,63,TYPE1[rd],name)
		new Float:delaytime = random_float(1.0,7.0)		
		new args[66]
		args[0] = id
		copy(args[1],63,SayText)
		set_task(delaytime,"delay_response",0,args,66)
		talkingto[angrybot[id]][0] = id
		new maxpl = get_maxplayers()+1
		for(new i=1;i<maxpl;i++)
			angrybot[i] = 0
	}
	if( is_user_alive(id) && needswelcome[id] && !welcome1 ){
		new botid = get_random_bot(ALIVE_BOT)
		if(botid > 0 && botid < get_maxplayers()+1){
			welcome1 = 1
			needswelcome[id] = 0
			new name[32]
			get_user_name(id,name,31)
			new rd = random_num(0,type4index-1)
			new SayText[64]
			format(SayText,63,TYPE4[rd],name)
			new args[66]
			args[0] = botid
			copy(args[1],63,SayText)
			set_task(5.0,"delay_response",0,args,66)
			set_task(5.0,"reset_welcome")
			talkingto[id][0] = botid
		}
	}
	return PLUGIN_CONTINUE
}	

public handle_bvr(){
	new arg1[8],arg2[8]
	read_argv(1,arg1,7)
	read_argv(2,arg2,7)
	bombvoterevenge[strtonum(arg1)] = strtonum(arg2)
	return PLUGIN_CONTINUE
}

public bomb_revenge(br[]){
	server_cmd("amx_votetimebomb #%d",br[1])
	new args[66]
	args[0] = br[0]
	copy(args[1],4,"hehe")
	set_task(4.0,"delay_response",0,args,66)		
	return PLUGIN_CONTINUE
}

public reset_welcome(){
	welcome1 = 0
	return PLUGIN_CONTINUE
}

public bot_adminabuse(id){
	if(!get_cvar_num("amx_usebotchat"))
		return PLUGIN_CONTINUE
	new arg[32]
	read_argv(1,arg,31)
	new player = cmd_target(id,arg,1)
	if (!player) return PLUGIN_HANDLED
	if(is_user_bot(player)){
		if(!isAbused[player]){
			isAbused[player] = 1
			new args[3]
			args[0] = id
			args[1] = player
			args[2] = 0
			abuse_action(args)
		}
	}
	return PLUGIN_CONTINUE	
}

public abuse_action(args[]){
	new id = args[0]
	new player = args[1]
	new recycled = args[2]
	if(!isAbused[player])
		return PLUGIN_CONTINUE
	new namea[32]
	get_user_name(id,namea,31)
	new SayText[64]
	new rd = random_num(0,14)
	if(recycled){
		if(rd < 14){
			if(rd < 12){
				if(is_user_alive(id) == is_user_alive(player)){
					rd = random_num(0,type7index -1) 	
					format(SayText,63,TYPE7[rd],namea)
					new args1[66]
					args1[0] = player
					if(!equal(SayText[0],"!",1)){
						isAbused[player] = 0
						copy(args1[1],63,SayText)
						set_task(1.0,"delay_response",0,args1,66)
						talkingto[id][0] = player
						rd = random_num(0,1)
						if(!rd)
							abuserevenge[player] = id
					}else{
						set_task(5.0,"abuse_action",34031,args,3)
					}
				}else{
					set_task(5.0,"abuse_action",34031,args,3)
				}
			}else{
				set_task(5.0,"abuse_action",34031,args,3)
			}
		}else{
			isAbused[player] = 0
		}
	}else{
		rd = random_num(0,type7index -1) 
		format(SayText,63,TYPE7[rd],namea)
		new args1[66]
		args1[0] = player
		if(equal(SayText[0],"!",1)){
			isAbused[player] = 0
			copy(args1[1],63,SayText[1])
			set_task(0.3,"delay_response",0,args1,66)
		}else{
			args[2] = 1
			set_task(5.0,"abuse_action",34031,args,3)
		}
	}
	return PLUGIN_CONTINUE	
}

public abuse_revenge(br[]){
	server_cmd("amx_votetimebomb #%d",br[1])
	new args[66]
	args[0] = br[0]
	copy(args[1],4,"hehe")
	set_task(4.0,"delay_response",0,args,66)		
	return PLUGIN_CONTINUE
}

public client_connect(id){
	dod_team[id] = 0
	needswelcome[id] = 0
	isAbused[id] = 0
	abuserevenge[id] = 0
	talkingto[id][0] = 0
	return PLUGIN_CONTINUE
}

public client_putinserver(id){
	if(!get_cvar_num("amx_usebotchat"))
		return PLUGIN_CONTINUE
	new name[24]
	get_user_name(id,name,23)
	if(is_user_bot(id)){
		if(botnamecounter > 19)
			botnamecounter = 19
		copy(botnames[botnamecounter],23,name)
		botids[botnamecounter] = id
		botnamecounter++
	}else{
		new rd = random_num(0,1)
		if(!rd){
			new authid[16],found
			get_user_authid(id,authid,15)
			for(new i = 0;i<MAX_BHC;i++){
				if(equal(authid,beenhere[i]))
					found = 1
			}
			if(!found){
				needswelcome[id] = 1
				copy(beenhere[beenherecounter],15,authid)
				beenherecounter++
				if(beenherecounter > MAX_BHC-1)
					beenherecounter = 0
			}else{
				rd = random_num(0,9)
				if(!rd){
					new SayText[64]
					format(SayText,63,"hi again, %s weren't you just here?",name)
					new args[66]
					args[0] = get_random_bot(ALIVE_BOT)
					copy(args[1],63,SayText)
					set_task(6.0,"delay_response",0,args,66)
					talkingto[id][0] = args[0]
				}
			}					
		}
	}		
	return PLUGIN_CONTINUE
}

public client_disconnect(id){
	dod_team[id] = 0
	needswelcome[id] = 0
	isAbused[id] = 0
	abuserevenge[id] = 0
	talkingto[id][0] = 0
	return PLUGIN_CONTINUE
}

public plugin_init() {
	register_plugin("Bot controller for EJL plugins","1.4.1","EJL")
	register_concmd("amx_botsay","admin_botsay",ADMIN_MAP,"<player> <message> : make bots say stuff.")
	register_concmd("amx_botmods_reset","admin_bot_rs",ADMIN_MAP,": restarts bot mod usage tasks if they were off or had failed")
	register_clcmd("amx_slay","bot_adminabuse")
	register_clcmd("amx_slay2","bot_adminabuse")
	register_clcmd("amx_slap","bot_adminabuse")
	register_clcmd("amx_zap","bot_adminabuse")
	register_clcmd("amx_grav","bot_adminabuse")
	register_clcmd("amx_timebomb","bot_adminabuse")
	register_clcmd("say","HandleSay")
	register_event("SayText","handle_SayText","b")
	gmsgSayText = get_user_msgid("SayText")
	register_srvcmd("botsayreturn","handle_bsr")
	register_srvcmd("jetpackmissile_chk","jp_missile_ck")
	register_srvcmd("bot_votebegin","make_botvotes")
	register_srvcmd("artificial_dm","handle_adm")
	register_srvcmd("bot_bombrevenge","handle_bvr")
	register_cvar("amx_autoscotty_bots","1")
	set_cvar_string("amx_autoscotty_bots","1")
	register_cvar("amx_automissile_bots","1")
	set_cvar_string("amx_automissile_bots","1")
	register_cvar("amx_automissile_bots_freq","2.0")
	set_cvar_string("amx_automissile_bots_freq","2.0")
	register_cvar("amx_automissile_bots_d","7.0")
	set_cvar_string("amx_automissile_bots_d","7.0")
	register_cvar("amx_autolaser_bots","1")
	set_cvar_string("amx_autolaser_bots","1")
	register_cvar("amx_autolaser_bots_freq","0.3")
	set_cvar_string("amx_autolaser_bots_freq","0.3")
	register_cvar("amx_autolaser_bots_d","5.0")
	set_cvar_string("amx_autolaser_bots_d","5.0")
	register_cvar("amx_autolivechat_bots","1")
	set_cvar_string("amx_autolivechat_bots","1")
	register_cvar("amx_autolivechat_bots_freq","30.0")
	set_cvar_string("amx_autolivechat_bots_freq","30.0")
	register_cvar("amx_autolivechat_bots_d","2.0")
	set_cvar_string("amx_autolivechat_bots_d","2.0")
	register_cvar("amx_autoflame_bots","1")
	set_cvar_string("amx_autoflame_bots","1")
	register_cvar("amx_autoflame_bots_freq","1.0")
	set_cvar_string("amx_autoflame_bots_freq","1.0")
	register_cvar("amx_enhancejetpack_bots","1")
	set_cvar_string("amx_enhancejetpack_bots","1")
	register_cvar("amx_autovotegravity_bots","1")
	set_cvar_string("amx_autovotegravity_bots","1")
	register_cvar("amx_autovotescotty_bots","0")
	set_cvar_string("amx_autovotescotty_bots","0")
	register_cvar("amx_allowbotvotes","1")
	set_cvar_string("amx_allowbotvotes","1")
	register_cvar("amx_usebotchat","1")
	set_cvar_string("amx_usebotchat","1")

	register_event("SendAudio","round_end","a","2=%!MRAD_terwin","2=%!MRAD_ctwin","2=%!MRAD_rounddraw")
	register_event("TextMsg","round_end","a","2&#Game_C","2&#Game_w")
	register_event("DeathMsg","death_event","a")
	register_event("ResetHUD", "new_spawn", "b")	

	new mod_name[32]
	get_modname(mod_name,31)
	cstrike_running = equal(mod_name,"cstrike") ? true : false
	dod_running = equal(mod_name,"dod") ? true : false

	set_task(10.0,"pluginstart")

	if(file_exists("addons/amx/bot_chats.txt") == 1){
		new line = 0
		new data[64]
		new stextsize = 0
		new type =-1
		while((line=read_file("addons/amx/bot_chats.txt",line,data,63,stextsize))!=0){
			if(equali(data,"[NOT-UNDERSTAND]"))
				type = 0
			else if(equali(data,"[GRUDGEBOT]"))
				type = 1	
			else if(equali(data,"[VICTIMBOT]"))
				type = 2
			else if(equali(data,"[ATTACKERBOT]"))
				type = 3
			else if(equali(data,"[HELLO-RESPOND]"))
				type = 4
			else if(equali(data,"[NAME-RESPOND1]"))
				type = 5
			else if(equali(data,"[BOMB-REVENGE]"))
				type = 6
			else if(equali(data,"[ADMIN-ABUSE]"))
				type = 7
			if( (equal(data,"[",1)) || (equal(data,"/",1)) || (strlen(data) == 0) )
				continue
			switch(type){
				case 0:{
					copy(TYPE0[type0index],MAX_BS_LENGTH-1,data)
					type0index++
					if(type0index > MAX_TYPE0 -1)
						type0index--
				}
				case 1:{
					copy(TYPE1[type1index],MAX_BS_LENGTH-1,data)
					type1index++
					if(type1index > MAX_TYPE1 -1)
						type1index--
				}
				case 2:{
					copy(TYPE2[type2index],MAX_BS_LENGTH-1,data)
					type2index++
					if(type2index > MAX_TYPE2 -1)
						type2index--
				}
				case 3:{
					copy(TYPE3[type3index],MAX_BS_LENGTH-1,data)
					type3index++
					if(type3index > MAX_TYPE3 -1)
						type3index--
				}
				case 4:{
					copy(TYPE4[type4index],MAX_BS_LENGTH-1,data)
					type4index++
					if(type4index > MAX_TYPE4 -1)
						type4index--
				}
				case 5:{
					copy(TYPE5[type5index],MAX_BS_LENGTH-1,data)
					type5index++
					if(type5index > MAX_TYPE5 -1)
						type5index--
				}
				case 6:{
					copy(TYPE6[type6index],MAX_BS_LENGTH-1,data)
					type6index++
					if(type6index > MAX_TYPE6 -1)
						type6index--
				}
				case 7:{
					copy(TYPE7[type7index],MAX_BS_LENGTH-1,data)
					type7index++
					if(type7index > MAX_TYPE7 -1)
						type7index--
				}					
			}
		}
	}
	return PLUGIN_CONTINUE	
}
