/* 
* 
* AMX_LOWGRAV 
* by DrOctagon 
* valyeum@tds.net 
*
* This plugin adds the ability for public low gravity votes as well as giving admins the 
* ability to enable or disable low gravity.
*
* COMMANDS:
* 
*    say: vote_gravity
*    amx_lowgrav < on|off, or 1|0 >
* 
*/ 
#include <amxmod> 
#include <amxmisc> 
new bool:LowGravity 
new option[2] 

public amx_lowgravity(id,level,cid) { 
	if (!cmd_access(id,level,cid,1)) 
	return PLUGIN_HANDLED 
	new arg1[4] 
	read_argv(1,arg1,3) 
	if (equal(arg1,"1")||equali(arg1,"on")){ 
		LowGravity = true 
		server_cmd("sv_gravity 200")
	}
	else if (equal(arg1,"0")||equali(arg1,"off")){ 
		LowGravity = false 
		server_cmd("sv_gravity 800") 
		} 
	else { 
		console_print(id,"Low Gravity is %s",LowGravity ? "enabled" : "disabled") 
		return PLUGIN_HANDLED 
		} 
	console_print(id,"Low Gravity %s",LowGravity ? "enabled" : "disabled") 
	client_print(0,print_center,"Low Gravity Has Been %s!",LowGravity ? "Enabled" : "Disabled") 
	set_hudmessage(0, 100, 0, 0.05, 0.65, 2, 0.02, 10.0, 0.01, 0.1, 2) 
	show_hudmessage(0,LowGravity ? "Low Gravity Enabled" : "Low Gravity Disabled" ) 
	return PLUGIN_HANDLED 
	}

public HandleSay(id) {
	new Speech[192]
	read_args(Speech,192)
	remove_quotes(Speech)
	if ( (containi(Speech, "gravity") != -1) || (containi(Speech, "lowgravity") != -1) ){
		if (get_cvar_num("sv_gravity") != 200) {
			client_print(id,print_chat, "[AMX]  Low gravity is currently disabled. To change say vote_gravity")
			return PLUGIN_HANDLED
		}
		else{ 
			client_print(id,print_chat, "[AMX]  Low gravity is currently enabled. To change say vote_gravity")
			return PLUGIN_HANDLED
		}
	}
	return PLUGIN_CONTINUE
}
		
new votelowgravity[] = "\yAMX %s Low Gravity?\w^n^n1. Yes^n2. No" 
public vote_gravity(id){ 
	new Float:voting = get_cvar_float("amx_last_voting") 
	if (voting > get_gametime()){ 
		client_print(id,print_chat,"* There is already one voting...") 
		return PLUGIN_HANDLED 
	} 
	if (voting && voting + get_cvar_float("amx_vote_delay") > get_gametime()) { 
		client_print(id,print_chat,"* Voting not allowed at this time...") 
		return PLUGIN_HANDLED 
	} 
	new menu_msg[256] 
	format(menu_msg,255,votelowgravity,LowGravity ? "Disable" : "Enable") 
	new Float:vote_time = get_cvar_float("amx_vote_time") + 2.0 
	set_cvar_float("amx_last_voting", get_gametime() + vote_time ) 
	show_menu(0,(1<<0)|(1<<1),menu_msg,floatround(vote_time)) 
	set_task(vote_time,"check_votes") 
	client_print(0,print_chat,"* Voting has started...") 
	option[0]=option[1]=0 
	return PLUGIN_HANDLED 
	}
 
public vote_count(id,key){ 
	if ( get_cvar_float("amx_vote_answers") ) { 
		new name[32] 
		get_user_name(id,name,31) 
		client_print(0,print_chat,"* %s voted for %s", name, key ? "option #2" : "option #1" ) 
	} 
	++option[key] 
	return PLUGIN_HANDLED 
	} 
	public check_votes(id){ 
	if (option[0] > option[1]){ 
		server_cmd( "amx_lowgrav %s", LowGravity ? "off" : "on" ) 
		client_print(0,print_chat,"* Voting successful (yes ^"%d^") (no ^"%d^").",option[0],option[1]) 
	} 
	else{ 
		client_print(0,print_chat,"* Voting failed (yes ^"%d^") (no ^"%d^").",option[0],option[1]) 
	} 
	return PLUGIN_CONTINUE 
	} 

public plugin_init(){ 
register_plugin("Admin Low Gravity","0.4","DrOctagon") 
register_concmd("amx_lowgrav","amx_lowgravity",ADMIN_IMMUNITY,"< 1|0 or on|off > : turn low gravity on/off") 
register_clcmd("say vote_gravity","vote_gravity",0,"- start voting session for low gravity") 
register_clcmd("say", "HandleSay")
register_menucmd(register_menuid("Low Gravity?"),(1<<0)|(1<<1),"vote_count") 
return PLUGIN_CONTINUE 
} 
