/*
* AMXMOD SCRIPT
* 
* AMX SCRIM AND MATCH PLUGIN
* Gevurah
*
* Thanks to the creators of AMX MATCH and AMX Match Deluxe
*
* I used code from them to make my plugin,
* as well as my own code
*
* Instructions:
* simple stuff. an admin with level ADMIN_LEVEL_A types
* amx_prescrim in console to prep the server for scrim/match
* it allows time for DR's and shows WonID's if the cvar amx_officialmatch is 1
* (make it 1 by typing amx_makeofficial in console and amx_makeunofficial to make
* it 0). also, teams are locked. when everyone is ready, type
* amx_starthalf in console. this will execute cal.cfg and do lo3.
* 12 rounds pass. first half ends. scores are shown. teams are
* automatically switched. you have DR's. when you are ready for
* second half type amx_starthalf in console. executes cal.cfg and lo3.
* if a team wins (13 wins) match stops and a vote takes place
* to see if teams would like to play out the match.
* if teams vote yes, play continues until 12 rounds in the second
* half have been played. if teams tie, match plugin stops.
* you can cancel a match at any time by typing amx_haltscrim in console.
* two cfg files are used. in the amx folder make pauseplugins.cfg and
* unpauseplugins.cfg. type pause <plugin name> on each line in the cfg
* for every plugin you want to pause during the match. in unpauseplugins.cfg
* type the same thing as in in pauseplugins.cfg but instead of pause, make it
* unpause. this is disabled by default. in admin.cfg add amx_usecfgs 1 to enable
* it or use rcon.
*
*/

#include <amxmod>
#include <amxmisc>
#include <fun>
#include <csstats>


public admin_setup(id,level,cid){
	if (!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED
	new newpass[32]
	read_argv(1,newpass,31)
	if(newpass[0]!=0)
		set_cvar_string("sv_password",newpass)
	server_cmd("exec cal.cfg")
	new usecfgs=get_cvar_num("amx_usecfgs")
	if(usecfgs)
		server_cmd("exec addons/amx/pauseplugins.cfg")
	set_cvar_string("amx_lockteams","1")
	set_cvar_string("mp_maxrounds","0")
	new officialmatch=get_cvar_num("amx_officialmatch")
	if(officialmatch){
		new players[32], playername[32], CTtext[1024] ,Ttext[1024]
		new i, nbr, Tpos = 0, CTpos = 0, steamid[32]
		Tpos += format(Ttext,1023,"Counter-Terrorist WonIDs:^n")
		CTpos += format(CTtext,1023,"Terrorist WonIDs:^n") 
		get_players(players,nbr,"e","CT")
		for(i=0; i<nbr; i++) { 
		    get_user_name(players[i],playername,31) 
		    get_user_authid(players[i], steamid, 31)
		    Tpos += format(Ttext[Tpos],1023 - Tpos,"     %s: %s^n",playername,steamid)
		} 
		get_players(players,nbr,"e","TERRORIST") 
		for(i=0; i<nbr; i++) { 
		    get_user_name(players[i],playername,31) 
		    get_user_authid(players[i], steamid, 31)
		    CTpos += format(CTtext[CTpos],1023 - CTpos,"     %s: %s^n",playername,steamid)
		} 
		set_hudmessage(255, 255, 255, 0.02, -1.0, 0, 2.0, 15.0, 0.8, 0.8, 1) 
		get_players(players,nbr,"e","CT")
		for(i=0; i<nbr; i++) {
			show_hudmessage(players[i],CTtext)
		}
		get_players(players,nbr,"e","TERRORIST")
		for(i=0; i<nbr; i++) {
			show_hudmessage(players[i],Ttext)
		}
		set_task(15.5, "restart_round",0,"1",2)
		set_task(18.0,"dead_round")
	}
	else{
		set_task(0.5, "restart_round",0,"1",2)
		set_task(3.0,"dead_round")
	}
	return PLUGIN_CONTINUE
}

public admin_start(id,level,cid){
	if (!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED
	new scrimhalf=get_cvar_num("amx_scrimhalf")
	new matchinprogress=get_cvar_num("amx_matchinprogress")
	set_cvar_string("amx_checkwinner","1")
	if(scrimhalf==0){ //if first half starting
		client_print(0,print_chat,"* [AMX SCRIM/MATCH] Executing CAL.cfg...")
		server_cmd("exec cal.cfg")//exec cal.cfg
		set_cvar_string("mp_maxrounds","0") //remove maxrounds
		client_print(0,print_chat,"* [AMX SCRIM/MATCH] Live in 3 restarts...")
		restart_round("1") //first restart
		set_task(2.0, "restart_round",0,"1",2) //second restart
		set_task(4.0, "restart_round",0,"3",2) //3rd restart
		set_task(10.0, "live_message") //calls live message
		return PLUGIN_CONTINUE
	}
	if(scrimhalf==1 && matchinprogress==0){ //second half and match hasn't started yet
		client_print(0,print_chat,"* [AMX SCRIM/MATCH] Live in 3 restarts...")
		restart_round("1") //first restart
		set_task(2.0, "restart_round",0,"1",2) //second restart
		set_task(4.0, "restart_round",0,"3",2) //final restart
		set_task(10.0, "live_message") //livemessage
		return PLUGIN_CONTINUE
	}
	if(scrimhalf==1 && matchinprogress==1)
		console_print(id,"* A match half is already in progess") //first half match already going
	if(scrimhalf==2){
		console_print(id,"* A match half is already in progess") //second half match already going
	}
	return PLUGIN_CONTINUE
}

public live_message(){
	set_cvar_string("mp_maxrounds","0") //removes maxrounds "failsafe"
	new scrimhalf=get_cvar_num("amx_scrimhalf") //find out which half it is
	scrimhalf++ //increment (becomes 1 if first half - becomes 2 if second)
	set_cvar_num("amx_scrimhalf",scrimhalf) //sets cvar to correct half
	set_cvar_num("amx_matchinprogress",1) //makes matchinprogess 1 - new round and other functions start working
	set_hudmessage(255, 255, 255, 0.45, 0.3, 0, 2.0, 6.0, 0.8, 0.8, 2) //white hud message
	show_hudmessage(0,"* BEGINING HALF %i *^n  * LIVE LIVE LIVE *",scrimhalf) //LIVE
	client_print(0,print_chat,"* [AMX SCRIM/MATCH] LIVE! GL! HF!")
	set_cvar_num("amx_roundnumber",1) //sets round as 1
	set_task(1.0,"new_round") //calls new round for first time.
	return PLUGIN_CONTINUE
}

public new_round(id){
	new matchinprogress=get_cvar_num("amx_matchinprogress") //if match isn't going don't do anything
	if(!matchinprogress)
		return PLUGIN_CONTINUE
	new roundlimit=get_cvar_num("amx_halflength")  //gets all used values
	new roundnumber=get_cvar_num("amx_roundnumber") //gets all used values
	new ctwins=get_cvar_num("amx_ctwins") //gets all used values
	new twins=get_cvar_num("amx_twins") //gets all used values
	new scrimhalf=get_cvar_num("amx_scrimhalf") //gets all used values
	new checkwinner=get_cvar_num("amx_checkwinner") //gets all used values
	new winslimit=get_cvar_num("amx_winslimit") //gets all used values
	new ctfirstround=get_cvar_num("amx_ctwins_save") //gets all used values
	new tfirstround=get_cvar_num("amx_twins_save") //gets all used values
	new ctwins_total=ctfirstround+ctwins //total ct wins
	new twins_total=tfirstround+twins //total t wins
	if(scrimhalf==2&&checkwinner==1){ //if its second round and its still checking for a win
		if((ctfirstround+ctwins)>winslimit){ //if total ct wins are greater than 12
			new origin[3]
   			get_user_origin(id,origin)
   			origin[2] -= 50
  			set_user_origin(id, origin)
			return PLUGIN_CONTINUE
		}
		if((tfirstround+twins)>winslimit){ //if total T wins are greater than 12 freeze player in ground
			new origin[3]
   			get_user_origin(id,origin)
   			origin[2] -= 50
  			set_user_origin(id, origin)
			return PLUGIN_CONTINUE
		}
	}
	if((roundnumber>roundlimit)&&(checkwinner==1)){
		new origin[3]
   		get_user_origin(id,origin)
   		origin[2] -= 50
  		set_user_origin(id, origin)
		return PLUGIN_CONTINUE
	}
	set_hudmessage(255, 255, 255, 0.02, -1.0, 0, 2.0, 5.0, 0.8, 0.8, 1)
	show_hudmessage(id,"Round %i of %i: CT: %i T: %i",roundnumber,roundlimit,ctwins_total,twins_total)
	return PLUGIN_CONTINUE
}	

public round_end(){
	new matchinprogress=get_cvar_num("amx_matchinprogress") //is match going on
	if(!matchinprogress) //if not drops out
		return PLUGIN_CONTINUE
	new roundnumber=get_cvar_num("amx_roundnumber") //gets roundnumber
	roundnumber++ //increments round#
	set_cvar_num("amx_roundnumber",roundnumber) //stores roundnumber in cvar
	set_task(4.0,"delay_check_win") //delay to call to check for a win
	return PLUGIN_CONTINUE
}

public delay_check_win(){
	new roundlimit=get_cvar_num("amx_halflength") //gets values
	new roundnumber=get_cvar_num("amx_roundnumber") //gets values
	new ctwins=get_cvar_num("amx_ctwins") //gets values
	new twins=get_cvar_num("amx_twins") //gets values
	new scrimhalf=get_cvar_num("amx_scrimhalf") //gets values
	new checkwinner=get_cvar_num("amx_checkwinner") //gets values
	if(scrimhalf==2&&checkwinner==1){ //if second half going on
		new winslimit=get_cvar_num("amx_winslimit") //gets values
		new ctfirstround=get_cvar_num("amx_ctwins_save") //gets values
		new tfirstround=get_cvar_num("amx_twins_save") //gets values
		if((ctfirstround+ctwins)>winslimit){ //if CT's have enough wins
			set_task(1.0,"end_half",0,"1",2) //call end_half and pass 1 for CT
			return PLUGIN_CONTINUE
		}
		if((tfirstround+twins)>winslimit){ //if T's have enough wins
			set_task(1.0,"end_half",0,"2",2) //call end_half and pass 2 vor T
			return PLUGIN_CONTINUE
		}
	}
	if(roundnumber>roundlimit){ //if the number of rounds for half have been passed
		set_cvar_num("amx_matchinprogress",0) //stop the match (new round & end round isn't called)
		set_task(1.0,"end_half",0,"0",2) //call end_half with nothing passed (waits for endhalf message to finish)
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

public end_half(winnerstr[]){
	new winner=strtonum(winnerstr)
	if(winner==0){ //if either first round is over or tie
		set_cvar_num("amx_matchinprogress",0) //stop match (new round and end round no longer called)
		new scrimhalf=get_cvar_num("amx_scrimhalf")
		if(scrimhalf==1){ //if end of first half
			set_hudmessage(200, 200, 100, 0.02, -1.0, 0, 2.0, 6.0, 0.8, 0.8, 1) //color text saying end of first round
			show_hudmessage(0,"1st Half Over: CT: %i T: %i",get_cvar_num("amx_ctwins"),get_cvar_num("amx_twins"))
			if(get_cvar_num("amx_endroundss")){
				new plrs[32],nbr,i,pindex[2]
				get_players(plrs,nbr)
				for(i=0;i<nbr;i++){
					pindex[0]=plrs[i]
					client_cmd(plrs[i],"+showscores")
					set_task(1.0,"screen",0,"pindex",2)
					set_task(2.0,"offscores",0,"pindex",2)
				}
			}
			set_cvar_num("amx_twins_save",get_cvar_num("amx_ctwins")) //saves score
			set_cvar_num("amx_ctwins_save",get_cvar_num("amx_twins")) //saves score
			set_task(6.0,"switch_teams") //switch teams automatically
			return PLUGIN_CONTINUE
		}
		if(scrimhalf==2){ //scrim is over due to tie or played out
			new ctfirstround=get_cvar_num("amx_ctwins_save") //get scores
			new tfirstround=get_cvar_num("amx_twins_save") //get scores
			new ctwins=get_cvar_num("amx_ctwins") //get scores
			new twins=get_cvar_num("amx_twins") //get scores
			new ctwins_total=ctfirstround+ctwins //combine scores
			new twins_total=tfirstround+twins //combine scores
			if(ctwins_total==twins_total){ //if tie
				set_hudmessage(255, 255, 255, 0.02, -1.0, 0, 2.0, 4.0, 0.8, 0.8, 1)
				show_hudmessage(0,"TIE - OVERTIME") //
				client_print(0,print_chat,"FOR CAL OVERTIME IS TWO 3-ROUND HALVES")
				client_print(0,print_chat,"GG to all")
				stop_plugin() //stop plugin run
			}
			else{ //they played match out and someone already won
				set_hudmessage(255, 255, 255, 0.02, -1.0, 0, 2.0, 4.0, 0.8, 0.8, 1)
				show_hudmessage(0,"* MATCH OVER *")
				client_print(0,print_chat,"GG to all")
				stop_plugin() //stop plugin run
			}
			if(get_cvar_num("amx_endroundss")){
				new plrs[32],nbr,i,pindex[2]
				get_players(plrs,nbr)
				for(i=0;i<nbr;i++){
					pindex[0]=plrs[i]
					client_cmd(plrs[i],"+showscores")
					set_task(1.0,"screen",0,"pindex",2)
					set_task(2.0,"offscores",0,"pindex",2)
				}
			}
			return PLUGIN_CONTINUE
		}//end of scrimhalf 2 loop
	}//end of winner 0 if loop
	else{ //someone won
		new ctfirstround=get_cvar_num("amx_ctwins_save") //get scores
		new tfirstround=get_cvar_num("amx_twins_save") //get scores
		new ctwins=get_cvar_num("amx_ctwins") //get scores
		new twins=get_cvar_num("amx_twins") //get scores
		new ctwins_total=ctfirstround+ctwins //combine scores
		new twins_total=tfirstround+twins //combine scores
		set_cvar_string("amx_checkwinner","0") //turn off checkwinner - allows play to continue
		if(winner==1){ //if CT's won
			set_hudmessage(255, 255, 255, 0.02, -1.0, 0, 2.0, 6.0, 0.8, 0.8, 1)
			show_hudmessage(0,"Counter-Terrorists Win %i to %i",ctwins_total,twins_total) //score
			set_task(6.0,"free_clients") //unburry clients
		}
		else{ //if T's won
			set_hudmessage(255, 255, 255, 0.02, -1.0, 0, 2.0, 6.0, 0.8, 0.8, 1)
			show_hudmessage(0,"Terrorists Win %i to %i",twins_total,ctwins_total) //score
			set_task(6.0,"free_clients") //unburry clients
		}
		if(get_cvar_num("amx_endroundss")){
				new plrs[32],nbr,i,pindex[2]
				get_players(plrs,nbr)
				for(i=0;i<nbr;i++){
					pindex[0]=plrs[i]
					client_cmd(plrs[i],"+showscores")
					set_task(1.0,"screen",0,"pindex",2)
					set_task(2.0,"offscores",0,"pindex",2)
				}
		}
		return PLUGIN_CONTINUE
	}//end of else
	return PLUGIN_CONTINUE
}

public screen(pindex[]){
	new id=pindex[0]
	client_cmd(id,"snapshot")
	return PLUGIN_CONTINUE
}

public offscores(pindex[]){
	new id=pindex[0]
	client_cmd(id,"-showscores")
	return PLUGIN_CONTINUE
}

public switch_teams(){
	client_print(0,print_chat,"* [AMX SCRIM/MATCH] Switching teams!...")
	set_cvar_string("mp_limitteams","0")
	set_cvar_string("amx_lockteams","0")
	restart_round("1")
	set_task(2.0,"swap") 
	set_task(5.0,"dead_round")
	return PLUGIN_CONTINUE 
}

public swap(){ 
	new playersCT[32] 
	new playersT[32] 
	new nbrCT,nbrT, i
	get_players(playersCT,nbrCT,"e","CT") 
	get_players(playersT,nbrT,"e","TERRORIST") 
	for(i = 0; i < nbrCT; i++) { 
		engclient_cmd(playersCT[i], "chooseteam") 
		engclient_cmd(playersCT[i], "menuselect", "1") 
		client_cmd(playersCT[i], "slot2") 
	} 
	for(i = 0; i < nbrT; i++) { 
		engclient_cmd(playersT[i], "chooseteam") 
		engclient_cmd(playersT[i], "menuselect", "2") 
		client_cmd(playersT[i], "slot2") 
	}
	set_cvar_string("amx_lockteams","1")
	set_cvar_string("mp_limitteams","6")
	restart_round("1")
	return PLUGIN_CONTINUE 
}

public free_clients(){
	new players[32],plrnum, i, origin[3]
	get_players(players,plrnum)
	for(i=0;i<plrnum;i++){
   		get_user_origin(players[i],origin)
   		origin[2] += 50
  		set_user_origin(players[i], origin)
  	}
}

public attempt_switch(id){
	new locked=get_cvar_num("amx_lockteams")
	if(locked)
		return PLUGIN_HANDLED
	else{
		engclient_cmd(id,"chooseteam")
		return PLUGIN_CONTINUE
	}
	return PLUGIN_CONTINUE
}

public restart_round(time[])
{
	server_cmd("sv_restartround %s",time)
	return PLUGIN_CONTINUE
}

public dead_round(){
	set_hudmessage(255, 0, 0, 0.45, 0.3, 0, 2.0, 3.0, 0.8, 0.8, 1)
	show_hudmessage(0,"Dead Rounds Until lo3")
	return PLUGIN_CONTINUE
}

public team_score()
{
	new matchinprogress=get_cvar_num("amx_matchinprogress") //is match going on
	if(!matchinprogress) //if not drops out
		return PLUGIN_CONTINUE
	new team[32]
	read_data(1,team,32)
	if (equal(team,"CT")){
		set_cvar_num("amx_ctwins",read_data(2))
	}
	else if (equal(team,"TERRORIST")){
		set_cvar_num("amx_twins",read_data(2))
	}
	return PLUGIN_CONTINUE
}

public admin_haltmatch(id,level,cid){
	if (!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED
	set_hudmessage(255, 255, 255,0.45, 0.3, 0, 2.0, 3.0, 0.8, 0.8, 1)
	show_hudmessage(0,"* MATCH HALTED *")
	client_print(0,print_chat," ** MATCH HALTED!! **")
	stop_plugin()
	return PLUGIN_HANDLED
}

public stop_plugin(){
	set_cvar_string("amx_matchinprogress","0")
	set_cvar_string("amx_scrimhalf","0")
	set_cvar_string("amx_lockteams","0")
	set_cvar_string("amx_checkwinner","0")
	set_cvar_string("amx_roundnumber","0")
	set_cvar_string("amx_ctwins","0")
	set_cvar_string("amx_twins","0")
	set_cvar_string("amx_ctwins_save","0")
	set_cvar_string("amx_twins_save","0")
	set_cvar_string("amx_officialmatch","0")
	server_cmd("exec server.cfg")
	new usecfgs=get_cvar_num("amx_usecfgs")
	if(usecfgs)
		server_cmd("exec addons/amx/unpauseplugins.cfg")
	return PLUGIN_HANDLED
}

public admin_changeone(id,level,cid){
	if (!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED
	new officialmatch=get_cvar_num("amx_officialmatch")
	if(officialmatch){
		console_print(id,"* It is already an official match")
	}
	else{
		set_cvar_num("amx_officialmatch",1)
		console_print(id,"* Match has been made official")
	}
	return PLUGIN_HANDLED
}

public admin_changezero(id,level,cid){
	if (!cmd_access(id,level,cid,0))
		return PLUGIN_HANDLED
	new officialmatch=get_cvar_num("amx_officialmatch")
	if(!officialmatch){
		console_print(id,"* It is already not an official match")
	}
	else{
		set_cvar_num("amx_officialmatch",0)
		console_print(id,"* Match has been made unofficial")
	}
	return PLUGIN_HANDLED
}

public plugin_init() {
	register_plugin("AMX SCRIM/MATCH","1.1.0","Gevurah")
	register_event("SendAudio","round_end","a","2=%!MRAD_terwin","2=%!MRAD_ctwin","2=%!MRAD_rounddraw")
	register_event("ResetHUD","new_round","abe")
	register_event("TeamScore", "team_score", "a")
	register_clcmd("amx_starthalf","admin_start",ADMIN_LEVEL_A,"amx_starthalf - Executes cal.cfg and automates match")
	register_clcmd("amx_prescrim","admin_setup",ADMIN_LEVEL_A,"amx_prescrim <sv_password> - Pauses other plugins that interfere with matches and sets teams up for DR's")
	register_clcmd("amx_makeofficial","admin_changeone",ADMIN_LEVEL_A,"amx_makeofficial - changes amx_officialmatch cvar so that WONID's are displayed")
	register_clcmd("amx_makeunofficial","admin_changezero",ADMIN_LEVEL_A,"amx_makeunofficial - changes amx_officialmatch cvar so that WONID's are not displayed")
	register_clcmd("amx_haltscrim","admin_haltmatch",ADMIN_LEVEL_A,"amx_haltscrim - ends match and resets server settings")
	register_clcmd("chooseteam","attempt_switch") 
	register_cvar("amx_officialmatch","0") 
	register_cvar("amx_winslimit","12") 
	register_cvar("amx_scrimhalf","0") 
	register_cvar("amx_matchinprogress","0") 
	register_cvar("amx_roundnumber","0") 
	register_cvar("amx_ctwins","0") 
	register_cvar("amx_twins","0")
	register_cvar("amx_halflength","12") 
	register_cvar("amx_ctwins_save","0") 
	register_cvar("amx_twins_save","0") 
	register_cvar("amx_lockteams","0") 
	register_cvar("amx_checkwinner","1")
	register_cvar("amx_usecfgs","0")
	register_cvar("amx_endroundss","0")
	return PLUGIN_CONTINUE
}
