/* (C)1995-2003 The TCW Organization and David "BAILOPAN" Anderson
 * bail_register.sma
 * Allows for servers to require user registration.
 * Creation: 12-07-2003, Last Modify: 12-07-2003
 * http://www.tcwonline.org/ - http://lambda.tcwonline.org/
 * This is written under the GNU General Public License, version 2.
 * Give credit where due.  Share the source - it sets you free.
 */
 
//This is my second plugin.
//Please tell me if you found this useful! I'd love to hear feedback.
//dvander@tcwonline.org (Please do not email me for requests - use amx forums)
new PLUGINNAME[] = "Bail's Register"
new VERSION[] = "1.00"
new BUILD_VERSION[] = "011"
new AUTHOR[] = "BAILOPAN"

#define MAX_TEXT_LENGTH 192
#define MAX_INFO_LENGTH 32
#define MAX_NAME_LENGTH 32

#include <amxmod>
#include <amxmisc>
#include <mysql>

//Stores player uids from mysql
new PLAYERS[32]
//Stores player usernames from mysql
new USERNAMES[32][MAX_INFO_LENGTH]
//store connection

public plugin_init()
{
	register_plugin(PLUGINNAME, VERSION, AUTHOR)
	register_concmd("breg_version", "breg_version", 0, "Shows BREG version.")
	register_concmd("breg_ban", "breg_ban", ADMIN_BAN, "Bans a registered user")
	register_concmd("breg_info", "breg_info", 0, "Shows info about a user")
	register_cvar("amx_mysql_host","127.0.0.1")
	register_cvar("amx_mysql_user","root")
	register_cvar("amx_mysql_pass","")
	register_cvar("amx_mysql_db","amx")
	register_cvar("amx_breg_addy","www.mysite.com")
	register_cvar("amx_breg_email","myemail@addy.com")	
	
	return PLUGIN_CONTINUE
}

bool:is_banned(IP[])
{
	new mysql
	new Query[128], error[128]
	new sBan[3], ban
	format(Query, 127, "SELECT banned FROM amx_users WHERE ipaddr='%s'", IP)
	mysql = lease_sql()
	if (mysql_query(mysql, Query) < 1) {
		mysql_error(mysql, error, 127)
		log_message("[PBREG]: MySQL error on query: '%s'", error)
		log_message("[PBREG]: MySQL error on '%s'", Query)
	}
	if (mysql_nextrow(mysql)>0) {
		mysql_getfield(mysql, 1, sBan, 2)
		mysql_close(mysql)
		ban = strtonum(sBan)
		if (ban) {
			return true
		} else {
			return false
		}
	} else {
		mysql_close(mysql)
		return false
	}

	return false
}

public breg_info(id, level, cid)
{
	if (!cmd_access(id,level,cid,2)) {
		return PLUGIN_HANDLED
	}
	new arg[32]
	read_argv(1,arg,31)
	new player = cmd_target(id,arg,5)
	if (!player) {
		console_print(id, "[BREG] Player not found.")
		return PLUGIN_HANDLED
	}
	
	console_print(id, "[BREG] UserID is %d, Username is '%s'", PLAYERS[player], USERNAMES[player])
	
	return 1
}

public breg_ban(id, level, cid)
{
	new mysql
	if (!cmd_access(id,level,cid,2)) {
		return PLUGIN_HANDLED
	}
	new arg[32]
	read_argv(1,arg,31)
	new player = cmd_target(id,arg,5)
	if (!player) {
		return PLUGIN_HANDLED
	}

	new Email[MAX_TEXT_LENGTH]
	new Site[MAX_TEXT_LENGTH]	
	get_cvar_string("amx_breg_email", Email, MAX_TEXT_LENGTH-1)
	get_cvar_string("amx_breg_addy", Site, MAX_TEXT_LENGTH-1)	
	new Query[128], uid
	uid = PLAYERS[player]
	
	if (!uid) {
		//What happened here?!
		client_cmd(id, "echo Sorry but to play on this server you must register first.")
		client_cmd(id, "echo You may register at %s", Site)
		client_cmd(id, "echo Contact %s for more info", Email)
		client_cmd(id, "toggleconsole;disconnect")
	} else {
		mysql = lease_sql()
		format(Query, 127, "UPDATE amx_users SET banned = 1 WHERE uid = %d", uid)
		mysql_query(mysql, Query)
		log_message("[BREG] Banned user id '%d', username '%s'", uid, USERNAMES[uid])
		client_cmd(player, "echo Sorry but your IP has been banned.")
		client_cmd(player, "echo Contact %s or visit %s for more info.", Email, Site)
		client_cmd(player, "toggleconsole;disconnect")		
		mysql_close(mysql)
	}
	
	return true
}

public breg_version(id, level, cid)
{
	console_print(id, "[BREG]: %s by %s.  Version %s, build %s", PLUGINNAME, AUTHOR, VERSION, BUILD_VERSION)
}

public client_disconnect(id)
{
	PLAYERS[id] = 0
	copy(USERNAMES[id], 31, "")
}

public client_connect(id)
{
	new IP[MAX_INFO_LENGTH]
	new Query[MAX_TEXT_LENGTH]
	new Email[MAX_TEXT_LENGTH]
	new Site[MAX_TEXT_LENGTH]
	new error[128]
	new mysql

	get_cvar_string("amx_breg_email", Email, MAX_TEXT_LENGTH-1)
	get_cvar_string("amx_breg_addy", Site, MAX_TEXT_LENGTH-1)	
	get_user_ip(id, IP, MAX_INFO_LENGTH-1, 1)
	format(Query, MAX_TEXT_LENGTH-1, "SELECT uid,username FROM amx_users WHERE ipaddr='%s' AND banned = 0", IP)
	server_print("BREG=>Query='%s'", Query)
	PLAYERS[id] = 0
	copy(USERNAMES[id], 31, "")
	
	if (is_banned(IP)) {
		client_cmd(id, "echo Sorry but your IP has been banned.")
		client_cmd(id, "echo Contact %s or visit %s for more info.", Email, Site)
		client_cmd(id, "toggleconsole;disconnect")	
		mysql_close(mysql)
		
		return PLUGIN_CONTINUE
	}
	
	mysql = lease_sql()	

	if (mysql_query(mysql, Query) < 1) {
		mysql_error(mysql, error, 127)
		log_message("[PBREG]: MySQL error on query: '%s'", error)
		log_message("[PBREG]: MySQL error on '%s'", Query)
	}
	
	new user_name[32]
	new user_uid[32]
		
	
	if (mysql_nextrow(mysql) > 0) {
		mysql_getfield(mysql, 1, user_uid, 31)
		server_print("BREG=> user_uid=%s", user_uid)
		mysql_getfield(mysql, 2, user_name, 31)
		server_print("BREG=> user_uname=%s", user_name)
		PLAYERS[id] = strtonum(user_uid)
		copy(USERNAMES[id], 31, user_name)
	}
		
	if (!PLAYERS[id]) {
		client_cmd(id, "echo Sorry but to play on this server you must register first.")
		client_cmd(id, "echo You may register at %s", Site)
		client_cmd(id, "echo Contact %s for more info", Email)
		client_cmd(id, "toggleconsole;disconnect")
	} else {
		log_message("[BREG] Authorized user ^"%s^" with UserID <%d>", USERNAMES[id], PLAYERS[id])
		new info[2]
		info[0] = id
		set_task(60.0, "show_user_info", 13370+id, info, 2)
	}
	
	mysql_close(mysql)	
	
	return PLUGIN_CONTINUE
}

public show_user_info(info[])
{
	new uname[32]
	new uid
	uid = info[0]
	
	get_user_name(uid, uname, 32)
	
	client_print(0, print_chat, "[BREG] Player ^"%s^" has been verified as a registered user.", uname)
	client_print(0, print_chat, "[BREG] ^"%s^": Username %s, UserID %d", uname, USERNAMES[uid], PLAYERS[uid])
	
	return PLUGIN_CONTINUE
}

lease_sql()
{
	new mysql
	new host[64],user[32],pass[32],db[32],error[128]	
	
	get_cvar_string("amx_mysql_host",host,63)
	get_cvar_string("amx_mysql_user",user,31)
	get_cvar_string("amx_mysql_pass",pass,31)
	get_cvar_string("amx_mysql_db",db,31)
	mysql = mysql_connect(host, user, pass, db, error, 127)
	
	if (mysql < 1) {
		log_message("[PBSTATS]: MySQL error on connect: '%s'", error)
		
		return 0
	}
	
	return mysql
}
