/* AMXMOD script.
*
* Bank Deposit (c) Copyright 2003, Phreak
* This file is provided as is (no warranties).
*
* You can save money to a bank account and retrieve it after mapchange.
*
* Usage:
*  say savecash <amount>   : put <amount>on your account
*  say checkcash           : check how many you have on your account
*  say getcash <amount>    : retrieve <amount> from your account
*
* Settings:
* There are two CVARs to control the plugin.
*  - "amx_bank_maplimit"    controls how many you can retrieve in one map
*                           (default 5000)
*  - "amx_bank_minplayer"   controls how many player must be playing on
*                           the server to be able to use the bank (default 2)
*
* You need amx 0.9.4 or higher or 0.9.3 with the vault module
* installed to use the plugin.
*
*/

#include <amxmod>
#include <fun>

new paylimit
new paid[33]

public deposit(id) {
new args[32],first[16],samount[16],amount=0
new key[64],deposited = 0,data[32],authid[16]
read_argv(1,args,31)
parse(args,first,15,samount,15)
amount = strtonum(samount)
paylimit = get_cvar_num("amx_bank_maplimit");
if ((equali(first,"savecash",9) || equali(first,"getcash",9) ||
equali(first,"checkcash",9)) && get_playersnum()<get_cvar_num("amx_bank_minplayer")) {
client_print(id,print_chat,"[AMX] There are not enough players on the server to use the bank account.")
return PLUGIN_HANDLED
}
get_user_authid(id,authid,15)
format(key,63,"bankdeposit/%s",authid)
get_vaultdata(key, data, 31)
deposited = strtonum(data)
if (equali(first,"savecash",9)) {
client_print(id,print_chat,"[AMX] Saving %d$ to your bank account",amount)
set_user_money(id,max(get_user_money(id)-amount,0))
deposited += amount
format(data,31,"%d",deposited)
set_vaultdata(key,data);
return PLUGIN_HANDLED
}
if (equali(first,"checkcash",9)) {
client_print(id,print_chat,"[AMX] Your current amount is %d$",deposited)
return PLUGIN_HANDLED
}
if (equali(first,"getcash",9)) {
if ((paid[id]+amount)>paylimit) {
client_print(id,print_chat,"[AMX] You can only get %d$ per map",paylimit)
return PLUGIN_HANDLED
}
if (deposited<amount) {
client_print(id,print_chat,"[AMX] You have only %d$ on your account",deposited)
return PLUGIN_HANDLED
}
paid[id] += amount
set_user_money(id,max(get_user_money(id)+amount,0))
deposited -= amount
format(data,31,"%d",deposited)
set_vaultdata(key,data);
return PLUGIN_HANDLED
}
return PLUGIN_CONTINUE
}   

public plugin_init()   
{
	register_plugin("Bank Deposit","0.1","Phreak")
	register_clcmd("say","deposit")
	register_cvar("amx_bank_maplimit","5000");
	register_cvar("amx_bank_minplayer","2");
	return PLUGIN_CONTINUE
} 
