/* 
* AMX Mod Script 
* 
* Server & Client Match Rate v1.0 - Made by Calzinger
*                                   Requested by AClockworkOrange 
* This file is provided as is (no warranties). 
* 
* CVARs: 
*  cal_matchrate_announce 1/0 -> On/Off to display motd to warn clients on connect
*  sv_maxrate x -> Set maxrate (plugin will read) (clients will match this value) 
*  sv_minrate x -> Set minrate (plugin will read) (clients will match this value) 
* 
* Updates:
*  v1.0 - 
*    [BUILD] 
*
*/

#include <amxmod> 
#include <amxmisc> 

public client_connect(id) { 

   new maxrate = get_cvar_num("sv_maxrate") 
   new minrate = get_cvar_num("sv_minrate") 

   client_cmd(id,"sv_maxrate %s",maxrate) 
   client_cmd(id,"sv minrate %s",minrate) 

   if (get_cvar_num("cal_matchrate_announce") != 0) { 
      client_cmd(id,"echo ^"^"") 
      client_cmd(id,"echo ^"========================================================================^"") 
      client_cmd(id,"echo ^" This server is ordering consistency in sv_maxrate and sv_minrate.      ^"") 
      client_cmd(id,"echo ^" If you do not agree to this, please disconnect now.                    ^"") 
      client_cmd(id,"echo ^"========================================================================^"") 
      client_cmd(id,"echo ^"^"") 
   } 

} 

public consistency() { 
   new all[32], all_num 
   get_players(all,all_num) 

   new maxrate = get_cvar_num("sv_maxrate") 
   new minrate = get_cvar_num("sv_minrate") 

   for (new i=0;i < all_num;i++) { 
      client_cmd(all[i],"sv_maxrate %s",maxrate) 
      client_cmd(all[i],"sv_minrate %s",minrate) 
   } 
   return   PLUGIN_CONTINUE
} 

public plugin_init() { 
   register_plugin("Server & Client Match Rate","1.0","Calzinger") 
   register_cvar("cal_matchrate_announce","1") 
   set_task(5.0,"consistency",0,"",0,"b") 
   return   PLUGIN_CONTINUE 
} 
