/*
* AMX Mod Script
*
* Unique Damage v2.0 - Made by Calzinger
* This file is provided as is (no warranties). 
*
* CVARs: 
*  cal_uniquedamage 1/0 <- On/Off (called on new round) 
*  cal_colorfade 1/0 <- Enables unique color fading when damage is registered 
*  cal_leech x <- Enables leech. Value will multiply the amount of damage
*    Example: cal_leech "2" will double the amount of damage (3 damage with glock; I get 6 hp).
*
* Updates: 
*  v2.0 - 
*    [ADDED] - Leech ability
*  v1.2 - 
*    [FIXED] - Mistaken fades of only red. Should work properly now
*                (Thanks IceMouse) 
*  v1.1 - 
*    [FIXED] - Crashes when c4 explodes or grenade damages multiple targets
*                (Thanks Scarzzurs) 
*  v1.0 - 
*    BUILD
*/

#include <amxmod> 
#include <amxmisc> 
#include <fun>

new colorfade 

public damage_occur(id) { 
   new attacker = get_user_attacker(id) 
   new damage = read_data(2) 


   if (get_cvar_num("cal_colorfade") != 0) { 

      if (attacker <= 32 && attacker >= 1) { 
         message_begin(MSG_ONE,colorfade,{0,0,0},attacker) 
         write_short( 1<<10 ) 
         write_short( 1<<10 ) 
         write_short( 1<<12 ) 
         write_byte( 0 ) 
         write_byte( 0 ) 
         write_byte( 255 ) 
         write_byte( 100 ) 
         message_end() 
      } 

      if (id <= 32 && id >= 1) { 
         message_begin(MSG_ONE,colorfade,{0,0,0},id) 
         write_short( 1<<10 ) 
         write_short( 1<<10 ) 
         write_short( 1<<12 ) 
         write_byte( 255 ) 
         write_byte( 0 ) 
         write_byte( 0 ) 
         write_byte( 100 ) 
         message_end() 
      } 
   } 

   set_hudmessage(0,255,0,0.55,0.50,2,0.1,4.0,0.1,0.1,7) 
   show_hudmessage(attacker,"%i",damage) 

   set_hudmessage(255,0,0,0.45,0.50,2,0.1,4.0,0.1,0.1,8) 
   show_hudmessage(id,"%i",damage) 

   new health = get_user_health(attacker) 
   new leech = get_cvar_num("cal_leech") * damage
   set_user_health(attacker,health + leech) 

   return   PLUGIN_CONTINUE 
} 

public round_start(id) { 
   if (get_cvar_num("cal_uniquedamage") == 0) { 
      pause("a") 
   } 
   return   PLUGIN_CONTINUE 
} 

public plugin_init() { 
   register_plugin("Unique Damage","2.0","Calzinger") 
   register_event("Damage","damage_occur","b","2!0","3=0","4!0") 
   register_event("ResetHUD","round_start","b") 
   register_cvar("cal_colorfade","1") 
   register_cvar("cal_uniquedamage","1") 
   register_cvar("cal_leech","0") 

   colorfade = get_user_msgid("ScreenFade") 

   return   PLUGIN_CONTINUE 
} 
