/* AMX Mod script.
*
* CovertOps (c) 2003, Phreak
* inspired by Krypt-Keep3r
* This file is provided as is (no warranties).
*
* Usage:
*   The Players can use "say_team getclothes" to steal the clothes from
*   corpses. 
*   After round end all models are turned back to normal.
*
* Setup:
*   CovertOps can be disabled by setting amx_covertops to 0
*   The vexed module is required to run the plugin.
*
* Known Bugs:
*   After been switched to the other team (for example by a team balancer)
*   You will get the model you've used in your old team.
*
* Version history:
*   v0.2a
*   - increased array size
*   v0.2
*   - added sound when taking clothes
*   - clothes can only be taken one time per round
*   v0.1
*   - initial version
*/

#include <amxmod>
#include <Vexd_Utilities>

new pl_origins[33][3]
new pl_skins[33][32]
new bool:pl_carmouflaged[33] = {false,...}
new bool:pl_taken[33] = {false,...}

public get_clothes(id) {
	if (get_cvar_num("amx_covertops")==0)
		return PLUGIN_HANDLED
	if (!is_user_alive(id))
		return PLUGIN_HANDLED
	new cur_origin[3],players[32],pl_num=0,dist,last_dist=99999,last_id,model[32]
	get_user_origin(id,cur_origin,0)
	get_players(players,pl_num,"b")
	if (pl_num>0) {
		for (new i=0;i<pl_num;i++) {
			if (players[i]!=id) {
				dist = get_distance(cur_origin,pl_origins[players[i]])
				if (dist<last_dist) {
					last_id = players[i]
					last_dist = dist
				}
			}
		}
		if (last_dist<80) {
			if (pl_taken[last_id]) {
				client_print(id,print_chat,"These clothes have already been taken.")
				return PLUGIN_CONTINUE
			}
			get_user_info(last_id,"model",model,31)
			get_user_info(id,"model",pl_skins[id],31)
			CS_SetModel(id, model)
			pl_carmouflaged[id] = true
			pl_taken[last_id] = true
	 		emit_sound(id,CHAN_VOICE,"items/tr_kevlar.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			client_print(id,print_chat,"You are now looking like a %s",model)
			return PLUGIN_CONTINUE
		}
	}
	client_print(id,print_chat,"There is no corpse nearby to get clothes from")
	return PLUGIN_CONTINUE
}

public player_die() {
	new victim = read_data(2)
	get_user_origin(victim,pl_origins[victim],0)
	if (pl_carmouflaged[victim]) {
		CS_SetModel(victim, pl_skins[victim])
	}
	return PLUGIN_CONTINUE
}

public new_round(id){ 
	if (pl_carmouflaged[id]) {
		CS_SetModel(id, pl_skins[id])
		pl_carmouflaged[id] = false
	} else {
		get_user_info(id,"model",pl_skins[id],31)
	}
	pl_taken[id] = false
	return PLUGIN_CONTINUE
}

public plugin_precache(){
	precache_sound( "items/tr_kevlar.wav")
	return PLUGIN_CONTINUE
} 

public plugin_init()
{
	register_plugin("CovertOps","0.2a","Phreak")
	register_clcmd("say_team getclothes","get_clothes")
	register_event("ResetHUD", "new_round", "b")
	register_event("DeathMsg","player_die","a")
	register_cvar("amx_covertops","1")
	return PLUGIN_CONTINUE
}
