/* AMXMOD script. 
* 
* Copyright (c) 2003, Ryan D Kneeshaw (a.k.a. TheShaft)
* Server Op from FrankensteinCS (http://www.frankensteincs.com)
* Much thanks to JustinHomi of the AMX Mod team!!!
* This file is provided as is (no warranties). 
* 
* Ultimate Friendly-Fire Control
* 
* Changelog:
*  1.5  -  Optimized TA and TK functions for better performance
*          Modified /forgive command.
*          Modified /attackers command.
*  1.43 -  Added /attacker say command to display your last team-attacker
*          Removed logpath cvar, logs are automaticly placed in addons/amx/logs
*  1.42 -  Fixed team attacker history not properly resetting upon disconnect
*          Set thunder.wav to be played to everyone on server when user is slayed
*          Changed round_start detection for less CPU usage
*  1.41 -  Fixed users not getting banned due to truncated SteamID
*          Fixed run time error 4 messages in HLDS logs
*          Various code tweaks to improve performance
*  1.4  -  Replaced forgive commands with a single /forgive menu
*  1.33 -  Added uffc_logpath cvar
*  1.32 -  Removed /attackers command (1.6 compatability issue)
*          Replaced /livestatus with a /mystatus command (1.6 compatability issue)
*  1.31 -  Updated to make Steam compatable
*          Turned off livestatus by default due to lack of support in CS 1.6
*  1.3	-  Changed warnings and alerts to begin with [UFFC]
*          Redesigned /forgive functions
*          Re-Added support to store TA's and TK's on disconnect
*  1.21 -  Temporary fix of memory leak
*          Added /ff say command
*          Fixed wrong version number
*  1.2  -  Code tweaks to reduce CPU overhead
*          Added support to store TA's on disconnect (does NOT store over mapchanges)
*  1.1  -  Added say command advertisement
*          Changed /whotkedme to /attackers
*  1.0  -  Initial Release
*/ 

#include <amxmod>
#include <amxmisc>


new TK[33] /* TK Count for players */
new lastTKer[33]
new TA[33] /* TA Count for players */
new lastTAer[33]
new bool:taroundstart = false 
new bool:tkroundstart = false
new saved[200][26] /* Saved TA and TK counts */
new savedcount = 0
new logfilename[64]

new tacounts1
new tacounts2
new tacounts3
new tacounts4
new tapenalty1[12]
new tapenalty2[12]
new tapenalty3[12]
new tapenalty4[12]
new tabantime
new Float:taroundlimit
new taroundpenalty
new taforgive

new tkcounts1
new tkcounts2
new tkcounts3
new tkcounts4
new tkpenalty1[12]
new tkpenalty2[12]
new tkpenalty3[12]
new tkpenalty4[12]
new tkbantime
new Float:tkroundlimit
new tkroundpenalty
new tkforgive


/***********************************  TA FUNCTIONS *********************************/

public event_Damage(vIndex) 
	{ 
	new aIndex = get_user_attacker(vIndex)
	if ( get_user_team(aIndex) == get_user_team(vIndex) ) 
		{
		if ( aIndex && vIndex != aIndex )  
			{
			new repeat = 1
			if (taroundstart && taroundpenalty > 0)
				repeat = taroundpenalty
			for (new i=1; i <= repeat; ++i)
				{
				TA[aIndex]++
				//check to see if they need to be punished
				new penalty[12]
				if (TA[aIndex] == tacounts4 && tacounts4 > 0) 
					{
					copy(penalty,11,tapenalty4)
					punish_ta(aIndex,penalty)
					}
				else if (TA[aIndex] == tacounts3 && tacounts3 > 0) 
					{
					copy(penalty,11,tapenalty3)
					punish_ta(aIndex,penalty)
					}
				else if (TA[aIndex] == tacounts2 && tacounts2 > 0) 
					{
					copy(penalty,11,tapenalty2)
					punish_ta(aIndex,penalty)
					}
				else if (TA[aIndex] == tacounts1 && tacounts1 > 0) 
					{
					copy(penalty,11,tapenalty1)
					punish_ta(aIndex,penalty)
					}
				}
			lastTAer[vIndex] = aIndex				
			//Get number of tas or tks before next punish level for warning message
			new maxta = 0
			new warnings = 0
			new nextpenalty[12]
			new aName[32]
			if (TA[aIndex] >= tacounts3 && tacounts4 > 0) 
				{
				maxta = tacounts4
				copy(nextpenalty,11,tapenalty4)
				}
			else if (TA[aIndex] >= tacounts2 && tacounts3 > 0) 
				{
				maxta = tacounts3
				copy(nextpenalty,11,tapenalty3)
				}
			else if (TA[aIndex] >= tacounts1 && tacounts2 > 0) 
				{
				maxta = tacounts2
				copy(nextpenalty,11,tapenalty2)
				}
			else 
				{
				maxta = tacounts1
				copy(nextpenalty,11,tapenalty1)
				}
			warnings = (maxta - TA[aIndex])
			get_user_name(aIndex,aName,31)
			client_print(aIndex,print_chat,"[UFFC] Please DO NOT ATTACK teammates! You have %i more warnings before %s.",warnings,nextpenalty)
			}
		}
	return PLUGIN_HANDLED
	}

punish_ta(aIndex,penalty[]) 
	{
	new aName[32]
	new aAuthid[20]
	get_user_name(aIndex,aName,31)
	get_user_authid(aIndex,aAuthid,19)
	if (containi(penalty,"slap") != -1)
		{
		slap(aIndex)
		client_print(0,print_chat,"* [UFFC] %s has been slapped for %i TEAM ATTACKS",aName,TA[aIndex])
		}
	if (containi(penalty,"slay") != -1)
		{
		slay(aIndex)
		client_print(0,print_chat,"* [UFFC] %s has been slayed for %i TEAM ATTACKS",aName,TA[aIndex])
		}
	if (containi(penalty,"kick") != -1) 
		{
		client_print(aIndex,print_console,"You have been kicked for %i TEAM ATTACKS",TA[aIndex])
		client_print(0,print_chat,"* [UFFC] %s has been kicked for %i TEAM ATTACKS",aName,TA[aIndex])
		log_to_file(logfilename,"^"%s<%s>^" ^" kicked for %i team attacks^" ",aName,aAuthid,TA[aIndex])
		server_cmd("kick #%d",get_user_userid(aIndex))
		}
	if (containi(penalty,"ban") != -1) 
		{
		client_print(aIndex,print_console,"You have been banned for %i minutes for %i TEAM ATTACKS",tabantime,TA[aIndex])
		client_print(0,print_chat,"* [UFFC] %s has been banned for %i minutes for %i TEAM ATTACKS",aName,tabantime,TA[aIndex])
		log_to_file(logfilename,"^"%s<%s>^" ^" banned for %i minutes for %i team attacks^" ",aName,aAuthid,tabantime,TA[aIndex])
		// CUSTOM FCS MODIFICATION
		new logdata[256]
		new thedate[64]
		get_time("%m/%d/%y %H:%M:%S",thedate,63)
		format(logdata,255,"%s - %s<%s> was banned by UFFC for %i minutes. Reason:^"%i team-attacks^"",
			thedate, aName, aAuthid, tabantime,TA[aIndex])
  		write_file("logs/banned.log",logdata,-1)
  		// END CUSTOM MODIFICATION
  		server_cmd("banid %i %s kick;wait;writeid",tabantime,aAuthid)
		}	
	}


/**********************************  TK FUNCTIONS *********************************/

public event_Death(id) 
	{		
	new kIndex = read_data(1)
	new vIndex = read_data(2)
	if ( get_user_team(kIndex) == get_user_team(vIndex) )
		{
		if ( kIndex && kIndex != vIndex ) 
			{
			new repeat = 1
			if (tkroundstart && tkroundpenalty > 0)
				repeat = tkroundpenalty
			for (new e=1; e <= repeat; ++e)
				{
				TK[kIndex]++
				//check to see if they need to be punished
				new penalty[12]
				if (TK[kIndex] == tkcounts4 && tkcounts4 > 0) 
					{
					copy(penalty,11,tkpenalty4)
					punish_tk(kIndex,penalty)
					}
				else if (TK[kIndex] == tkcounts3 && tkcounts3 > 0) 
					{
					copy(penalty,11,tkpenalty3)
					punish_tk(kIndex,penalty)
					}
				else if (TK[kIndex] == tkcounts2 && tkcounts2 > 0) 
					{
					copy(penalty,11,tkpenalty2)
					punish_tk(kIndex,penalty)
					}
				else if (TK[kIndex] == tkcounts1 && tkcounts1 > 0) 
					{
					copy(penalty,11,tkpenalty1)
					punish_tk(kIndex,penalty)
					}	
				}
			lastTKer[vIndex] = kIndex
			//Get number of ta/tks before next punish level for warning message
			new maxtk = 0
			new warnings = 0
			new nextpenalty[12]
			new kName[32]
			if (TK[kIndex] >= tkcounts3 && tkcounts4 > 0) 
				{
				maxtk = tkcounts4
				copy(nextpenalty,11,tkpenalty4)
				}
			else if (TK[kIndex] >= tkcounts2 && tkcounts3 > 0) 
				{
				maxtk = tkcounts3
				copy(nextpenalty,11,tkpenalty3)
				}
			else if (TK[kIndex] >= tkcounts1 && tkcounts2 > 0)
				{
				maxtk = tkcounts2
				copy(nextpenalty,11,tkpenalty2)
				}
			else 
				{
				maxtk = tkcounts1
				copy(nextpenalty,11,tkpenalty1)
				}
			warnings = (maxtk - TK[kIndex])
			get_user_name(kIndex,kName,31)
			client_print(kIndex,print_chat,"[UFFC] Please DO NOT KILL teammates! You have %i more TK warnings before %s.",warnings,nextpenalty)
			}
		}
	return PLUGIN_HANDLED
	}

punish_tk(kIndex,penalty[]) 
	{
	new kName[32]
	new kAuthid[20]		
	get_user_name(kIndex,kName,31)
	get_user_authid(kIndex,kAuthid,19)	
	if (containi(penalty,"slap") != -1)
		{
		slap(kIndex)
		client_print(0,print_chat,"* [UFFC] %s has been slapped for %i TEAM KILLS",kName,TK[kIndex])
		}
	if (containi(penalty,"slay") != -1)
		{
		slay(kIndex)
		client_print(0,print_chat,"* [UFFC] %s has been slayed for %i TEAM KILLS",kName,TK[kIndex])
		}
	if (containi(penalty,"kick") != -1) 
		{
		client_print(kIndex,print_console,"You have been kicked for %i TEAM KILLS",TK[kIndex])
		client_print(0,print_chat,"* [UFFC] %s has been kicked for %i TEAM KILLS",kName,TK[kIndex])
		log_to_file(logfilename,"^"%s<%s>^" ^" kicked for %i Team Kills^" ",kName,kAuthid,TK[kIndex])
		server_cmd("kick #%d",get_user_userid(kIndex))
		}
	if (containi(penalty,"ban") != -1) 
		{
		client_print(kIndex,print_console,"You have been banned for %i minutes for %i TEAM KILLS",tkbantime,TK[kIndex])
		client_print(0,print_chat,"* [UFFC] %s has been banned for %i minutes for %i TEAM KILLS",kName,tkbantime,TK[kIndex])
		log_to_file(logfilename,"^"%s<%s>^" ^" banned for %i minutes for %i Team Kills^" ",kName,kAuthid,tkbantime,TK[kIndex])
		// CUSTOM FCS MODIFICATION
		new logdata[256]
		new thedate[64]
		get_time("%m/%d/%y %H:%M:%S",thedate,63)
		format(logdata,255,"%s - %s<%s> was banned by UFFC for %i minutes. Reason:^"%i team-kill(s)^"",
			thedate, kName, kAuthid, tkbantime,TK[kIndex])
  		write_file("logs/banned.log",logdata,-1)
  		// END CUSTOM MODIFICATION
		server_cmd("banid %i %s kick;wait;writeid",tkbantime,kAuthid)
		}	
	}


/**********************************  SLAP/SLAY FUNCTIONS ********************************/

public slap(id)
	{
	if (is_user_alive(id))
		if(get_user_health(id) <= 5)
			user_slap(id, 0)
		else
			user_slap(id, 5)
	return PLUGIN_HANDLED 
	}

public slay(id)
	{
	if (is_user_alive(id))
		{
		emit_sound(0,CHAN_ITEM, "ambience/thunder_clap.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		user_kill(id,1)
		}
	return PLUGIN_HANDLED 
	}


/****************************** CLIENT FUNCTIONS *****************************/

public advertise()
	client_print(0,print_chat,"* [UFFC] Say commands: /forgive /attacker /mystatus /ff")

public actionMenu(id,key)
	{
	switch(key)
		{
		case 0:
			{
			if (taforgive == 1)
				{
				//Forgive the person who TA'd you last
				new aName[32], vName[32], aIndex
				aIndex = lastTAer[id]
				if (aIndex > 0)
					{
					get_user_name(aIndex,aName,31)
					get_user_name(id,vName,31)
					client_print(0,print_chat,"* [UFFC] %s has forgiven %s for %i Team Attack(s)",vName,aName,TA[aIndex])
					TA[aIndex] = 0
					lastTAer[id] = 0
					}
				}
			else
				client_print(id,print_chat,"[UFFC] ForgiveTA function is currently disabled.")
		
			}
		case 1:
			{
			if (tkforgive == 1)
				{
				//Forgive the person who TK'd you last
				new kName[32], vName[32], kIndex
				kIndex = lastTKer[id]
				if (kIndex > 0)
					{
					get_user_name(kIndex,kName,31)
					get_user_name(id,vName,31)
					client_print(0,print_chat,"* [UFFC] %s has forgiven %s for %i Team Kill(s)",vName,kName,TK[kIndex])
					TK[kIndex] = 0
					lastTKer[id] = 0
					}
				}
			else
				client_print(id,print_chat,"[UFFC] ForgiveTK function is currently disabled.")
			}
		case 2:
			{
			if (taforgive == 1 && tkforgive == 1)
				{
				new kName[32], vName[32], kIndex
				kIndex = lastTKer[id]
				get_user_name(id,vName,31)
				if (kIndex > 0)
					{
					get_user_name(kIndex,kName,31)
					client_print(0,print_chat,"* [UFFC] %s has forgiven %s for %i Team Kill(s) AND %i Team Attack(s)",vName,kName,TK[kIndex],TA[kIndex])
					TA[kIndex] = 0
					TK[kIndex] = 0
					lastTAer[id] = 0
					lastTKer[id] = 0
					}
				}
			else
				client_print(id,print_chat,"[UFFC] ForgiveTA or ForgiveTK function is currently disabled.")
			}
		}
	return PLUGIN_HANDLED
	}


public showMenu(id,level,cid)
	{
	new tkid, taid
	taid = lastTAer[id]
	tkid = lastTKer[id]
	if (TA[taid] > 0 || TK[tkid] > 0)
		{
		new menuBody[512], aName[32], kName[32]
 		new len = format(menuBody,511,"\yForgive Menu\R^n^n\w")
 		get_user_name(taid,aName,31)
 		get_user_name(tkid,kName,31)
 		if (TA[taid] > 0)
 			len += format(menuBody[len],511-len,"1. Forgive %s for TeamAttack(s)^n",aName)
 		else
 			len += format(menuBody[len],511-len,"^n")
 		if (TK[tkid] > 0)
 			len += format(menuBody[len],511-len,"2. Forgive %s for TeamKill(s)^n",kName)	
 		else
 			len += format(menuBody[len],511-len,"^n")
 		if (TA[tkid] > 0 && TK[tkid] > 0 && tkid == taid)
 			len += format(menuBody[len],511-len,"3. Forgive Both^n")	
		else
 			len += format(menuBody[len],511-len,"^n")
 		len += format(menuBody[len],511-len,"^n0. Cancel")
 		show_menu(id,((1<<0)|(1<<1)|(1<<2)|(1<<9)),menuBody)
 		}
 	else
 		client_print(id,print_chat,"[UFFC] There are no TA's or TK's that you can forgive")
	
	return PLUGIN_HANDLED
	}

public say_attacker(id)
	{
	if (lastTAer[id] > 0)
		{
		new aName[32]
		get_user_name(lastTAer[id],aName,31)
		client_print(id,print_chat,"[UFFC] Your last team-attacker was: %s",aName)
		client_print(id,print_chat,"[UFFC] You can forgive your last team-attacker by saying /forgive")
		}
	else
		client_print(id,print_chat,"[UFFC] Could not find a teammate that has attacked you.")
	return PLUGIN_HANDLED
	}

public say_ff(id)
	{
	new ff = get_cvar_num("mp_friendlyfire")
	if (ff == 1)
		client_print(id,print_chat,"[AMX] Friendly fire is ON")
	else if (ff == 0)
		client_print(id,print_chat,"[AMX] Friendly fire is OFF")
	return PLUGIN_HANDLED
	}

public say_mystatus(id)
	{
	if (is_user_bot(id) || id==0)
		return PLUGIN_HANDLED
	
	new maxta = 0
	new maxtk = 0
	if (TA[id] >= tacounts3)
		maxta = tacounts4
	else if (TA[id] >= tacounts2)
		maxta = tacounts3
	else if (TA[id] >= tacounts1)
		maxta = tacounts2
	else
		maxta = tacounts1
	if (TK[id] >= tkcounts3)
		maxtk = tkcounts4
	else if (TK[id] >= tkcounts2)
		maxtk = tkcounts3
	else if (TK[id] >= tkcounts1)
		maxtk = tkcounts2
	else
	maxtk = tkcounts1
	client_print(id,print_chat,"[UFFC] TeamKills: %i/%i TeamAttacks: %i/%i",TK[id],maxtk,TA[id],maxta)
	
	return PLUGIN_HANDLED	
	}


/*******************************  START ROUND FUNCTIONS ****************************/

public event_newround()
	{
	if (taroundlimit)
		{
		// Set timer for TA within x seconds of roundstart.
		taroundstart = true
		set_task(taroundlimit,"not_taround_start")
		}
	if (tkroundlimit)
		{
		// Set timer for TK within x seconds of roundstart.
		tkroundstart = true
		set_task(tkroundlimit,"not_tkround_start")	
		}
	return PLUGIN_CONTINUE
	}

public not_taround_start()
	{
	taroundstart = false
	}

public not_tkround_start()
	{
	tkroundstart = false
	}


/***************************** CONNECTION FUNCTIONS ******************************/

public client_authorized(id)
	{
	if (is_user_bot(id))
		return PLUGIN_HANDLED
	
	//Get Saved TA and TK counts if they where saved recently
	new storedauthid[20] 
	new storedtk[3]
	new storedta[3]
        new authid[20] 
        get_user_authid(id, authid, 19) 
  
        //Load previous TA and TK counts if they have any
        for(new x = 0; x <= savedcount; ++x)    
        	{ 
        	parse(saved[x], storedauthid, 19, storedtk, 2, storedta, 2) 
        	if(equal(storedauthid, authid))
        		{
        		TA[id] = strtonum(storedta)
        		TK[id] = strtonum(storedtk)
        		}
        	} 
	return PLUGIN_HANDLED
	}
	
public client_disconnect(id)
	{	
	new string[26]
	new storedauthid[20]
	new storedtk[3]
	new storedta[3]
	new authid[20]
	new bool:found
	
	get_user_authid(id, authid, 19)
             
	// Check if players TA and TK counts are already stored
	for(new x = 0; x <= savedcount; ++x)    
		{ 
		parse(saved[x], storedauthid, 19, storedtk, 2, storedta, 2) 
		if(equal(storedauthid, authid))    
			{
			format(string, 25, "%s %i %i", authid, TK[id], TA[id]) 
			saved[x] = string 
			found = true 
			}
		}
	
	storedauthid[0] = 0 
	storedtk[0] = 0 
	storedta[0] = 0 

	// If not stored, store their TA and TK counts
	if(!found && savedcount < 200) 
		{
		format(string, 25, "%s %i %i", authid, TK[id], TA[id])
		saved[savedcount] = string 
		savedcount++          
		}
	
	//Remove TA and TK history
	for(new i = 0; i <= 32; ++i)
		{
		if (lastTKer[i] == id)
			lastTKer[i] = 0
		if (lastTAer[i] == id)
			lastTKer[i] = 0
		}
	
	//Reset TA and TK counts in memory for disconnecting player
	TK[id] = 0
	TA[id] = 0
	
	return PLUGIN_HANDLED
	}


/*************************** PRECACHE & INIT FUNCTIONS ******************************/

public plugin_precache()
	{
	precache_sound("ambience/thunder_clap.wav")
	return PLUGIN_HANDLED
	}

public plugin_init()
	{
	//Register cvars, events, and commands
	register_plugin("amx_uffc","1.5","TheShaft")
	register_cvar("uffc_version", "1.5",FCVAR_SERVER) /* For gamespy/hlsw and such */
	
	register_clcmd("say /attacker","say_attacker",0,"- Returns the name of your last team attacker")
	register_clcmd("say /ff","say_ff",0,"- Returns whether FF is enabled or not")
	register_clcmd("say /forgive","showMenu",0,"Displays the Forgive Menu")
	register_clcmd("say /mystatus","say_mystatus",0,"- Toggles UFFC Live Status (lower,left corner)")
	
	register_logevent("event_newround",2,"0=World triggered","1=Round_Start") 
	
	register_menucmd(register_menuid("Forgive Menu"),1023,"actionMenu")
	
	register_cvar("uffc_tkcheck","0")
	register_cvar("uffc_tkcounts1","0")
	register_cvar("uffc_tkcounts2","0")
	register_cvar("uffc_tkcounts3","0")
	register_cvar("uffc_tkcounts4","0")
	register_cvar("uffc_tkpenalty1","0")
	register_cvar("uffc_tkpenalty2","0")
	register_cvar("uffc_tkpenalty3","0")
	register_cvar("uffc_tkpenalty4","0")
	register_cvar("uffc_tkbantime","800")
	register_cvar("uffc_tkroundlimit","7")
	register_cvar("uffc_tkroundpenalty","0")
	register_cvar("uffc_tkforgive","1")
	register_cvar("uffc_tacheck","0")
	register_cvar("uffc_tacounts1","0")
	register_cvar("uffc_tacounts2","0")
	register_cvar("uffc_tacounts3","0")
	register_cvar("uffc_tacounts4","0")
	register_cvar("uffc_tapenalty1","0")
	register_cvar("uffc_tapenalty2","0")
	register_cvar("uffc_tapenalty3","0")
	register_cvar("uffc_tapenalty4","0")
	register_cvar("uffc_tabantime","800")
	register_cvar("uffc_taroundlimit","7")
	register_cvar("uffc_taroundpenalty","0")
	register_cvar("uffc_taforgive","1")
	register_cvar("uffc_advertise","1")
	
	//Execute uffc.cfg to load variables
	server_cmd("exec addons/amx/uffc.cfg")
	server_cmd("mp_tkpunish 0")
	server_cmd("mp_autokick 0")
	
	//Load variables with data from cvars
	tkcounts1 = get_cvar_num("uffc_tkcounts1")
	tkcounts2 = get_cvar_num("uffc_tkcounts2")
	tkcounts3 = get_cvar_num("uffc_tkcounts3")
	tkcounts4 = get_cvar_num("uffc_tkcounts4")
	get_cvar_string("uffc_tkpenalty1",tkpenalty1,11)
	get_cvar_string("uffc_tkpenalty2",tkpenalty2,11)
	get_cvar_string("uffc_tkpenalty3",tkpenalty3,11)
	get_cvar_string("uffc_tkpenalty4",tkpenalty4,11)
	tkbantime = get_cvar_num("uffc_tkbantime")
	tkroundlimit = get_cvar_float("uffc_tkroundlimit")
	tkroundpenalty = get_cvar_num("uffc_tkroundpenalty")
	tkforgive = get_cvar_num("uffc_tkforgive")
	tacounts1 = get_cvar_num("uffc_tacounts1")
	tacounts2 = get_cvar_num("uffc_tacounts2")
	tacounts3 = get_cvar_num("uffc_tacounts3")
	tacounts4 = get_cvar_num("uffc_tacounts4")
	get_cvar_string("uffc_tapenalty1",tapenalty1,11)
	get_cvar_string("uffc_tapenalty2",tapenalty2,11)
	get_cvar_string("uffc_tapenalty3",tapenalty3,11)
	get_cvar_string("uffc_tapenalty4",tapenalty4,11)
	tabantime = get_cvar_num("uffc_tabantime")
	taroundlimit = get_cvar_float("uffc_taroundlimit")
	taroundpenalty = get_cvar_num("uffc_taroundpenalty")
	taforgive = get_cvar_num("uffc_taforgive")
	logfilename = "uffc.log"

	if ( get_cvar_num("uffc_tacheck") == 1 )
		register_event("DeathMsg","event_Death","a")
	if ( get_cvar_num("uffc_tkcheck") == 1 )
		register_event("Damage", "event_Damage", "b", "2!0", "3=0", "4!0")
	
	//Should we advertise the say commands
	if (get_cvar_num("uffc_advertise") == 1) 
		set_task(600.0,"advertise",123456,"",0,"b")
	}
