/*	AMX Clanwar system 1.4b5 by Grisbilen
*
*	Tested with amx 0.9.6j BETA, UDP module for amx is required if you want to use HLTV
*	Untested on older AMX versions, but 0.9.3 *could* work, you'll have to test it yourself
*	
*	Some features:
*	Counter-Strike ONLY
*	Maxrounds, timelimit or winlimit games (winlimit only 1 map)
*	Support for infinite overtimes if match is tied
*	Full support for two map games
*	Admin can autostart game
*	Information about the match displayed during warmups
*	Score is displayed at start of round (can be disabled)
*	Cointoss for CT/T sides at match start
*	Option to disable tactical shiled
*	Players/spectators can say score to get the current score in the match
*	Optional HLTV recording of games
*	Players say "ready" during warmup, when all players are ready, match starts
*	Simple tag system for customising text strings in strings.ini
*	Assigns players to correct team (not so stable as for now)
*	Admin does not need to be ingame, logfiles in amx/logs/ directory has all the scores etc.
*
*	files (in amxwar14b.zip):
*	addons/amx/plugins/amxwar/amxwar.cfg	- Holds all settings
*	addons/amx/plugins/amxwar/clans.ini		- Text file with a list of clantags, used in the menu
*	addons/amx/plugins/amxwar/maps.ini		- Text file with a list of maps, used in the menu
*	addons/amx/plugins/amxwar/strings.ini	- Text file with a list of strings used by amxwar
*	addons/amx/plugins/amxwar/tags.txt		- Text file with a list of tags used by strings.ini
*	addons/amx/plugins/amxwar/pd.cfg		- Plugins to pause during match play
*	addons/amx/plugins/amxwar/pe.cfg		- Plugins to unpause after match
*	addons/amx/plugins/amxwar/cfg/			- Directory where the configfiles resides, files must end in .cfg
*	addons/amx/plugins/amx_war.amx			- Plugin file
*	addons/amx/examples/amx_war.sma			- Source file
*	
*	Commands:
*	amxwar, commandline arguments follow below: 
*		<clantag1> if spaces are present in the clantag, it must be enclosed in double quotes, ex. "clan tag"
*		<clantag2> if spaces are present in the clantag, it must be enclosed in double quotes, ex. "clan tag"
*		<players> 5 for 5vs5 game
*		<mrXX=end when maxrounds+1, mxXX=end when maxrounds*2, tlXX=timelimit wlXX=winlimit> XX being a number between 2 & 999
*			for two maps: mrXX=two individual maps, team2 must win both, mx=scores from both maps are added, all rounds are played, mz=same as mx, but match ends when one team reaches rounds*2+1
*						  tl=same as mr, but timelimit, tx=same as mx, but timelimit
*		<map1>
*		optional: <map2> note: ignored in winlimit games
*		optional: <pw=yourpassword> you have to set "pw=" before your password, ex. pw=ironmaiden sets sv_password to "ironmaiden"
*		optional: <cfg=yourconfigfile> same as password, ex. cfg=clanbase will use addons/amx/plugins/amxwar/cfg/clanbase.cfg as configfile
*
*		example: "amxwar SK.swe 3D 5 mr12 de_dust2 de_inferno pw=match cfg=cpl"
*
*	awhltv <adminpassword of HLTV proxy or 0 to disable>
*
*	aw				- same as amxwar
*	awstart			- autostarts current match
*	awabort			- immediately aborts current match
*	awmenu			- amxwar menu
*	say ready		- client: makes you ready
*	say notready	- client: makes you not ready anymore
*	say_team score	- client: shows current score for the entire match
*	
*	Cvars:
*	Refer to addons/amx/plugins/amxwar/amxwar.cfg
*	
*	Note on hltv support:
*	Make sure the hltv proxy is in fact "in" the game before setting up demorecording
*	otherwise, amxwar will report hltv demo being recorded when it's not, there is no
*	error checking code so check your hltv console when recording.
*
*	SQL, please read!
*	=================================================================================
*	I have added light SQL support to the mod, to use it you must first have a SQL
*	server (duh!) with an amx database. Create a table with the data below and
*	uncomment line 199 here (#define SQL_SUPPORT_LIGHT. Recompile the sourcefile and
*	you are all set.
*	IMPORTANT: Do not uncomment line 202 (#define SQL_SUPPORT_EXTENDED) as that will
*	make the plugin non-funtional.
*
*
*
*	# MySQL-Front Dump 1.16 beta
*	#
*	# Host: localhost Database: amx
*	#--------------------------------------------------------
*	# Server version 4.0.16-nt
*	#
*	# Table structure for table 'awsmatches'
*	#
*
*	CREATE TABLE awsmatches (
*	  match_id int(9) unsigned NOT NULL auto_increment,
*	  team1 varchar(32) NOT NULL DEFAULT '' ,
*	  team2 varchar(32) NOT NULL DEFAULT '' ,
*	  map1 varchar(32) NOT NULL DEFAULT '' ,
*	  map2 varchar(32) ,
*	  scoret1 smallint(3) unsigned DEFAULT '0' ,
*	  scoret2 smallint(3) unsigned DEFAULT '0' ,
*	  scoret1m1 smallint(3) unsigned DEFAULT '0' ,
*	  scoret2m1 smallint(3) unsigned DEFAULT '0' ,
*	  scoret1m2 smallint(3) unsigned DEFAULT '0' ,
*	  scoret2m2 smallint(3) unsigned DEFAULT '0' ,
*	  gametype char(2) NOT NULL DEFAULT '' ,
*	  rounds smallint(4) unsigned NOT NULL DEFAULT '0' ,
*	  cfgfile varchar(32) ,
*	  players tinyint(2) unsigned NOT NULL DEFAULT '0' ,
*	  starttime datetime ,
*	  endtime datetime ,
*	  server varchar(64) ,
*	  adminname varchar(32) ,
*	  password varchar(32) ,
*	  completed tinyint(1) unsigned ,
*	  PRIMARY KEY (match_id),
*	  KEY match_id_2 (match_id),
*	  UNIQUE match_id (match_id)
*	);
*
*
*
*
*	Todo list:
*		- Fix *ALL* bugs in current version :\
*		- Autodetect clantags not in the beginning of a name
*		- Stable teamswap code
*		- Fix *ALL* bugs in current version :)
*		- Easier to use HLTV
*		- Kniferound
*		- Pre-prestart(!) a game xx minutes before start & throw out non matchplayers + set password some less xx minutes before start
*		- Wonid/steamid screenshot
*		- Fix *ALL* bugs in current version :D
*		- Wait for a stable/oficcial new version of AMX
*		- Re-enable map validity check
*		- Fix *ALL* bugs in current version :0
*		- Manuals
*
*	Version History:
*	1.5		- Only players recording a demo will get the question to stop recording
*			- Back to normal hudstrings (as they have been fixed)
*			- Light SQL Support
*			- Small fixes to tag system
*			- Added cvar awc_clantagcheck wich, if disabled, makes plugin not check names for the ready system
*			- Small bugfix concerning cfgfiles, the array was too small
*			- Fixed bug where all hudmessages was printed to server console, stupid me forgot to remove debugmessages
*			- Changed team-assignment code, thansk Redmist
*			- Fixed bug where correct cfg would not be loaded due to a non-terminated string
*			- Fixed bug where awc_tie would be ignored on map load
*			- Removed startstring, now uses vault
*	1.4b4	- Added winlimit games, only one map in wl for now
*	1.4b3	- Fixed bug where behaviour of mx & mz was swapped in first half of second map
*	1.4b2	- Fixed bug with tied games cvar not working correctly
*	1.4b	- amx_war is now a CS 1.6/Steam plugin (It *should* work for CS 1.5 too, but i'm just barely supporting it)
*			- Using amx v0.9.6j
*			- Bugfixes in the menu
*			- Added autodetection of clantags (menu only)
*			- Autodetected (and used) clantags will be added to clans.ini
*			- Screenshots are taken between half-times also
*			- Removed cvar awc_screenshots, instead plugin asks player if he wishes to take a screenshot
*			- Plugin asks players if they wish to record a demo
*			- Small fix of timeleft command (only "say_team timeleft" worked before)
*			- HLTV support can now be disabled/enabled by commenting/uncommenting the line #define HLTV_SUPPORT (line 128) and recompiling
*			- Rewrite of gametype & score code
*			- New cvar: awc_contoss, if enabled a cointoss will determine wich side teams start on, if disabled team1 begins as CT first map & T second map
*			- New cvar: awc_noshield, disables tactical shield if enabled
*			- New cvar: (buggy, same as in PTB) awc_autoteam, plugin attempts to auto assign players in warmups, disable this if players become spectators without being able to choose a team
*			- Removed cvar: awc_map2rules, it was silly anyway, it's now controlled by mr,mx,mz,tl and tx
*			- Some new and changed strings, refer to strings.ini
*			- Hudstrings will not get chopped off due to the 68 char limitation
*			- Had to disable map validity check since some bug prevented it from working, not sorted out yet
*			- My girlfriend left me for another guy, sad...
*
*	1.3		- User-Definable textstrings, most hudstrings & client text strings can be modified via strings.ini
*			- Strings.ini uses a simple tag system, refer to tags.txt
*			- In second map, team2 starts as CT
*			- Optional commandline argument: serverpassword (sv_password)
*			- Optional commandline argument: configfile
*			- Removed cvar awc_warcfg, instead uses addons/amx/plugins/amxwar/cfg/default.cfg if none is specified
*			- New directory (plugins/amxwar/cfg) where you can store configfiles for different cups/rules
*			- Adds clantags entered in cmdline to clans.ini if not there already
*			- Adds maps entered in cmdline to maps.ini if not there already
*           - Various bugfixes
*
*	1.2a	- Added working HLTV
*			- Rewrote most cheking code
*			- Two map games
*			- New commandline interface
*			- Timelimit games fully supported
*			- New (and changed) CVARS
*			- Added version history :)
*			- AMX_WAR has it's own logfile in amx/logs/ directory, use this for scores etc.
*
*	1.1a	- Internal test release
*
*	1.0		- Removed buggy teamchanging
*			- Bugfixes
*
*	0.9		- First release
*/

//#define HLTV_SUPPORT

/* Uncomment the line below for SQL */
//#define SQL_SUPPORT_LIGHT

/* Not the one below here */
//#define SQL_SUPPORT_EXTENDED

#include <amxmod>
#if defined HLTV_SUPPORT
#include <udp> // Needed for HLTV
#endif
#if defined SQL_SUPPORT_LIGHT || defined SQL_SUPPORT_EXTENDED
#include <mysql>
#endif

#define POS_TOP 20
#define POS_CENTER 250
#define POS_BOTTOM 850

#define COL_RED 0
#define COL_GREEN 1
#define COL_BLUE 2
#define COL_WHITE 3
#define COL_TAN 4

#define MENU_MIN_TAGLENGTH 2 // Minimum tag length (equal letters) for a clan to be autodetected
#define MENU_MIN_TAGNUMBER 2 // Minimum number of players sharing a tag required to autodetect a clan

new AW_VERSION[] = "v1.4b5"

new rounds, totrounds, gametype, wichmap, map2[32], map1[32], tiedgames
new war_live, warauto, half_active, period_number, war_password[64], war_config[64]
new war_countdowntimer,tl_start
new t1startside = 0, t2startside = 1 // team1 as ct & team2 as t by default
new p_ready[2],minready
new t_name[2][32],t_score[2][3],pl_rec[32],pl_recnum = 0
new readyplayers[32][2],readyplayersnum
new logfile[64], client_demoname[128]

// Infotext hack, pretty lame but i'm lazy
new mi[3][] = { "match", "1st map", "2nd map" }
new mi2[3][] = { "One", "1st", "2nd" }
new hi[6][] = { "", "1st", "1st", "2nd", "2nd", "" }
new nm[3][] = { "One map", "Two map", "Two map" }
new gt[6][] = { "Maxrounds", "Maxrounds", "Maxrounds", "Timelimit", "Timelimit", "Winlimit" }
new colors[5][3] = { {255,30,20},{30,255,30},{20,30,255},{230,230,230},{220,80,0} }

new sql_matchid

// HLTV
new hltv_address = -1
#if defined HLTV_SUPPORT
new hltv_id,hltv_pass[32]
#endif

// Menu
new clans[64][32],num_clans,maps[32][32],num_maps,menu_maxrounds = 12,menu_minready = 5
new clan1_toshow = 0,clan2_toshow = 1,map1_toshow = 1,map2_toshow = 0,menu_gametype[6] = "mr"
new cfgs[64][32],num_cfgs = 0,cfg_toshow = 0

// ============================================================================
// ============================= MISC FUNCTIONS ===============================
// ============================================================================

// formats strings from strings.ini, result will be in textblock string, returns time from strings.ini
public war_parsestrini(tofind[],textblock[1024]) {
	new inifile[64] = "addons/amx/plugins/amxwar/strings.ini"
	if (!file_exists(inifile)) return -1
	new text[1024], len, end, timetmp[4], pos = 0, i
	while(read_file(inifile,pos++,text,1023,len)) {
		if (contain(text,tofind) == 0) {
			len = contain(text,"=")
			if(len == -1) return -1
			setc(textblock,strlen(text)-(len+1),' ')
			for(i=len+1;i<strlen(text);i++) textblock[i-(len+1)] = text[i]
			len = contain(text,"(")
			end = contain(text,")")
			if((end > len+4) || (end <= len+1)) return -1
			for(i=len+1;i<end;i++) timetmp[i-(len+1)] = text[i]
			if(strtonum(timetmp) == 0) return 0

			// tag replacing begins here
			while(contain(textblock,"[lbrk]") != -1) replace(textblock,1023,"[lbrk]","^n")
			while(contain(textblock,"[team1]") != -1) replace(textblock,1023,"[team1]",t_name[0])
			while(contain(textblock,"[team2]") != -1) replace(textblock,1023,"[team2]",t_name[1])
			while(contain(textblock,"[nummaps]") != -1) replace(textblock,1023,"[nummaps]",nm[wichmap])
			while(contain(textblock,"[players1]") != -1) { new tmp[4]; numtostr(minready,tmp,3); replace(textblock,1023,"[players1]",tmp); }
			while(contain(textblock,"[players2]") != -1) { new tmp[8]; format(tmp,7,"%ivs%i",minready,minready); replace(textblock,1023,"[players2]",tmp); }
			while(contain(textblock,"[myname]") != -1) replace(textblock,1023,"[myname]","Admin")
			while(contain(textblock,"[gametype]") != -1) replace(textblock,1023,"[gametype]",gt[gametype])
			while(contain(textblock,"[maxrounds1]") != -1) { new tmp[4]; numtostr(rounds,tmp,3); replace(textblock,1023,"[maxrounds1]",tmp); }
			while(contain(textblock,"[maxrounds2]") != -1) { new tmp[16]; format(tmp,15,"%i%s",rounds,((gametype == 3) || (gametype == 4)) ? " min" : ""); replace(textblock,1023,"[maxrounds2]",tmp); }
			while(contain(textblock,"[matchmaps]") != -1) {
				new tmp[64], curmap[32]
				get_mapname(curmap,32)
				format(tmp,63,"%s%s%s",curmap,(wichmap == 1) ? ", " : "",(wichmap == 1) ? map2 : "")
				replace(textblock,1023,"[matchmaps]",tmp)
			}
			while(contain(textblock,"[startcountdown]") != -1) { new tmp[4]; numtostr(war_countdowntimer,tmp,3); replace(textblock,1023,"[startcountdown]",tmp); }
			while(contain(textblock,"[timer]") != -1) {
				new tl[8] = " "
				if((gametype == 3) || (gametype == 4))
					if(half_active) { new tl_rem = (floatround(get_gametime())-(tl_start+rounds*60))*(-1); format(tl,7,"%i%s%i",(tl_rem-(tl_rem%60))/60,(tl_rem%60 < 10) ? ":0" : ":",tl_rem%60); }
					else format(tl,7,"%i:00",rounds)
				replace(textblock,1023,"[timer]",tl)
			}
			while(contain(textblock,"[playedmap]") != -1) replace(textblock,1023,"[playedmap]",mi[wichmap])
			while(contain(textblock,"[playedmap2]") != -1) replace(textblock,1023,"[playedmap2]",mi2[wichmap])
 			while(contain(textblock,"[playedhalf]") != -1) replace(textblock,1023,"[playedhalf]",hi[war_live])
			while(contain(textblock,"[team1rdy]") != -1) { new tmp[4]; numtostr(p_ready[0],tmp,3); replace(textblock,1023,"[team1rdy]",tmp); }
			while(contain(textblock,"[team2rdy]") != -1) { new tmp[4]; numtostr(p_ready[1],tmp,3); replace(textblock,1023,"[team2rdy]",tmp); }
			while(contain(textblock,"[team1score]") != -1) { new tmp[4]; numtostr(t_score[0][0],tmp,3); replace(textblock,1023,"[team1score]",tmp); }
			while(contain(textblock,"[team2score]") != -1) { new tmp[4]; numtostr(t_score[1][0],tmp,3); replace(textblock,1023,"[team2score]",tmp); }
			while(contain(textblock,"[team1mapscore]") != -1) { new tmp[4]; numtostr(t_score[0][1]+t_score[0][2],tmp,3); replace(textblock,1023,"[team1mapscore]",tmp); }
			while(contain(textblock,"[team2mapscore]") != -1) { new tmp[4]; numtostr(t_score[1][1]+t_score[1][2],tmp,3); replace(textblock,1023,"[team2mapscore]",tmp); }
			while(contain(textblock,"[team1halfscore]") != -1) { new tmp[4]; if(war_live < 3) numtostr(t_score[0][1],tmp,3); else numtostr(t_score[0][2],tmp,3); replace(textblock,1023,"[team1halfscore]",tmp); }
			while(contain(textblock,"[team2halfscore]") != -1) { new tmp[4]; if(war_live < 3) numtostr(t_score[1][1],tmp,3); else numtostr(t_score[1][2],tmp,3); replace(textblock,1023,"[team2halfscore]",tmp); }
			while(contain(textblock,"[team1side]") != -1) { if(war_live > 2) replace(textblock,1023,"[team1side]",(t1startside == 0) ? "Terrorist" : "Counter-Terrorist"); else replace(textblock,1023,"[team1side]",(t1startside == 1) ? "Terrorist" : "Counter-Terrorist"); }
			while(contain(textblock,"[team2side]") != -1) { if(war_live > 2) replace(textblock,1023,"[team2side]",(t2startside == 0) ? "Terrorist" : "Counter-Terrorist"); else replace(textblock,1023,"[team2side]",(t2startside == 1) ? "Terrorist" : "Counter-Terrorist"); }
			while(contain(textblock,"[periodinfo]") != -1) {
				new tmp[32]
				if(period_number > 0) format(tmp,31," OT %i ",period_number)
				else format(tmp,31," ",period_number)
				replace(textblock,1023,"[periodinfo]",tmp)
			}
			while(contain(textblock,"[begininfo]") != -1) { if((war_live == 1) && (period_number == 0) && (wichmap < 2)) replace(textblock,1023,"[begininfo]","begin"); else replace(textblock,1023,"[begininfo]","continue"); }
			while(contain(textblock,"[pointsleft]") != -1) { new tmp[4] = ""; if((half_active == 1) && (gametype != 5)) numtostr(rounds-(t_score[0][war_live/2]+t_score[1][war_live/2]),tmp,3); replace(textblock,1023,"[pointsleft]",tmp); }
			while(contain(textblock,"[pointsleft2]") != -1) { 
				new tmp[4] = ""
				if(gametype < 3) {
					if(wichmap == 0) i = (rounds * 2) - (t_score[0][0]+t_score[1][0])
					else i = (rounds * 4) - (t_score[0][0]+t_score[1][0])
					numtostr(i,tmp,3)
				}
				replace(textblock,1023,"[pointsleft2]",tmp)
			}
			while(contain(textblock,"[winningteam]") != -1) {
				if(t_score[0][0] >= t_score[1][0]) replace(textblock,1023,"[winningteam]",t_name[0])
				else replace(textblock,1023,"[winningteam]",t_name[1])
			}
			while(contain(textblock,"[losingteam]") != -1) {
				if(t_score[0][0] >= t_score[1][0]) replace(textblock,1023,"[losingteam]",t_name[1])
				else replace(textblock,1023,"[losingteam]",t_name[0])
			}
			while(contain(textblock,"[round1]") != -1) { new tmp[4]; numtostr(t_score[0][0]+t_score[1][0]+1,tmp,3); replace(textblock,1023,"[round1]",tmp); }
			while(contain(textblock,"[round2]") != -1) { new tmp[4]; numtostr(t_score[0][war_live/2]+t_score[1][war_live/2]+1,tmp,3); replace(textblock,1023,"[round2]",tmp); }
			while(contain(textblock,"[round3]") != -1) { new tmp[4]; numtostr(t_score[0][1]+t_score[1][1]+t_score[0][2]+t_score[1][2]+1,tmp,3); replace(textblock,1023,"[round3]",tmp); }
			// and ends here

			return strtonum(timetmp)
		}
	}
	return -1
}

//displays text on hud
public war_hudtext(tofind[],maxtime,mintime,col,pos,screen) {
	new textblock[1024]
	new x = war_parsestrini(tofind,textblock)
	if(x == 0) return mintime //string disabled in strings.ini
	else if(x == -1) { log_to_file(logfile,"strings.ini error, infostring ^"%s^" not shown, check if string exist in strings.ini",tofind); return mintime; } //string not found
	else if(x == 1) x = 2
	else if((x < mintime) || (x > maxtime)) { log_to_file(logfile,"strings.ini error, infostring ^"%s^" not shown, check stringtime in strings.ini",tofind); return mintime; } //string time is wrong
	set_hudmessage(colors[col][0],colors[col][1],colors[col][2], -1.0, float(pos)/1000.0, 0, 6.0, float(x), 0.2, 0.2, screen)
	show_hudmessage(0,textblock)
	return x
}

//displays text on client
public war_clienttext(textstring[],id) {
	new textblock[1024]
	new x = war_parsestrini(textstring,textblock)
	if(x == -1) log_to_file(logfile,"strings.ini error, clientstring ^"%s^" not shown",textstring)
	else if(x == 1) client_print(id,print_chat,textblock)
	else if(x == 2) client_print(id,print_console,textblock)
	return PLUGIN_CONTINUE
}

// restarts round in time
public r_r(time[])
{
	set_cvar_num("sv_restartround", strtonum(time))
	return PLUGIN_CONTINUE
}

// takes scoreboard screenshot on clients
public war_ss2(id[]) client_cmd(id[0],"snapshot")
public war_ss3(id[]) client_cmd(id[0],"-showscores")

public war_ss() {
	new menu_body[512]
	new keys = (1<<0)|(1<<1)
	format(menu_body,511,"\yScreenshot^n\dDo you wish to take a scoreboard^nscreenshot?^n^n\w1. Yes^n2. No")
	new players[32],num_players,i
	get_players(players,num_players,"ce", "CT")
	for(i=0;i<num_players;i++) show_menu(players[i],keys,menu_body)
	get_players(players,num_players,"ce", "TERRORIST")
	for(i=0;i<num_players;i++) show_menu(players[i],keys,menu_body)
	return PLUGIN_HANDLED
}

public war_ss_action(id,key) {
	new params[1]
	params[0] = id
	switch(key) {
		case 0: {
			client_cmd(id,"+showscores")
			set_task(0.3,"war_ss2",0,params,1)
			set_task(0.6,"war_ss3",0,params,1)
		}
	}
	if(war_live == 5) {
		war_demo_off()
	}
	return PLUGIN_HANDLED
}

public war_demo() {
	war_fixcvar("awc_demos",0,2)
	if(get_cvar_num("awc_demos") == 0) return PLUGIN_HANDLED
	new menu_body[512],curmap[32],time_date[32],players[32],num_players,i,playerteam[16]
	new keys = (1<<0)|(1<<1)

	get_mapname(curmap,32) 
	get_time("%Y%m%d-%H.%M",time_date,32) 
	format(client_demoname,256,"%s-vs-%s_%s_%s.dem",t_name[0],t_name[1],curmap,time_date) 
	while(replace(client_demoname,64,"/","-")) {}
	while(replace(client_demoname,64,"\","-")) {}
	while(replace(client_demoname,64,":","-")) {}
	while(replace(client_demoname,64,"*","-")) {}
	while(replace(client_demoname,64,"?","-")) {}
	while(replace(client_demoname,64,">","-")) {}
	while(replace(client_demoname,64,"<","-")) {}
	while(replace(client_demoname,64,"|","-")) {}

	format(menu_body,511,"\yRecord Demo^n\dDo you wish to record a demo of this game to:^n%s?^n^n\w1. Yes^n2. No",client_demoname)
	get_players(players,num_players,"c")
	for(i=0;i<num_players;i++) {
		get_user_team(players[i],playerteam,15)
		if((equal(playerteam,"CT")) || (equal(playerteam,"TERRORIST"))) {
			if(get_cvar_num("awc_demos") == 2) show_menu(players[i],keys,menu_body) //ask if client wants to record demo
			else if(get_cvar_num("awc_demos") == 1) { //autorecord
				client_cmd(players[i],"stop;record ^"%s^"",client_demoname)
				pl_rec[pl_recnum] = players[i]
				pl_recnum++
			}
		}
	}
	return PLUGIN_HANDLED
}

public war_demo_action(id,key) {
	if(key == 0) {
		client_cmd(id,"stop;record ^"%s^"",client_demoname)
		pl_rec[pl_recnum] = id
		pl_recnum++
	}
	return PLUGIN_HANDLED
}

public war_demo_off() {
	war_fixcvar("awc_demos",0,2)
	new menu_body[512]
	new keys = (1<<0)|(1<<1)
	format(menu_body,511,"\yStop Recording^n\dDo you wish to stop demorecording now?^n^n\w1. Yes^n2. No")
	for(new i=0;i<pl_recnum;i++) {
		if(get_cvar_num("awc_demos") == 2) show_menu(pl_rec[i],keys,menu_body) //ask to stop recording
		else if(get_cvar_num("awc_demos") == 1) client_cmd(pl_rec[i],"stop") //autostop
	}
	pl_recnum = 0
	return PLUGIN_HANDLED
}

public war_demo_off_action(id,key) {
	switch(key) {
		case 0: client_cmd(id,"stop")
	}
	return PLUGIN_HANDLED
}

// transfers player to team, team=0 - CT, team=1 - T, thanks Redmist
public war_set_team(id,team) {
	user_kill(id,1)
	new temp[2],param[1]
	get_user_info(id,"_vgui_menus",temp,1) 
	client_cmd(id, "setinfo _vgui_menus 0") 
	if(strtonum(temp) == 1) { 
		client_cmd(id, "wait;wait;wait;wait") 
		client_cmd(id, "chooseteam") 
		client_cmd(id, "setinfo _vgui_menus 1") 
		param[0] = id
		if(team == 0) set_task(1.2,"war_c_ct",0,param,1)
		else set_task(1.2,"war_c_t",0,param,1)
	} 
	else { 
		engclient_cmd(id, "chooseteam") 
		if(team == 0) client_cmd(id, "slot1")
		else client_cmd(id, "slot2")
	} 
	return PLUGIN_CONTINUE
}
public war_c_ct(id[]) { client_cmd(id[0], "slot1"); return PLUGIN_CONTINUE; }
public war_c_t(id[]) { client_cmd(id[0], "slot2"); return PLUGIN_CONTINUE; }

// transfers players to the correct team
public war_teamplayers() {
	if ((war_live != 1) && (war_live != 3)) return PLUGIN_CONTINUE

	new players[32],myteam[32],name[64]
	new num_players,i,x

	get_players(players,num_players,"")

	for(i = 0;i<num_players;i++) {
		get_user_name(players[i], name, 63)
		get_user_team(players[i], myteam, 31)
		if(equal(myteam,"CT")) x = 0
		else if(equal(myteam,"TERRORIST")) x = 1
		if((containi(name,t_name[0]) != -1) && (containi(name,t_name[0]) < 3)) { //player should be on team 1
			if((war_live == 1) && (x != t1startside)) {
				war_set_team(players[i],t1startside)
				client_print(0,print_chat,"Assigning %s to %s team",name, (t1startside == 1) ? "Terrorist" : "Counter-Terrorist")
			}
			else if((war_live == 3) && (x != t2startside)) {
				war_set_team(players[i],t2startside)
				client_print(0,print_chat,"Assigning %s to %s team",name, (t2startside == 1) ? "Terrorist" : "Counter-Terrorist")
			}
		}
		else if((containi(name,t_name[1]) != -1) && (containi(name,t_name[1]) < 3)) { //player should be on team 2
			if((war_live == 1) && (x != t2startside)) {
				war_set_team(players[i],t2startside)
				client_print(0,print_chat,"Assigning %s to %s team",name, (t2startside == 1) ? "Terrorist" : "Counter-Terrorist")
			}
			else if((war_live == 3) && (x != t1startside)) {
				war_set_team(players[i],t1startside)
				client_print(0,print_chat,"Assigning %s to %s team",name, (t1startside == 1) ? "Terrorist" : "Counter-Terrorist")
			}
		}
	}
	return PLUGIN_CONTINUE
}

// this will ensure that cvar is between val_min and val_max, cvar is numerical
public war_fixcvar(cvar[],val_min,val_max) {
	if(get_cvar_num(cvar) < val_min) set_cvar_num(cvar,val_min)
	if(get_cvar_num(cvar) > val_max) set_cvar_num(cvar,val_max)
	return PLUGIN_CONTINUE
}

// ============================================================================
// =================================== INIT ===================================
// ============================================================================

// fills rounds, totrounds & gametype with correct values according to inpstr
public war_formatgtype(inpstr[]) {
	new tmp1[4],tmp2[4],i
	for(i=0;i<strlen(inpstr);i++)
		if(i<2) tmp1[i] = inpstr[i]
		else tmp2[i-2] = inpstr[i]
	rounds = strtonum(tmp2)
	if(rounds < 2) return 0 //match must be at least 2 rounds/minutes
	totrounds = rounds
	if(equali(tmp1,"mr")) gametype = 0
	else if(equali(tmp1,"mx")) gametype = 1
	else if(equali(tmp1,"mz")) gametype = 2
	else if(equali(tmp1,"tl")) gametype = 3
	else if(equali(tmp1,"tx")) gametype = 4
	else if(equali(tmp1,"wl")) gametype = 5
	else return 0 // wrong gametype
	return 1
}

// this function gets called if amxwar changes map
public war_startmapchange() {
	new tmp_t1name[32],tmp_t2name[32],tmp_gametype[8],tmp_score1,tmp_score2,strtmp[10]

	tiedgames = get_cvar_num("awc_tie")

	if(vaultdata_exists("aws_matchid")) {
		get_vaultdata("aws_matchid",strtmp,9)
		sql_matchid = strtonum(strtmp)
	}
	get_vaultdata("aws_team1",tmp_t1name,31)
	get_vaultdata("aws_team2",tmp_t2name,31)
	get_vaultdata("aws_map1",map1,31)
	if(vaultdata_exists("aws_map2")) get_vaultdata("aws_map2",map2,31)
	if(vaultdata_exists("aws_team1score")) {
		get_vaultdata("aws_team1score",strtmp,9)
		tmp_score1 = strtonum(strtmp)
	}
	else tmp_score1 = -1
	if(vaultdata_exists("aws_team2score")) {
		get_vaultdata("aws_team2score",strtmp,9)
		tmp_score2 = strtonum(strtmp)
}
	else tmp_score2 = -1

	get_vaultdata("aws_currentmap",strtmp,9)
	wichmap = strtonum(strtmp)

	get_vaultdata("aws_team1side",strtmp,9)
	if(wichmap == 2) { // 2nd map, team1 should start on the opposite side of map1
		t2startside = strtonum(strtmp)
		if(t2startside == 1) t1startside = 0
		else t1startside = 1
	}
	else {
		t1startside = strtonum(strtmp)
		if(t1startside == 1) t2startside = 0
		else t2startside = 1
	}

	get_vaultdata("aws_players",strtmp,9)
	minready = strtonum(strtmp)

	get_vaultdata("aws_gametype",tmp_gametype,7)
	if(war_formatgtype(tmp_gametype) == 0) war_end()
	if(vaultdata_exists("aws_password")) get_vaultdata("aws_password",war_password)
	else format(war_password,63,"NOTHING")
	get_vaultdata("aws_config",war_config)

	new hostname[64]
	get_cvar_string("hostname",hostname,63) 
	war_init(hostname,tmp_t1name,tmp_t2name,tmp_score1,tmp_score2)
	return PLUGIN_CONTINUE
}

//clears vaultdata since weird problems could arise if server crashed while war was active
war_clearvault() {
	if(vaultdata_exists("aws_initialized")) remove_vaultdata("aws_initialized")
	if(vaultdata_exists("aws_map1")) remove_vaultdata("aws_map1")
	if(vaultdata_exists("aws_map2")) remove_vaultdata("aws_map2")
	if(vaultdata_exists("aws_team1")) remove_vaultdata("aws_team1")
	if(vaultdata_exists("aws_team2")) remove_vaultdata("aws_team2")
	if(vaultdata_exists("aws_team1score")) remove_vaultdata("aws_team1score")
	if(vaultdata_exists("aws_team2score")) remove_vaultdata("aws_team2score")
	if(vaultdata_exists("aws_gametype")) remove_vaultdata("aws_gametype")
	if(vaultdata_exists("aws_players")) remove_vaultdata("aws_players")
	if(vaultdata_exists("aws_config")) remove_vaultdata("aws_config")
	if(vaultdata_exists("aws_password")) remove_vaultdata("aws_password")
	if(vaultdata_exists("aws_team1side")) remove_vaultdata("aws_team1side")
	if(vaultdata_exists("aws_matchid")) remove_vaultdata("aws_matchid")
	if(vaultdata_exists("aws_currentmap")) remove_vaultdata("aws_currentmap")
	return PLUGIN_CONTINUE
}

// command line intepreter
public war_begin(id) {
	if (id && !((get_user_flags(id) & ADMIN_LEVEL_A))) { war_clienttext("clt_noaccess",id); return PLUGIN_HANDLED; }
	tiedgames = get_cvar_num("awc_tie")
	new adminname[32]
	new gttmp[6][] = { "mr", "mx", "mz", "tl", "tx", "wl" }
	get_user_name(id,adminname,31)
	if(war_live == 0) {
#if defined SQL_SUPPORT_LIGHT || defined SQL_SUPPORT_EXTENDED
		new query[512]
		new sql_datetime[32]
		new hostaddress[64]
		get_cvar_string("net_address",hostaddress,63) 
		get_time("%Y-%m-%d %H:%M:%S",sql_datetime,31)
		new matchid[16],merror[128]
#endif
		new tmp_t1name[32],tmp_t2name[32],tmp_minready[4],tmp_gametype[8],tmp_map1[32],passw[64],tmpinp[3][64],config[64],curmap[32],strtmp[10]
#if defined SQL_SUPPORT_EXTENDED
		new tmp_t1,tmp_t2
		war_clearvault()

		if(read_argc() == 2) { // only match database id is submitted as argument
			read_argv(1,matchid,15)
			sql_matchid = strtonum(matchid)
			new	mysql = war_sqlinit()
			if(mysql > 0) {
				new comptmp[2]
				format(query,511,"SELECT * FROM awsmatches WHERE match_id='%i'",sql_matchid)
				mysql_query(mysql,query) 
				mysql_error(mysql,merror,127)
				if (merror[0]) log_to_file(logfile,"Error: MySQL error: %s",merror)
				if(mysql_nextrow(mysql) > 0) {
					mysql_getfield(mysql,22,comptmp,1)
					if(strtonum(comptmp) == 2) {
						client_print(id,print_console,"Error: MySQL error: match id %i is already played",sql_matchid)
						log_to_file(logfile,"Error: MySQL error: sql_matchid %i is already played",sql_matchid)
						mysql_close(mysql)
						return PLUGIN_HANDLED
					}
					else if(strtonum(comptmp) == 1) {
						client_print(id,print_console,"Error: MySQL error: match id %i is currently being played",sql_matchid)
						log_to_file(logfile,"Error: MySQL error: sql_matchid %i is currently being played",sql_matchid)
						mysql_close(mysql)
						return PLUGIN_HANDLED
					}
	
					mysql_getfield(mysql,25,tmp_t1name,31)
					tmp_t1 = strtonum(tmp_t1name)
					if(tmp_t1 == 0) mysql_getfield(mysql,2,tmp_t1name,31)
					mysql_getfield(mysql,26,tmp_t2name,31)
					tmp_t2 = strtonum(tmp_t2name)
					if(tmp_t2 == 0) mysql_getfield(mysql,3,tmp_t2name,31)

					mysql_getfield(mysql,4,tmp_map1,31)
					mysql_getfield(mysql,5,map2,31)
					if(strlen(map2) > 0) wichmap = 1
					else wichmap = 0

					new tmp_rounds[4],tmp_gt[3]
					mysql_getfield(mysql,12,tmp_gt,2)
					mysql_getfield(mysql,13,tmp_rounds,3)
					format(tmp_gametype,7,"%s%s",tmp_gt,tmp_rounds)
					mysql_getfield(mysql,14,war_config,63)
					if(strlen(war_config) < 1) copy(war_config,63,"NOTHING")
					mysql_getfield(mysql,15,tmp_minready,3)
					mysql_getfield(mysql,20,war_password,63)
					if(strlen(war_password) < 1) copy(war_password,63,"NOTHING")
					if(tmp_t1 != 0) {
						format(query,511,"SELECT clan_tag FROM awsclans WHERE clan_id=%i",tmp_t1)
						mysql_query(mysql,query)
						mysql_error(mysql,merror,127)
						if (merror[0]) log_to_file(logfile,"Error: MySQL error: %s",merror)
						if(mysql_nextrow(mysql) > 0) mysql_getfield(mysql,1,tmp_t1name,31)
						else {
							client_print(id,print_console,"Error: MySQL error: clan id %i not found",tmp_t1)
							log_to_file(logfile,"Error: MySQL error: clan id %i not found",tmp_t1)
							mysql_close(mysql)
							return PLUGIN_HANDLED
						}
					}
					if(tmp_t2 != 0) {
						format(query,511,"SELECT clan_tag FROM awsclans WHERE clan_id=%i",tmp_t2)
						mysql_query(mysql,query)
						mysql_error(mysql,merror,127)
						if (merror[0]) log_to_file(logfile,"Error: MySQL error: %s",merror)
						if(mysql_nextrow(mysql) > 0) mysql_getfield(mysql,1,tmp_t2name,31)
						else {
							client_print(id,print_console,"Error: MySQL error: clan id %s not found",tmp_t2)
							log_to_file(logfile,"Error: MySQL error: clan id %s not found",tmp_t2)
							mysql_close(mysql)
							return PLUGIN_HANDLED
						}
					}
				}
				else {
					client_print(id,print_console,"Error: MySQL error: match id %i not found",sql_matchid)
					log_to_file(logfile,"Error: MySQL error: sql_matchid %i not found",sql_matchid)
					mysql_close(mysql)
					return PLUGIN_HANDLED
				}

				war_checkininames(tmp_map1,2)
				if(war_formatgtype(tmp_gametype) == 0) { war_clienttext("clt_init2",id); return PLUGIN_HANDLED; }
				minready = strtonum(tmp_minready)
				if((minready < 1) || (minready > 10)) { war_clienttext("clt_init3",id); return PLUGIN_HANDLED; }

				format(query,511,"UPDATE awsmatches SET starttime='%s', server='%s', adminname='%s', completed='%i' WHERE match_id='%i'",sql_datetime,hostaddress,adminname,1,sql_matchid)
				mysql_query(mysql,query) 
				mysql_error(mysql,merror,127)
				if (merror[0]) log_to_file(logfile,"Error: MySQL error: %s",merror)
				mysql_close(mysql)

				set_vaultdata("aws_initialized","1")
				set_vaultdata("aws_team1",tmp_t1name)
				set_vaultdata("aws_team2",tmp_t2name)
				num_to_str(minready,strtmp,3)
				set_vaultdata("aws_players",strtmp)
				set_vaultdata("aws_gametype",tmp_gametype)
				set_vaultdata("aws_map1",tmp_map1)
				if(strlen(map2) != 0) set_vaultdata("aws_map2",map2)
				set_vaultdata("aws_config",war_config)
				num_to_str(t1startside,strtmp,3)
				set_vaultdata("aws_team1side",strtmp)
				if(!equal(war_password,"NOTHING")) set_vaultdata("aws_password",war_password)
				if(sql_matchid != 0) {
					num_to_str(sql_matchid,strtmp,9)
					set_vaultdata("aws_matchid",strtmp)
				}
				if(wichmap == 1) set_vaultdata("aws_currentmap","1")
				else set_vaultdata("aws_currentmap","0")

				war_checkininames(tmp_t1name,1)
				war_checkininames(tmp_t2name,1)
				get_mapname(curmap,31)
				if(equali(tmp_map1,curmap)) war_init(adminname,tmp_t1name,tmp_t2name,-1,-1)
				else server_cmd("changelevel %s",tmp_map1)
			}
			else {
				client_print(id,print_console,"Error: MySQL error: Could not connect to MySQL DBase while getting match info")
				log_to_file(logfile,"Error: MySQL error: Could not connect to MySQL DBase while getting match info")
				return PLUGIN_HANDLED
			}
		}
		else if(read_argc() >= 6) { // sql
#else
		if(read_argc() >= 6) { // no sql, match is submitted as normal
#endif
			read_argv(1,tmp_t1name,31)
			read_argv(2,tmp_t2name,31)
			read_argv(3,tmp_minready,4)
			read_argv(4,tmp_gametype,7)
			read_argv(5,tmp_map1,31)

//			if(!is_map_valid(tmp_map1)) { war_clienttext("clt_init1a",id); return PLUGIN_HANDLED; }
			war_checkininames(tmp_map1,2)
			if(war_formatgtype(tmp_gametype) == 0) { war_clienttext("clt_init2",id); return PLUGIN_HANDLED; }
			minready = strtonum(tmp_minready)
			if((minready < 1) || (minready > 10)) { war_clienttext("clt_init3",id); return PLUGIN_HANDLED; }

			set_cvar_string("awc_maps", "1")
			wichmap = 0
			copy(war_password,63,"NOTHING")
			copy(war_config,63,"NOTHING")
			map2 = ""

			if(read_argc() > 6) {
				new tmp1[64],i
				read_argv(6,tmpinp[0],63)
				read_argv(7,tmpinp[1],63)
				read_argv(8,tmpinp[2],63)
				for(i=0;i<3;i++) {
					if(strlen(tmpinp[i]) > 0) {
						if(containi(tmpinp[i],"pw=") == 0) copy(passw,63,tmpinp[i])
						else if(containi(tmpinp[i],"cfg=") == 0) copy(config,63,tmpinp[i])
						else copy(map2,32,tmpinp[i])
					}
				}
				if(containi(passw,"pw=") == 0) { for(i=3;i<strlen(passw);i++) tmp1[i-3] = passw[i]; copy(war_password,63,tmp1); }
				setc(tmp1,63,0)
				if(containi(config,"cfg=") == 0) { for(i=4;i<strlen(config);i++) tmp1[i-4] = config[i]; copy(war_config,63,tmp1); }
				if((strlen(map2) > 0) && (gametype != 5)) {
//					if(!is_map_valid(map2)) { war_clienttext("clt_init1b",id); return PLUGIN_HANDLED; }
					war_checkininames(map2,2)
					format(tmp_gametype,7,"%s%i",gttmp[gametype],rounds)
					set_cvar_string("awc_maps", "2")
					wichmap = 1
				}
			}
#if defined SQL_SUPPORT_LIGHT
			new	mysql = war_sqlinit()
			if(mysql > 0) {
				format(query,511,"INSERT into awsmatches (team1,team2,map1,map2,gametype,rounds,cfgfile,players,starttime,server,adminname,password,completed) values('%s','%s','%s','%s','%s','%i','%s','%i','%s','%s','%s','%s','%i')",tmp_t1name,tmp_t2name,tmp_map1,map2,gttmp[gametype],rounds,(equal(war_config,"NOTHING")) ? "default" : war_config,minready,sql_datetime,hostaddress,adminname,war_password,1)
				mysql_query(mysql,query) 
				mysql_error(mysql,merror,127)
				if (merror[0]) log_to_file(logfile,"Error: MySQL error: %s",merror)
				format(query,511,"SELECT match_id FROM awsmatches WHERE starttime='%s'",sql_datetime)
				mysql_query(mysql,query)
				mysql_error(mysql,merror,127)
				if (merror[0]) log_to_file(logfile,"Error: MySQL error: %s",merror)
				if(mysql_nextrow(mysql) > 0) mysql_getfield(mysql,1,matchid,15)
				sql_matchid = strtonum(matchid)
				mysql_close(mysql)
				if(sql_matchid < 1) log_to_file(logfile,"Error: MySQL error: sql_matchid is zero")
			}
			else {
				client_print(id,print_console,"Error: MySQL error: Could not connect to MySQL DBase while adding new match")
				log_to_file(logfile,"Error: MySQL error: Could not connect to MySQL DBase while adding new match")
				return PLUGIN_HANDLED
			}
#endif

			set_vaultdata("aws_initialized","1")
			set_vaultdata("aws_team1",tmp_t1name)
			set_vaultdata("aws_team2",tmp_t2name)
			num_to_str(minready,strtmp,3)
			set_vaultdata("aws_players",strtmp)
			set_vaultdata("aws_gametype",tmp_gametype)
			set_vaultdata("aws_map1",tmp_map1)
			if(strlen(map2) != 0) set_vaultdata("aws_map2",map2)
			set_vaultdata("aws_config",war_config)
			num_to_str(t1startside,strtmp,3)
			set_vaultdata("aws_team1side",strtmp)
			if(!equal(war_password,"NOTHING")) set_vaultdata("aws_password",war_password)
			if(sql_matchid != 0) {
				num_to_str(sql_matchid,strtmp,9)
				set_vaultdata("aws_matchid",strtmp)
			}
			if(wichmap == 1) set_vaultdata("aws_currentmap","1")
			else set_vaultdata("aws_currentmap","0")

			war_checkininames(tmp_t1name,1)
			war_checkininames(tmp_t2name,1)
			get_mapname(curmap,31)
			if(equali(tmp_map1,curmap)) war_init(adminname,tmp_t1name,tmp_t2name,-1,-1)
			else server_cmd("changelevel %s",tmp_map1)
		}
		else { war_clienttext("clt_info5a",id); return PLUGIN_HANDLED; }
	}
	else war_clienttext("clt_init4",id)
	return PLUGIN_HANDLED
}

//if submitted string is not in clans.ini or maps.ini, add it there
public war_checkininames(tocheck[32],toedit) {
	new inifile[256]
	if(toedit == 1) inifile = "addons/amx/plugins/amxwar/clans.ini"
	else if(toedit == 2) inifile = "addons/amx/plugins/amxwar/maps.ini"
	if (!file_exists(inifile)) return 0
	new text[256],tag[32],len,pos=0,i=0,x=0
	while(read_file(inifile,pos++,text,255,len)) {
		if ( text[0] != ';') {
			parse(text,tag,32)
			if(equali(tag,tocheck)) i = 1
			x++
		}
	}
	if((i==0) && (((toedit == 1) && (x < 64)) || ((toedit == 2) && (x < 32)))) {
		if(toedit == 2) format(tag,31,"%s",tocheck)
		else format(tag,31,"^"%s^"",tocheck)
		write_file(inifile,tag)
	}
	return PLUGIN_CONTINUE
}

// this starts the game
public war_init(adminname[],cmd_team1[],cmd_team2[],cmd_team1score,cmd_team2score) {
	if(war_live == 0) {
		copy(t_name[0],31,cmd_team1)
		copy(t_name[1],31,cmd_team2)

		war_live = 1
		period_number = 0
		half_active = 0
		t_score[0] = {0,0,0}
		t_score[1] = {0,0,0}
		if(((cmd_team1score != -1) && (cmd_team2score != -1)) && ((cmd_team1score+cmd_team2score == rounds*2) || ((gametype == 3) || (gametype == 4)))) { // about to start second map
			if((gametype == 0) || (gametype == 3)) totrounds = rounds // score should be 0 for both teams if gametype is 0 (mr) or 3 (tl)
			else { // enter startscore if gametype is 1 (mx), 2 (mz) or 4 (tx)
				t_score[0][0] = cmd_team1score
				t_score[1][0] = cmd_team2score
				totrounds = rounds*2
			}
		}

		new tmp[256]
		client_print(0,print_console,"* [AMX WAR] %s by Grisbilen",AW_VERSION)
		war_clienttext("clt_init5",0)

		get_cvar_string("awc_pdiscfg",tmp,256)
		server_cmd("exec ^"%s^"",tmp)

		if(equal(war_config,"NOTHING")) format(tmp,256,"addons/amx/plugins/amxwar/cfg/default.cfg")
		else {
			format(tmp,256,"addons/amx/plugins/amxwar/cfg/%s.cfg",war_config)
			if(!file_exists(tmp)) format(tmp,256,"addons/amx/plugins/amxwar/cfg/default.cfg") // use default if nonexisting cfg is submitted
		}
		server_cmd("exec ^"%s^"",tmp)

		if(!equal(war_password,"NOTHING")) server_cmd("sv_password %s",war_password)

		new curmap[32]
		get_mapname(curmap,32)
		if(get_cvar_num("awc_noshield") == 1) { server_cmd("amx_restrict on shield"); client_print(0,print_chat,"Tactical shield has been disabled"); }
		if(wichmap != 2) log_to_file(logfile,"********************************************************************************************")
		log_to_file(logfile,"%s started by %s, Team1: %s Team2: %s %s: %i Startscore: %i-%i^nMap: %s Config: %s PW: %s",(t_score[0][0]+t_score[1][0] > 0) ? "2nd map" : "Clanmatch",adminname,t_name[0],t_name[1],gt[gametype],rounds,t_score[0][0],t_score[1][0],curmap,tmp,war_password)
		if((get_cvar_num("awc_cointoss") != 0) && (wichmap < 2)) { // cointoss only on first map
			new x = war_hudtext("hud_start9",60,5,COL_GREEN,POS_CENTER,10)
			if(wichmap == 2) set_task(float(x+10),"war_ctinit",876111)
			else set_task(float(x),"war_ctinit",876111)
		}
		else {
			new x
			if(get_cvar_num("awc_autoteam") == 1) x = war_hudtext("hud_start1a",60,5,COL_GREEN,POS_CENTER,10)
			else x = war_hudtext("hud_start1b",60,5,COL_GREEN,POS_CENTER,10)
			if(wichmap == 2) set_task(float(x+10),"war_warmup",876110)
			else set_task(float(x-3),"war_warmup",876110)
		}
		set_task(float(3),"war_warmup",876110)
	}
	return PLUGIN_CONTINUE
}

// cointoss
public war_ctinit() {
	new x  = random_num(0,1)
	t1startside = x
	if(t1startside == 1) t2startside = 0; else t2startside = 1;
	if(get_cvar_num("awc_autoteam") == 1) x = war_hudtext("hud_start10a",60,5,COL_GREEN,POS_CENTER,10)
	else  x = war_hudtext("hud_start10b",60,5,COL_GREEN,POS_CENTER,10)
	set_cvar_num("sv_restartround", x-4)
	set_task(float(x-1),"war_warmup",876110)
	return PLUGIN_CONTINUE
}

// ============================================================================
// ================================== WARMUP ==================================
// ============================================================================

// displayed at top during warmup
public war_hud_msg() {
	if((war_live%2 > 0)  && (war_live != 5)) {
		war_hudtext("hud_start2",2,2,COL_GREEN,POS_TOP,10)
	}
	return PLUGIN_CONTINUE
}

public war_starthud() {
	remove_task(876102)
	war_hud_msg()
	set_task(2.0,"war_hud_msg",876102,"",0,"b")
	return PLUGIN_CONTINUE
}

// inits warmup session
public war_warmup() {
//	if(get_cvar_num("awc_autoteam") == 1) war_teamplayers()
	r_r("3")
	war_clearready()
	set_task(7.0,"war_starthud",876109)
	set_task(9.0,"war_warmup_info",876104)
	return PLUGIN_CONTINUE
}

// some info for clients during warmup
public war_warmup_info() {
	war_clienttext("clt_warmup1a",0)
	war_clienttext("clt_warmup1b",0)
	war_clienttext("clt_warmup1c",0)
	return PLUGIN_CONTINUE
}

// ============================================================================
// =============================== READY SYSTEM ===============================
// ============================================================================

// what team is client in? first half: CT = 0, second half: CT = 1
public war_teaminfo(id) {
	new myteam[32]
	get_user_team(id,myteam,31)
	if((war_live == 1) || (war_live == 2)) {
		if(equal(myteam,"CT")) return t1startside
		else if(equal(myteam,"TERRORIST")) return t2startside
	}
	else if((war_live == 3) || (war_live == 4)) {
		if(equal(myteam,"CT")) return t2startside
		else if(equal(myteam,"TERRORIST")) return t1startside
	}
	return -1
}

// if client say ready
public war_readycheck(id) {
	new tmp = war_teaminfo(id)
	if ((tmp == -1) || (war_live == 0) || (war_live == 5)) return PLUGIN_HANDLED

	if(war_live%2 > 0) {
		new i,playername[64]
		get_user_name(id,playername,63)
		if(get_cvar_num("awc_clantagcheck") == 1)
			if((containi(playername,t_name[tmp]) == -1) || !(containi(playername,t_name[tmp]) < 3)) return PLUGIN_HANDLED
		for(i=0;i<32;i++) {
			if(readyplayers[i][0] == id) { //client is already good to go
				war_clienttext("clt_warmup2b",id)
				return PLUGIN_HANDLED
			}
		}
		readyplayers[readyplayersnum][1] = tmp
		readyplayers[readyplayersnum][0] = id
		readyplayersnum++
		war_clienttext("clt_warmup2a",id)
		p_ready = {0,0}
		for(i=0;i<32;i++) if(readyplayers[i][0] && (p_ready[readyplayers[i][1]] < minready)) p_ready[readyplayers[i][1]]++
		war_starthud()
	}
	else war_clienttext("clt_warmup2c",id)
	if((war_countdowntimer == 0) && (war_live%2 > 0))
		if(p_ready[0]+p_ready[1] >= minready*2) { remove_task(876102); war_prestart(); }

	return PLUGIN_HANDLED
}

// if client say notready
public war_notreadycheck(id) {
	if ((war_live == 0) || (war_live == 5)) return PLUGIN_HANDLED

	if(war_live%2 > 0) {
		new playername[64],tmp2[32][2],i,j
		new x = readyplayersnum
		get_user_name(id,playername,63)
		for(i=0;i<32;i++) {
			if(readyplayers[i][0] != id) {
				tmp2[j][0] = readyplayers[i][0]
				tmp2[j][1] = readyplayers[i][1]
				j++
			}
			else {
				readyplayersnum--
				war_clienttext("clt_warmup3a",id)
			}
		}
		readyplayers = tmp2

		if(x == readyplayersnum) {
			war_clienttext("clt_warmup3b",id)
			return PLUGIN_HANDLED
		}
		else {
			p_ready[0] = 0
			p_ready[1] = 0
			for(i=0;i<readyplayersnum;i++) if(readyplayers[i][0]) p_ready[readyplayers[i][1]]++
		}

		if((war_countdowntimer != 0) && (p_ready[0]+p_ready[1] < minready*2)) {
			remove_task(876103)
			war_hudtext("hud_start6",6,6,COL_RED,POS_CENTER,10)
			log_to_file(logfile,"Countdown aborted by %s",playername)
			war_countdowntimer = 0
		}
		remove_task(876101)
		war_starthud()
	}
	else war_clienttext("clt_warmup3c",id)

	return PLUGIN_HANDLED
}

// if client is ready and get disconnected, make him notready
public client_disconnect(id) {
#if defined HLTV_SUPPORT
	if (id == hltv_id) { 
		log_to_file(logfile,"HLTV proxy disconnected")
		hltv_id = 0 
		hltv_address = -1
	}
#endif
	if((war_live%2 > 0) && (war_live != 5)) {
		new tmp2[32][2],i,j
		for(i=0;i<32;i++) {
			if(readyplayers[i][0] != id) {
				tmp2[j][0] = readyplayers[i][0]
				tmp2[j][1] = readyplayers[i][1]
				j++
			}
			else readyplayersnum--
		}
		readyplayers = tmp2
		p_ready[0] = 0
		p_ready[1] = 0
		for(i=0;i<readyplayersnum;i++) if(readyplayers[i][0]) p_ready[readyplayers[i][1]]++

		if(p_ready[0]+p_ready[1] < minready*2) {
			if(war_countdowntimer != 0) {
				remove_task(876103)
				war_hudtext("hud_start6",6,6,COL_RED,POS_CENTER,10)
				log_to_file(logfile,"id:%i got disconnected during countdown",id)
				war_countdowntimer = 0
			}
			remove_task(876101)
			war_starthud()
		}
	}
	return PLUGIN_CONTINUE
}

// makes all clients notready
public war_clearready() {
	for (new i=0;i<32;i++) readyplayers[i] = {0,0}
	p_ready = {0,0}
	readyplayersnum = 0
	return PLUGIN_CONTINUE
}

// makes all valid (correct clantag & correct team) clients ready
public war_makeallready() {
	new players[32],playername[64]
	new num_players,i
	get_players(players,num_players,"")

	for(i = 0;i<num_players;i++) {
		new tmp = war_teaminfo(players[i])
		get_user_name(players[i],playername,63)
		if(tmp > -1) {
			if ((containi(playername,t_name[tmp]) != -1) && (containi(playername,t_name[tmp]) < 3)) {
				readyplayers[readyplayersnum][1] = tmp
				readyplayers[readyplayersnum][0] = players[i]
				readyplayersnum++
			}
		}
	}
	for(i=0;i<32;i++) if(readyplayers[i][0]) p_ready[readyplayers[i][1]]++
	return PLUGIN_CONTINUE
}

// ============================================================================
// ============================= MATCH START ==================================
// ============================================================================

// shows live message and sets game active, scoring can now begin
public war_live_msg() {
	war_hudtext("hud_start4",15,2,COL_RED,POS_CENTER,10)
	war_clienttext("clt_start1a",0)
	war_clienttext("clt_start1b",0)
	war_clienttext("clt_start1c",0)
	log_to_file(logfile,"%s Round %i %s half started",mi[wichmap],period_number,(war_live <= 2) ? "1st" : "2nd")
	half_active = 1
	if((gametype == 3) || (gametype == 4)) {
		tl_start = floatround(get_gametime())
		set_task(float(rounds*60),"war_timelimit",876105)
	}
	return PLUGIN_CONTINUE
}

// starts the match
public war_start() {
	remove_task(876103) // no more countdown
	war_clearready()
	war_clienttext("clt_start2",0)
	if((war_live == 1) && (period_number == 0)) {
#if defined HLTV_SUPPORT
		war_hltvrecord()
#endif
		war_demo()
	}
	war_live++
	t_score[0][war_live/2] = 0
	t_score[1][war_live/2] = 0
	set_task(3.0,"r_r",0,"1",1) // there must be a better way of doing this
	set_task(5.5,"r_r",0,"1",1)
	set_task(8.0,"r_r",0,"3",1)
	set_task(12.5,"war_live_msg")
	return PLUGIN_CONTINUE
}

// starts counter down to match start
public war_prestart() {
	new x
	if(warauto) { x = war_hudtext("hud_start7b",20,2,COL_GREEN,POS_CENTER,10); warauto = 0; }
	else x = war_hudtext("hud_start7a",20,2,COL_GREEN,POS_CENTER,10)
	war_countdowntimer = get_cvar_num("awc_countdowntime")
	log_to_file(logfile,"Prestarting %s round %i %s half",mi[wichmap],period_number,hi[war_live])
	remove_task(876102)
	set_task(float(x-2),"war_countdown",876103)
	set_task(float(get_cvar_num("awc_countdowntime")+(x-1)),"war_start",876101)
	return PLUGIN_CONTINUE
}

// counts down get_cvar_num("awc_countdowntime") seconds to match start
public war_countdown() {
	if(war_countdowntimer > 0) {
		war_hudtext("hud_start5",2,2,COL_BLUE,POS_BOTTOM,14)
		war_countdowntimer--
		set_task(1.0,"war_countdown",876103)
	}
	else war_hudtext("hud_start3",10,2,COL_RED,POS_CENTER,10)
	return PLUGIN_CONTINUE
}

// starts a match regardless of ready players
public war_forcestart(id) {
	if (id && !((get_user_flags(id) & ADMIN_LEVEL_A))) { 
		war_clienttext("clt_noaccess",id)
		return PLUGIN_HANDLED
	}
	if((war_live%2 > 0) && (war_live != 5)) {
		if((p_ready[0]+p_ready[1] < minready*2) && (war_countdowntimer == 0)) {
			new adminname[32]
			get_user_name(id,adminname,31)
			war_hudtext("hud_start8",6,6,COL_RED,POS_CENTER,10)
			remove_task(876102)
			war_clearready()
			war_makeallready()
			warauto = 1
			set_task(4.0,"war_prestart")
			war_clienttext("clt_start3a",0)
			log_to_file(logfile,"Clanmatch %s round %s autostarted by %s",mi[wichmap],hi[war_live],adminname)
		}
		else war_clienttext("clt_start3b",0)
	}
	return PLUGIN_HANDLED
}

// ============================================================================
// ================================= SCORE ====================================
// ============================================================================

// displays match score if client say_team score
public war_get_score(id) {
	if(war_live == 0) return PLUGIN_HANDLED
	if((gametype == 3) || (gametype == 4)) war_clienttext("clt_info3a",id)
	else if(gametype == 5) war_clienttext("clt_info3c",id)
	else war_clienttext("clt_info3b",id)
	war_clienttext("clt_info3d",id)
	return PLUGIN_HANDLED
}

// displays time remaining in match to client
public war_gettime(id) {
	if(((gametype == 3) || (gametype == 4)) && (war_live > 0)) war_clienttext("clt_info1",id)
	else return PLUGIN_CONTINUE
	return PLUGIN_HANDLED
}
// if timelimit has been reached
public war_timelimit() {
	if(war_live == 2) { // 1st half finished
		war_live = 3
		new x
		if(get_cvar_num("awc_autoteam") == 1) x = war_hudtext("hud_stop1a",20,2,COL_GREEN,POS_CENTER,10)
		else x = war_hudtext("hud_stop1b",20,2,COL_GREEN,POS_CENTER,10)
		log_to_file(logfile,"%s Round %i halftime, score: %s %i - %s %i",mi[wichmap],period_number,t_name[0],t_score[0][0],t_name[1],t_score[1][0])
		half_active = 0
		war_ss()
		set_task(float(x-2),"war_warmup")
	} // ENDIF 1st half finished
	if(war_live == 4) { // 2nd half finished
		if(gametype == 3) {
			if(wichmap == 1) {
				if(t_score[0][0] > t_score[1][0]) { wichmap = 0; war_scoremsg(); } // first team won
				else if(t_score[0][0] == t_score[1][0]) war_tied() // first map in tl can't be tied, overtime
				else war_scoremsg() // second team won, moving on to next map
			}
			else if(wichmap == 2) {
				if(t_score[0][0] == t_score[1][0]) war_tied() // can't be tied
				else war_scoremsg() // either team won
			}
			else {
				if(t_score[0][0] == t_score[1][0]) { if(tiedgames == 0) war_tied(); else war_tiedend(); } // tie
				else war_scoremsg() // either team won
			}
		}
		else if(gametype == 4) {
			if(wichmap == 1) war_scoremsg() // moving on to next map
			else if(wichmap == 2) {
				if(t_score[0][0] == t_score[1][0]) { if(tiedgames == 0) war_tied(); else war_tiedend(); } // tie
				else war_scoremsg() // either team won
			}
			else {
				if(t_score[0][0] == t_score[1][0]) { if(tiedgames == 0) war_tied(); else war_tiedend(); } // tie
				else war_scoremsg() // either team won
			}
		}
	} // ENDIF 2nd half finished				
	return PLUGIN_CONTINUE
}

// the terrorists scored
public war_score_t() {
	if(half_active == 1) {
		if(war_live == 2) war_score_check(t2startside,1)
		else if(war_live == 4) war_score_check(t1startside,2)
	}
	else if((war_live%2 > 0) && (war_live != 5)) set_task(5.0,"war_warmup_info",876104)
	return PLUGIN_CONTINUE
}

// the counter-terrorists scored
public war_score_ct() {
	if(half_active == 1) {
		if(war_live == 2) war_score_check(t1startside,1)
		else if(war_live == 4) war_score_check(t2startside,2)
	}
	else if((war_live%2 > 0) && (war_live != 5)) set_task(5.0,"war_warmup_info",876104)
	return PLUGIN_CONTINUE
}

// displays important messages at beginning of round
public war_scoreinfo() {
	if(half_active == 1)
		if((gametype == 3) || (gametype == 4)) war_hudtext("hud_play1b",20,2,COL_BLUE,POS_CENTER,10)
		else war_hudtext("hud_play1a",20,2,COL_BLUE,POS_CENTER,10)
	return PLUGIN_CONTINUE
}

// checks to see if halftime or game end have been reaced, this function is a bastard with about a million if's
public war_score_check(scoringteam,scoringhalf) {
	t_score[scoringteam][scoringhalf]++
	t_score[scoringteam][0]++

#if defined SQL_SUPPORT_LIGHT || defined SQL_SUPPORT_EXTENDED
	new mysql = war_sqlinit()
	if(sql_matchid == 0) log_to_file(logfile,"Error: MySQL error: sql_matchid is zero")
	else if(mysql > 0) {
		new query[256],merror[128]
		format(query,255,"UPDATE awsmatches SET scoret%i=scoret%i+1, scoret%im%i=scoret%im%i+1 WHERE match_id='%i'",scoringteam+1,scoringteam+1,scoringteam+1,(wichmap == 2) ? 2 : 1,scoringteam+1,(wichmap == 2) ? 2 : 1,sql_matchid)
		mysql_query(mysql,query) 
		mysql_error(mysql,merror,127)
		if (merror[0]) log_to_file(logfile,"Error: MySQL error: %s",merror)
		mysql_close(mysql)
	}
	else log_to_file(logfile,"Error: MySQL error: Could not connect to MySQL DBase while updating scores")
#endif

	new sides[2][3] = { "CT", "T" }
	log_to_file(logfile,"Team %s playing as %s scored in %s round %i %s half, %i-%i",t_name[scoringteam],(scoringteam == scoringhalf-1) ? sides[t1startside] : sides[t2startside],mi[wichmap],period_number,(war_live <= 2) ? "1st" : "2nd",t_score[0][0],t_score[1][0])
	set_task(6.0,"war_scoreinfo",876106)
	if((gametype != 3) && (gametype != 4)) { // game played is not timelimit
		if(war_live == 2) { // 1st half
			if((gametype == 2) && (wichmap == 2) && ((t_score[0][0] > totrounds) || (t_score[1][0] > totrounds))) war_scoremsg() // one team won
			else { // go to 2nd half
				if(((gametype != 5) && (t_score[0][1]+t_score[1][1] == rounds)) || ((gametype == 5) && ((t_score[0][1] == rounds) || (t_score[1][1] == rounds)))) { // all rounds in 1st half played
					war_live = 3
					new x
					if(get_cvar_num("awc_autoteam") == 1) x = war_hudtext("hud_stop1a",20,2,COL_GREEN,POS_CENTER,10)
					else x = war_hudtext("hud_stop1b",20,2,COL_GREEN,POS_CENTER,10)
					log_to_file(logfile,"Round %i halftime, score: %s %i - %s %i",period_number,t_name[0],t_score[0][0],t_name[1],t_score[1][0])
					half_active = 0
					war_ss()
					set_task(float(x),"war_warmup",876110)
				} // ENDIF all rounds in 1st half played
			} // ENDIF go to 2nd half
		} // ENDIF 1st half
		if(war_live == 4) { // 2nd half
			if(wichmap == 0) { // only one map in the game
				if(gametype == 0) { // maxrounds+1 (mr)
					if((t_score[0][0] == t_score[1][0]) && (t_score[0][2]+t_score[1][2] == rounds)) { if(tiedgames == 0) war_tied(); else war_tiedend(); } // game is tied
					else if((t_score[0][0] > totrounds) || (t_score[1][0] > totrounds)) war_scoremsg()
				} // ENDIF maxrounds+1 (mr)
				else if(((gametype == 1) || (gametype == 2)) && (t_score[0][2]+t_score[1][2] == rounds)) { // maxrounds*2 (mx,mz)
					if(t_score[0][0] == t_score[1][0]) { if(tiedgames == 0) war_tied(); else war_tiedend(); }
					else war_scoremsg()
				} // ENDIF maxrounds*2 (mx,mz)
				else if((gametype == 5) && ((t_score[0][2] == rounds) || (t_score[1][2] == rounds))) { // winlimit (wl)
					if(t_score[0][0] == t_score[1][0]) { if(tiedgames == 0) war_tied(); else war_tiedend(); }
					else war_scoremsg()
				} // ENDIF winlimit (wl)
			} // ENDIF only one map in the game
			else if(wichmap == 1) { // 2 maps, first map
				if(gametype == 0) { // two individual maps (mr)
					if((t_score[0][0] == t_score[1][0]) && (t_score[0][2]+t_score[1][2] == rounds)) war_tied() // first map in mr games cannot be tied
					else if(t_score[0][0] > totrounds) { wichmap = 0; war_scoremsg(); } // if team1 wins first it's over
					else if(t_score[1][0] > totrounds) { war_scoremsg(); }
				} // ENDIF two individual maps (mr)
				else if(((gametype == 1) || (gametype == 2)) && (t_score[0][2]+t_score[1][2] == rounds)) war_scoremsg() // two maps (mx,mz)
			} // ENDIF 2 maps, first map
			else if(wichmap == 2) { // 2 maps, second map
				if(gametype == 0) { // two individual maps (mr)
					if((t_score[0][0] == t_score[1][0]) && (t_score[0][2]+t_score[1][2] == rounds)) war_tied() // second map in mr games cannot be tied
					else if((t_score[0][0] > totrounds) || (t_score[1][0] > totrounds)) war_scoremsg()
				} // ENDIF two individual maps (mr)
				else if((gametype == 1) && (t_score[0][2]+t_score[1][2] == rounds)) { // two maps (mx)
					if(t_score[0][0] == t_score[1][0]) {if(tiedgames == 0) war_tied(); else war_tiedend(); } // game is tied
					else war_scoremsg() // one team won
				} // ENDIF two maps (mx)
				else if(gametype == 2) {
					if((t_score[0][0] == t_score[1][0]) && (t_score[0][2]+t_score[1][2] == rounds)) { if(tiedgames == 0) war_tied(); else war_tiedend(); }
					else if((t_score[0][0] > totrounds) || (t_score[1][0] > totrounds)) war_scoremsg() // one team won
				}
			} // ENDIF 2 maps, second map
		} // ENDIF 2nd half
	} // ENDIF game played is not timelimit
	return PLUGIN_CONTINUE
}

// if war is tied, enter overtime
public war_tied() {
	half_active = 0
	war_live = 1
	if(period_number == 0) { // overtime is even-down(rounds)/2-1
		while(rounds%2 > 0) rounds--
		rounds = (rounds/2)-1
		if(rounds < 3) rounds = 3 // atleast 3 rounds in overtime
	}
	totrounds += rounds
	period_number++
	new x
	if(get_cvar_num("awc_autoteam") == 1) x = war_hudtext("hud_stop2a",20,2,COL_BLUE,POS_CENTER,6)
	else x = war_hudtext("hud_stop2b",20,2,COL_BLUE,POS_CENTER,6)
	if(gametype < 3) gametype = 0 // mr overtime games should only go to mr+1
	log_to_file(logfile,"Clanmatch tied after %s round %i, score: %s %i - %s %i",mi[wichmap],period_number,t_name[0],t_score[0][0],t_name[1],t_score[1][0])
	set_task(float(x+ 4),"war_warmup",876110)
	war_ss()
	return PLUGIN_CONTINUE
}

// if game is tied and tiedgames == 1, match end here
public war_tiedend() {
	half_active = 0
#if defined SQL_SUPPORT_LIGHT || defined SQL_SUPPORT_EXTENDED
	new mysql = war_sqlinit()
	if(sql_matchid == 0) log_to_file(logfile,"Error: MySQL error: sql_matchid is zero")
	else if(mysql > 0) {
		new query[256],merror[128],sql_datetime[32]
		get_time("%Y-%m-%d %H:%M:%S",sql_datetime,31)
		if(wichmap != 2) format(query,255,"UPDATE awsmatches SET endtime='%s', completed='%i' WHERE match_id='%i'",sql_datetime,2,sql_matchid)
		else format(query,255,"UPDATE awsmatches SET endtime='%s', completed='%i' WHERE match_id='%i'",sql_datetime,2,sql_matchid)
		mysql_query(mysql,query) 
		mysql_error(mysql,merror,127)
		if (merror[0]) log_to_file(logfile,"Error: MySQL error: %s",merror)
		mysql_close(mysql)
	}
	else log_to_file(logfile,"Error: MySQL error: Could not connect to MySQL DBase while finishing match")

#endif
	new x = war_hudtext("hud_stop5",60,2,COL_GREEN,POS_CENTER,10)
	log_to_file(logfile,"Clanmatch finished, it's a tie^nFinal score: %s %i - %s %i",t_name[0],t_score[0][0],t_name[1],t_score[1][0])
	set_task(float(x),"war_end")
}

// changes to second map
public war_to2ndmap() {
	war_live = 0
	server_cmd("changelevel %s", map2)
	return PLUGIN_CONTINUE
}

// endscore
public war_scoremsg() {
	remove_task(876106)
	new x
	half_active = 0
	war_live = 5
	if(wichmap == 1) { // will start second map
		x = war_hudtext("hud_stop3",30,2,COL_GREEN,POS_CENTER,10)
		log_to_file(logfile,"1st map finished, score: %s %i - %s %i",t_name[0],t_score[0][0],t_name[1],t_score[1][0])
		wichmap = 2
		set_vaultdata("aws_currentmap", "2")
		war_clearready()
		new tmp[4]
		if((gametype == 0) || (gametype == 3)) {
			set_vaultdata("aws_team1score","-1")
			set_vaultdata("aws_team2score","-1")
		}
		else {
			numtostr(t_score[0][0],tmp,3)
			set_vaultdata("aws_team1score",tmp)
			numtostr(t_score[1][0],tmp,3)
			set_vaultdata("aws_team2score",tmp)
		}

#if defined HLTV_SUPPORT
		war_hltvstop()
#endif
		set_task(float(x),"war_to2ndmap",876108)
		war_countdowntimer = x
		set_task(1.0,"war_levelcountdown",876107,"",0,"b")
	}
	else { // match ended
#if defined SQL_SUPPORT_LIGHT || defined SQL_SUPPORT_EXTENDED
		new mysql = war_sqlinit()
		if(sql_matchid == 0) log_to_file(logfile,"Error: MySQL error: sql_matchid is zero")
		else if(mysql > 0) {
			new query[256],merror[128],sql_datetime[32]
			get_time("%Y-%m-%d %H:%M:%S",sql_datetime,31)
			if(wichmap != 2) format(query,255,"UPDATE awsmatches SET endtime='%s', completed='%i' WHERE match_id=%i",sql_datetime,2,sql_matchid)
			else format(query,255,"UPDATE awsmatches SET endtime='%s', completed='%i' WHERE match_id=%i",sql_datetime,2,sql_matchid)
			mysql_query(mysql,query) 
			mysql_error(mysql,merror,127)
			if (merror[0]) log_to_file(logfile,"Error: MySQL error: %s",merror)
			mysql_close(mysql)
		}
		else log_to_file(logfile,"Error: MySQL error: Could not connect to MySQL DBase while finishing match")
#endif
		war_endhack()
		set_task(5.0,"war_endhack")
		log_to_file(logfile,"Clanmatch finished, final score: %s %i - %s %i",t_name[0],t_score[0][0],t_name[1],t_score[1][0])
		set_task(10.0,"war_end")
	}
	war_ss()
	return PLUGIN_CONTINUE
}

// LAME!!!!
public war_endhack() war_hudtext("hud_stop4",60,2,COL_GREEN,POS_CENTER,10)

// counts down to map change
public war_levelcountdown() {
	war_hudtext("hud_stop7",2,2,COL_GREEN,POS_BOTTOM,14)
	if(war_countdowntimer > 0) war_countdowntimer--
	else remove_task(876107)
	return PLUGIN_CONTINUE
}

// ============================================================================
// =============================== END MATCH ==================================
// ============================================================================

// called when match end
public war_end() {
	war_clearvault()
	wichmap = 0
	war_live = 0
	war_countdowntimer = 0
	war_clearready()
	remove_task(876101) // abort all tasks, just in case
	remove_task(876102)
	remove_task(876103)
	remove_task(876104)
	remove_task(876105)
	remove_task(876106)
	remove_task(876107)
	remove_task(876108)
	remove_task(876109)
	remove_task(876110)
	remove_task(876111) //            - "" -
#if defined HLTV_SUPPORT
	if(hltv_address != -1) war_hltvstop()
#endif
	if(get_cvar_num("awc_noshield") == 1) { server_cmd("amx_restrict off shield"); client_print(0,print_chat,"Tactical shield has been enabled"); }
	new tmp[64]
	get_cvar_string("awc_penacfg",tmp,63)
	server_cmd("exec ^"%s^"",tmp)
	get_cvar_string("awc_pubcfg",tmp,63)
	server_cmd("exec ^"%s^"",tmp)
	if(!equal(war_password,"NOTHING")) server_cmd("sv_password ^"^"")
	if(hltv_address == -1) {	
		log_to_file(logfile,"End AMX WAR plugin, goodbye")
		log_to_file(logfile,"********************************************************************************************")
	}
	return PLUGIN_HANDLED
}

// used to abort a match immediately
public war_abort(id) {
	if (id && !((get_user_flags(id) & ADMIN_LEVEL_A))) { 
		war_clienttext("clt_noaccess",id)
		return PLUGIN_HANDLED
	}
	if(war_live == 0) return PLUGIN_HANDLED
	new adminname[32]
	get_user_name(id,adminname,31)
	war_hudtext("hud_stop6",20,2,COL_RED,POS_CENTER,6)
	war_clienttext("clt_start4",id)
#if defined SQL_SUPPORT_LIGHT || defined SQL_SUPPORT_EXTENDED
	new mysql = war_sqlinit()
	if(sql_matchid == 0) log_to_file(logfile,"Error: Fatal MySQL error: sql_matchid is zero")
	else if(mysql > 0) {
		new query[256],merror[128],sql_datetime[32]
		get_time("%Y-%m-%d %H:%M:%S",sql_datetime,31)
		format(query,255,"UPDATE awsmatches SET endtime='%s', completed='%i' WHERE match_id='%i'",sql_datetime,0,sql_matchid)
		mysql_query(mysql,query) 
		mysql_error(mysql,merror,127)
		if (merror[0]) log_to_file(logfile,"Error: MySQL error: %s",merror)
		mysql_close(mysql)
	}
	else log_to_file(logfile,"Error: Could not connect to MySQL DBase")
#endif
	log_to_file(logfile,"Clanmatch aborted by %s",adminname)
	war_end()
	return PLUGIN_HANDLED
}

// ============================================================================
// ================================ HLTV ======================================
// ============================================================================

#if defined HLTV_SUPPORT

// start recording of hltv demo
public war_hltvrecord() {
	if(hltv_address == -1) return PLUGIN_CONTINUE

	new demoname[128]
	format(demoname,127,"%s-vs-%s-hltv",t_name[0],t_name[1]) 

	// Remove bad strings before recording 
	while(replace(demoname,256,"/","-")) {}    
	while(replace(demoname,256,"\","-")) {} 
	while(replace(demoname,256,":","-")) {} 
	while(replace(demoname,256,"*","-")) {} 
	while(replace(demoname,256,"?","-")) {} 
	while(replace(demoname,256,">","-")) {} 
	while(replace(demoname,256,"<","-")) {} 
	while(replace(demoname,256,"|","-")) {} 

	log_to_file(logfile,"Started recording HLTV demo to %s",demoname)
	format(demoname,127,"record %s",demoname)
	hltv_rcon(0,demoname)
	war_clienttext("clt_info2a",0)
	return PLUGIN_CONTINUE
}    

// stop recording of hltv demo
public war_hltvstop() { 
	if(hltv_address == -1) return PLUGIN_CONTINUE
	hltv_rcon(0,"stoprecording")
	war_clienttext("clt_info2b",0)
	log_to_file(logfile,"Stopped recording HLTV demo")
	if(wichmap != 2) {
		log_to_file(logfile,"End AMX WAR plugin, goodbye")
		log_to_file(logfile,"********************************************************************************************")
	}
	return PLUGIN_CONTINUE
}

// command to set up hltv
public war_hltv(id) {
	if (id && !((get_user_flags(id) & ADMIN_LEVEL_A))) { 
		war_clienttext("clt_noaccess",id)
		return PLUGIN_CONTINUE
	}
	if((war_live == 0) || (war_live == 1)) {
		if(read_argc() != 2) {
			war_clienttext("clt_info5b",id)
			return PLUGIN_CONTINUE
		}

		new players[32],num_players,i
		get_players(players,num_players,"")
		for(i=0;i<num_players;i++) {
			if(is_user_hltv(players[i])) {
				hltv_id = players[i]
				break
			}
		}
		read_argv(1,hltv_pass,31)
		if(equal(hltv_pass,"0")) {
			hltv_address = -1
			hltv_id = 0
			client_print(id,print_console,"HLTV disabled")
			return PLUGIN_CONTINUE
		}
		if(hltv_id) {
			new ip[32],address[32]
			get_user_ip(hltv_id,ip,31)
			new pos = copyc(address,31,ip,':') + 1
			hltv_address = set_iaddress(address,strtonum(ip[pos]))
			client_print(id,print_console,"If HLTV proxy says ^"HLTV initialized^", everything is ok, otherwise HLTV is disabled")
			hltv_rcon(id,"say HLTV initialized")
		}
		else {
			hltv_address = -1
			client_print(id,print_console,"No HLTV proxy found in game")
		}
	}
	else {
		client_print(id,print_console,"HLTV cannot be initialized while a match is in progress")
	}
	return PLUGIN_CONTINUE
}

// send rcon command to hltv server
public hltv_rcon(id,cmd[]) {
	if((hltv_address == -1) || (hltv_id == 0)) {
		hltv_address = -1
		return PLUGIN_CONTINUE
	}

	new rcv[256],snd[256]
	new rconid[13]

	setc(snd,4,0xff) 
	copy(snd[4],255,"challenge rcon") 
	setc(snd[18],1,'^n') 
	new chk = query_udp_msg(hltv_address,rcv,255,snd) 
	if(chk) {
		copy(rconid,12,rcv[15]) 
		replace(rconid,255,"^n","") 
		setc(snd,4,0xff) 
		format(snd[4],255,"rcon %s ^"%s^" %s ^n",rconid,hltv_pass,cmd)
		send_udp_msg(hltv_address,snd)
	}
	return PLUGIN_CONTINUE
}

public client_putinserver(id) { 
	if ((is_user_hltv(id)) && (hltv_address == -1) && (strlen(hltv_pass) > 0)) {
		hltv_id = id
		new ip[32],address[32]
		get_user_ip(hltv_id,ip,31)
		new pos = copyc(address,31,ip,':') + 1
		hltv_address = set_iaddress(address,strtonum(ip[pos]))
		hltv_rcon(id,"say HLTV initialized")
	}
	return PLUGIN_CONTINUE 
} 

#endif

// ============================================================================
// ================================= MENU =====================================
// ============================================================================

public war_action_mm(id,key) {
	switch(key){
		case 0:
			if((war_live == 0) && (war_live != 5)) war_show_wm(id)
		case 1:
			if(war_live > 0) war_abort(id)
		case 2:
			if((war_live != 0) && (war_live%2 > 0) && (war_live != 5)) war_forcestart(id)
		case 3:
			war_show_sm(id)
	}
	return PLUGIN_HANDLED
}

public war_show_mm(id) {
	if (id && !((get_user_flags(id) & ADMIN_LEVEL_A))) { 
		war_clienttext("clt_noaccess",id)
		return PLUGIN_HANDLED
	}
	new menu_body[512]
	new len = copy(menu_body,511,"\yAMX War System^n^n")
	new keys = (1<<9)|(1<<3)

	if(war_live > 0) {
		len += copy(menu_body[len],511-len,"\d1. Start a Match^n\w2. Abort current match^n")
		keys |= (1<<1)
	}
	else {
		len += copy(menu_body[len],511-len,"\w1. Start a Match^n\d2. Abort current match^n")
		keys |= (1<<0)
	}

	if((war_live > 0) && (war_live%2 > 0) && (war_live != 5)) {
		len += copy(menu_body[len],511-len,"\w3. Autostart current match^n")
		keys |= (1<<2)
	}
	else len += copy(menu_body[len],511-len,"\d3. Autostart current match^n")

	copy(menu_body[len],511-len,"\w4. Settings^n^n0. Exit")

	war_loadini()
	war_findtags()
	show_menu(id,keys,menu_body)
	return PLUGIN_HANDLED
}

public war_action_sm(id,key) {
	switch(key) {
		case 9:
			war_show_mm(id)
		case 0: {
			new x = get_cvar_num("awc_tie")+1
			if(x > 1) x = 0
			set_cvar_num("awc_tie",x)
			war_show_sm(id)
		}
		case 1: {
			new tmp = get_cvar_num("awc_countdowntime")
			if(tmp < 60) tmp += 5
			else tmp = 5
			set_cvar_num("awc_countdowntime",tmp)
			war_show_sm(id)
		}
		case 2: {
			new x = get_cvar_num("awc_noshield")+1
			if(x > 1) x = 0
			set_cvar_num("awc_noshield",x)
			war_show_sm(id)
		}
		case 3: {
			new x = get_cvar_num("awc_cointoss")+1
			if(x > 1) x = 0
			set_cvar_num("awc_cointoss",x)
			war_show_sm(id)
		}
		case 4: {
			new x = get_cvar_num("awc_autoteam")+1
			if(x > 1) x = 0
			set_cvar_num("awc_autoteam",x)
			war_show_sm(id)
		}
		case 5: {
			new x = get_cvar_num("awc_clantagcheck")+1
			if(x > 1) x = 0
			set_cvar_num("awc_clantagcheck",x)
			war_show_sm(id)
		}
		case 6: {
			new x = get_cvar_num("awc_demos")+1
			if(x > 2) x = 0
			set_cvar_num("awc_demos",x)
			war_show_sm(id)
		}
		case 7: {
			new x = get_cvar_num("awc_screenshots")+1
			if(x > 2) x = 0
			set_cvar_num("awc_screenshots",x)
			war_show_sm(id)
		}
	}
	return PLUGIN_HANDLED
}

public war_show_sm(id) {
	new tmp[4],menu_body[512]
	numtostr(get_cvar_num("awc_countdowntime"),tmp,4)
	new keys = (1<<9)
	new len = copy(menu_body,511,"\yAMX War Settings^n\dIf two maps are being played and gametype is either mr or tl,^ntied games switch has no effect^nCointoss will randomly choose wich team begins as CT^n^n")
	new q_format[3][8] = { "No", "Yes", "Ask" }
	war_fixcvar("awc_tie",0,1)
	war_fixcvar("awc_noshield",0,1)
	war_fixcvar("awc_cointoss",0,1)
	war_fixcvar("awc_autoteam",0,1)
	war_fixcvar("awc_clantagcheck",0,1)
	war_fixcvar("awc_demos",0,2)
	war_fixcvar("awc_screenshots",0,2)

	if((war_live != 0) && (war_live != 5)) {
		len += format(menu_body[len],511-len,"\d1. Tied games\R%s^n2. Countdown Timer\R%s^n3. Disable Tactical Shield (cs 1.6)\R%s^n4. Cointoss CT/T teams\R%s^n",q_format[get_cvar_num("awc_tie")],tmp,q_format[get_cvar_num("awc_noshield")],q_format[get_cvar_num("awc_cointoss")])
		len += format(menu_body[len],511-len,"\w5. Autoassign teams\R\y%s^n\w6. Require clantags\R\y%s^n\d7. Record client demos\R%s^n\w8. Take client screenshots\R\y%s^n^n\w0. Back",q_format[get_cvar_num("awc_autoteam")],q_format[get_cvar_num("awc_clantagcheck")],q_format[get_cvar_num("awc_demos")],q_format[get_cvar_num("awc_screenshots")])
		keys |= (1<<4)|(1<<5)|(1<<7)
	}
	else {
		len += format(menu_body[len],511-len,"\w1. Tied games\R\y%s^n\w2. Countdown Timer\R\y%s^n\w3. Disable Tactical Shield (cs 1.6)\R\y%s^n\w4. Cointoss CT/T teams\R\y%s^n",q_format[get_cvar_num("awc_tie")],tmp,q_format[get_cvar_num("awc_noshield")],q_format[get_cvar_num("awc_cointoss")])
		len += format(menu_body[len],511-len,"\w5. Autoassign teams\R\y%s^n\w6. Require clantags\R\y%s^n\w7. Record client demos\R\y%s^n\w8. Take client screenshots\R\y%s^n^n\w0. Back",q_format[get_cvar_num("awc_autoteam")],q_format[get_cvar_num("awc_clantagcheck")],q_format[get_cvar_num("awc_demos")],q_format[get_cvar_num("awc_screenshots")])
		keys |= (1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)
	}

	show_menu(id,keys,menu_body)
	return PLUGIN_HANDLED
}

public war_action_wm(id,key){
	switch(key) {
		case 8: {
			new temp[512],curmap[32],ctmp1[32],ctmp2[32]
			get_mapname(curmap,31)
			if(contain(clans[clan1_toshow],"(AUTO)") != -1)
				copy(ctmp1,strlen(clans[clan1_toshow])-6,clans[clan1_toshow])
			else copy(ctmp1,31,clans[clan1_toshow])

			if(contain(clans[clan2_toshow],"(AUTO)") != -1)
				copy(ctmp2,strlen(clans[clan2_toshow])-6,clans[clan2_toshow])
			else copy(ctmp2,31,clans[clan2_toshow])

			format(temp,512,"amxwar %s %s %i %s%i %s %s cfg=%s %i",ctmp1,ctmp2,menu_minready,menu_gametype,menu_maxrounds,(map1_toshow == 1) ? curmap : maps[map1_toshow],(map2_toshow != 0) ? maps[map2_toshow] : "",cfgs[cfg_toshow])
			client_cmd(id,temp)
		}
		case 9:
			war_show_mm(id)
		case 0: {
			if(clan1_toshow == num_clans-1) clan1_toshow = 0
			else clan1_toshow++
			if(clan1_toshow == clan2_toshow)
				if(clan1_toshow >= num_clans-1) clan1_toshow = 0
				else clan1_toshow++
			war_show_wm(id)
		}
		case 1: {
			if(clan2_toshow == num_clans-1) clan2_toshow = 0
			else clan2_toshow++
			if(clan2_toshow == clan1_toshow)
				if(clan2_toshow >= num_clans-1) clan2_toshow = 0
				else clan2_toshow++
			war_show_wm(id)
		}
		case 2: {
			if(menu_minready >= 10) menu_minready = 1
			else menu_minready++
			war_show_wm(id)
		}
		case 3: {
			if(menu_maxrounds >= 120) menu_maxrounds = 2
			else if(menu_maxrounds >= 60) menu_maxrounds += 10
			else if(menu_maxrounds >= 20) menu_maxrounds += 5
			else menu_maxrounds++
			war_show_wm(id)
		}
		case 4: {
			if(equal(menu_gametype,"mr")) copy(menu_gametype,2,"mx")
			else if(equal(menu_gametype,"mx")) copy(menu_gametype,2,"mz")
			else if(equal(menu_gametype,"mz")) copy(menu_gametype,2,"tl")
			else if(equal(menu_gametype,"tl")) copy(menu_gametype,2,"tx")
			else if(equal(menu_gametype,"tx")) copy(menu_gametype,2,"wl")
			else if(equal(menu_gametype,"wl")) copy(menu_gametype,2,"mr")
			war_show_wm(id)
		}
		case 5: {
			if(map1_toshow >= num_maps-1) map1_toshow = 1
			else map1_toshow++
			war_show_wm(id)
		}
		case 6: {
			if(map2_toshow >= num_maps-1) map2_toshow = 0
			else if(map2_toshow == 0) map2_toshow = 2
			else map2_toshow++
			war_show_wm(id)
		}
		case 7: {
			if(cfg_toshow >= num_cfgs-1) cfg_toshow = 0
			else cfg_toshow++
			war_show_wm(id)
		}
	}
	return PLUGIN_HANDLED
}

public war_show_wm(id) {
	new menu_body[512],tmp1[4],tmp2[4]
	numtostr(menu_minready,tmp1,4)
	numtostr(menu_maxrounds,tmp2,4)
	new keys = (1<<9)|(1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)
	new len = format(menu_body,511,"\yAMX War Start^n^n\w1. Team 1 (CT)\R\y%s^n\w2. Team 2 (T)\R\y%s^n\w3. Players on each team\R\y%s^n\w4. ",clans[clan1_toshow],clans[clan2_toshow],tmp1)
	if((equal(menu_gametype,"tl")) || (equal(menu_gametype,"tx"))) len += copy(menu_body[len],511-len,"Timelimit")
	else if(equal(menu_gametype,"wl")) len += copy(menu_body[len],511-len,"Winlimit")
	else len += copy(menu_body[len],511-len,"Maxrounds")
	format(menu_body[len],511-len,"\R\y%s^n\w5. Gametype\R\y%s^n\w6. Map 1\R\y%s^n\w7. Map 2\R\y%s^n\w8. Configfile\R\y%s^n^n\w9. Start War^n0. Back",tmp2,menu_gametype,maps[map1_toshow],maps[map2_toshow],cfgs[cfg_toshow])
	show_menu(id,keys,menu_body)
	return PLUGIN_HANDLED
}

public war_loadini() {
	new inifile[64] = "addons/amx/plugins/amxwar/clans.ini"
	if (!file_exists(inifile)) return 0
	new text[128], tag[32], len, pos = 0
	num_clans = 0
	while(read_file(inifile,pos++,text,127,len)) {
		if ((text[0] != ';') && (strlen(text) > 1) && (num_clans < 64)) { // ; = comment
			copy(tag,31,text)
			clans[num_clans] = tag
			num_clans++
		}
	}

	format(inifile,63,"addons/amx/plugins/amxwar/maps.ini")
	if (!file_exists(inifile)) return 0
	pos = 0
	num_maps = 2
	maps[0] = "None"
	maps[1] = "Current"
	while(read_file(inifile,pos++,text,127,len)) {
		if ((text[0] != ';') && (strlen(text) > 1) && (num_maps < 32)) {
			copy(tag,32,text)
			maps[num_maps] = tag
			num_maps++
		}
	}

	copy(cfgs[num_cfgs],31,"default")
	num_cfgs = 1
	for(new i=1;read_dir("addons/amx/plugins/amxwar/cfg",i,tag,32,pos);i++) {
		if((contain(tag,".cfg") != -1) && (i<64)) {
			if(!equali(tag,"default.cfg")) {
				copyc(cfgs[num_cfgs],31,tag,'.') 
				num_cfgs++
			}
		}       
	}
	return PLUGIN_CONTINUE
}

//tries to autodetect clantags
public war_findtags() {
	new players[32],playernames[32][64],tags[32][32],num_players
	new i,k,x,y = 0,chk
	get_players(players,num_players,"")
	for(i = 0;i<num_players;i++) get_user_name(players[i],playernames[i],63)
	for(i = 0;i<num_players;i++) { //do for each player
		new z = 0; x = 0
		for(new j = i+1;j<num_players;j++) { //do for each player after current player
			k = 0 // counter for how many letters are equal
			while((equal(playernames[i],playernames[j],k+1)) && (k < min(strlen(playernames[i]),strlen(playernames[j])))) k++ //one more letter, will not add more if we are at end of one players name
			if((k >= MENU_MIN_TAGLENGTH) && ((z > k) || (x == 0))) z = k // if the tag is of min lenght and it is shorter than already found tag or it is the first tag found in wich case we don't have to worry about taglength
			if((z >= MENU_MIN_TAGLENGTH) && (k >= MENU_MIN_TAGLENGTH)) x++ // if it is a valid taglenth we will add a tag to the list
		}
		if(x >= MENU_MIN_TAGNUMBER-1) { // if there are enough players with this tag
			chk = true
			for(k=0;k<y;k++) if(equal(tags[k],playernames[i],z)) chk = false // don't add tag if already found in taglist
			if(chk) { copy(tags[y],z,playernames[i]); y++; } //this will add the new tag to the list & increase the number of tags in the list
		}
	}
	if((y > 0) && (y+num_clans < 64)) { // atleast one new tag and we cannot go over the clantag limit
		k = 0
		for(i=0;i<y;i++) {
			new tmp[64]
			chk = true
			if(tags[i][strlen(tags[i])-1] == ' ') tags[i][strlen(tags[i])-1] = 0 // removes letters at end of tag wich should not be there
			if(tags[i][strlen(tags[i])-1] == '|') tags[i][strlen(tags[i])-1] = 0
			if(tags[i][strlen(tags[i])-1] == '.') tags[i][strlen(tags[i])-1] = 0
			if(tags[i][strlen(tags[i])-1] == ' ') tags[i][strlen(tags[i])-1] = 0
			format(tmp,63,"^"%s^" (AUTO)",tags[i]) // add the string " (AUTO)" at end of tag to show user it has been autodetected
			for(new j=0;j<num_clans;j++) if(equal(tmp,clans[j],strlen(tmp)-6)) chk = false // don't add tag if already found in clanlist
			if(chk) { copy(clans[num_clans+i],64,tmp); k++; } // add the tag to the clanlist
		}
		num_clans = num_clans+k // we now have more clans
		clan1_toshow = num_clans-k+1 // show the first autodetected clantag as first team
		if(k > 1) clan2_toshow = clan1_toshow+1 // show the second autodetected clantag as second team IF more than one clantag has been added
	}
	return PLUGIN_CONTINUE
}

// ============================================================================
// ================================= SQL ======================================
// ============================================================================

#if defined SQL_SUPPORT_LIGHT || defined SQL_SUPPORT_EXTENDED

public war_sqlinit() { // saves match info
	new mhost[64],muser[32],mpass[32],merror[128],mdb[32]
	get_cvar_string("amx_mysql_host",mhost,64) 
	get_cvar_string("amx_mysql_user",muser,32) 
	get_cvar_string("amx_mysql_pass",mpass,32) 
	get_cvar_string("amx_mysql_db",mdb,32) 
	return mysql_connect(mhost,muser,mpass,mdb,merror,127)
}

#endif

public war_testhud() {
	new msg[256]
	format(msg,255,"xxxxxxxxx1xxxxxxxxx2xxxxxxxxx3xxxxxxxxx4xxxxxxxxx5xxxxxxxxx6xxxxxxxxx7xxxxxxxxx8xxxxxxxxx9xxxxxxxxx0xxxxxxxxx1xxxxxxxxx2xxxxxxxxx3xxxxxxxxx4")

	set_hudmessage(255,255,255, -1.0, -1.0, 0, 6.0, 20.0, 0.2, 0.2, 10)
	show_hudmessage(0,msg)
	return PLUGIN_HANDLED
}

// ============================================================================
// ================================= INIT =====================================
// ============================================================================

public plugin_init() {
	register_plugin("AMX War System", AW_VERSION, "Grisbilen") 

	register_cvar("awc_countdowntime", "10")
	register_cvar("awc_tie", "0")
	register_cvar("awc_noshield", "1")
	register_cvar("awc_cointoss", "1")
	register_cvar("awc_autoteam", "1")
	register_cvar("awc_clantagcheck", "1")
	register_cvar("awc_screenshots", "2")
	register_cvar("awc_demos", "2")
	register_cvar("awc_pubcfg", "server.cfg")
	register_cvar("awc_pdiscfg", "addons/amx/plugins/amxwar/pd.cfg")
	register_cvar("awc_penacfg", "addons/amx/plugins/amxwar/pe.cfg")

	register_event("SendAudio","war_score_t","a","2=%!MRAD_terwin") // terrorists wins
	register_event("SendAudio","war_score_ct","a","2=%!MRAD_ctwin") // ct wins

	register_concmd("amxwar","war_begin")
	register_concmd("aw","war_begin")
	register_concmd("awabort","war_abort")
	register_concmd("awstart","war_forcestart")

	register_clcmd("amxwar","war_begin",ADMIN_LEVEL_A,"- Starts a clanmatch")
	register_clcmd("aw","war_begin",ADMIN_LEVEL_A,"- Starts a clanmatch")
	register_clcmd("awabort","war_abort",ADMIN_LEVEL_A,"- Aborts a clanmatch immediately")
	register_clcmd("awstart","war_forcestart",ADMIN_LEVEL_A,"- Starts a warround immediately")

	register_clcmd("testhud","war_testhud",ADMIN_LEVEL_A,"- Starts a clanmatch")

#if defined HLTV_SUPPORT
	register_concmd("awhltv","war_hltv")
	register_clcmd("awhltv","war_hltv",ADMIN_LEVEL_A,"- Configures HLTV for amxwar")
#endif

	register_clcmd("say ready","war_readycheck")
	register_clcmd("say notready","war_notreadycheck")
	register_clcmd("say_team score","war_get_score")
	register_clcmd("say_team timeleft","war_gettime")
	register_clcmd("say timeleft","war_gettime")
	register_clcmd("timeleft","war_gettime")

	// Menu
	register_menucmd(register_menuid("\yAMX War Settings"),1023,"war_action_sm")
	register_menucmd(register_menuid("\yAMX War Start"),1023,"war_action_wm")
	register_menucmd(register_menuid("\yAMX War System"),1023,"war_action_mm")
	register_clcmd("awmenu","war_show_mm",ADMIN_LEVEL_A,"- displays war system menu")

	register_menucmd(register_menuid("\yScreenshot"),1023,"war_ss_action")
	register_menucmd(register_menuid("\yRecord Demo"),1023,"war_demo_action")
	register_menucmd(register_menuid("\yStop Recording"),1023,"war_demo_off_action")
	
	new tmp[4]
	get_vaultdata("aws_initialized",tmp,3)
	if(strtonum(tmp) == 0) server_cmd("exec addons/amx/plugins/amxwar/amxwar.cfg")

	new hostname[64]
	get_cvar_string("hostname",hostname,63) 
	while(replace(hostname,64,"/","-")) {}
	while(replace(hostname,64,"\","-")) {}
	while(replace(hostname,64,":","-")) {}
	while(replace(hostname,64,"*","-")) {}
	while(replace(hostname,64,"?","-")) {}
	while(replace(hostname,64,">","-")) {}
	while(replace(hostname,64,"<","-")) {}
	while(replace(hostname,64,"|","-")) {}
	while(replace(hostname,64," ","-")) {}
	format(logfile,255,"amxwar-%s-",hostname)
	get_time("%m%d.log",hostname,63)
	add(logfile,255,hostname)

	if(strtonum(tmp) == 1) set_task(5.0,"war_startmapchange",0)

	return PLUGIN_CONTINUE
}

/*
Task list:
876101	war start
876102	warmup hudmsg
876103	countdown
876104	warmup info
876105	timelimit
876106	scoreinfo
876107	hltv countdown
876108	change map
876109	starthud
876110	warmup
876111	cointoss init
*/
