

/* AMX_HOOK 
* Original Code by: Spacedude 
* 
* Coded by: {W`C} Bludy 
* Fixes by: GeekGod and Ivn-Software 
* 
* This plugin was created to replace the hookmod4.dll/.so.  Originally ninjarope.sma was required 
* but this dependency didn't ever seem necessary.  -GeekGod 
* 
* It is turned on and off with the same cvar sv_hook 
* 
* Description: Gives all players the ability to use the command +hook 
* It is very similar to hookmod4, and this plugin does nothing that hookmod cannot already do 
* It instantly shoots a hook where you are aiming, and it pulls you toward that point at a set 
* rate of speed (sv_hookforce). 
* 
* Plugin includes a help motd when a player says /hook, It has the description on how to 
* bind keys to +hook 
* 
* CVARS: 
* sv_hook - Turns hooking on and off (Same as the Grappling hook) 
* sv_hookforce - Controls the speed of the player while hooked.  default: 600 
* sv_hookwidth - Width of beam for hooks. default: 5 
* sv_hooknoise - Noise of beams for hooks 
* sv_hookcolor - 0 = all white beams 1 = team based colored beams. default: 0 
* sv_brightness - Brightness of beams for hooks 
* sv_hookspeed - Speed of beam for hooks (Does not affect speed of player) 
* sv_hookmsgs - 0 = no messages | 1 = notifys when you hook on/off walls | 2 = notifys when you 
*               hook a player | 3 = Show all msgs.  default: 0 
* sv_hooksound - Controls whether to make sounds for hooks. deafult: 1 
* sv_hook_on_maxspeed - speed user will be set to during hook operation. default: 0.01 
* sv_hook_on_gravity - gravity user will be set to during hook operation. default: 0.1 
* sv_hook_off_maxspeed - speed user will be set to after hook operation. default: 280.0 
* sv_hook_off_gravity -  gravity user will be set to after hook operation. default: 0 
* sv_hook_notify_when_active - notifies users when hookgrab mod is enabled. default: 1 
* sv_hook_auto_bind - if set to something other than 0, client will automatically bind 
*                     a key to this value.  Setting to q will auto bind the q key upon 
*                     client join. 
* sv_hook_redploy_when_firing - when client fires, the hook will redploy at what the 
*                               the person just fired at.  default is off. 
* 
* This plugin may seem useless because hookmod already does all of this and more, But I wrote this plugin 
* so I dont have to have the hookmod.dll in my metamod anymore. Most of this code was based/edited from 
* some of Spacedudes plugins, so original credit goes to him. 
* 
* This plugin uses the xtrafun module by Spacedude, you can get it at 
* http://amxmod.net/forums/viewtopic.php?t=10714 
* 
* CHANGES: 
* 12/24/03:  Added sv_hook_redploy_when firing cvar -GG 
* 12/24/03:  Added sv_hook_auto_bind option -GG 
* 12/24/03:  Added sv_hook_off_gravity, sv_hook_on_gravity, sv_hook_off_maxspeed 
*            and sv_hook_off_gravity cvars and removed previous harcoded values -GG 
* 12/23/03:  hard coded maxspeed and gravity values to make them work.  previously 
*            user could not move once hook was deployed. 
* 
*/ 
#include <amxmod> 
#include <fun>
#include <Vexd_Utilities>
#include <VexdUM_stock>

#define TE_BEAMENTPOINT 1 
#define TE_KILLBEAM 99 
#define BEAMLIFE 100 
#define DELTA_T 0.1 

new beam 
new Float:beamcreated[33] 

new grabbedorigin2[33][3] 
new look2[33][3] 
new grabbed[33] 

stock set_user_velocity(id, velocity[3]) {
  new Float:vel[3]
  IVecFVec(velocity, vel)
  entity_set_vector(id, EV_VEC_velocity, vel)
}

public client_putinserver(id) 
{ 
   if(get_cvar_num("sv_hook_auto_bind") != 0) 
   {    /* bind clients key */ 
        new bindkey[32] 
        get_cvar_string("sv_hook_auto_bind",bindkey,31) 
        client_cmd(id,"echo ^"[AMX] Binding +hook to %s key^"",bindkey) 
        client_cmd(id,"bind %s +hook",bindkey) 
   } 
} 

public hookgrab(id) 
{ 
   new cvar = get_cvar_num("sv_hook") 
   if (cvar == 1) 
   { 
      if(!is_user_alive(id)) 
      { 
         return PLUGIN_HANDLED 
      } 
      set_user_gravity(id,get_cvar_float("sv_hook_on_gravity")+0.1) 
      set_user_maxspeed(id,get_cvar_float("sv_hook_on_maxspeed")+0.1) 
      set_hookgrabbed(id) 
   } 
   return PLUGIN_HANDLED 
} 

public notify_hook_status(svIndex[]) 
{ 
    if(get_cvar_num("sv_hook_notify_when_active") == 1) 
    { 
        client_print(0,print_chat,"[AMX] HookGrab mod is active!  say /hook for more info.") 
    } 
    new sId[32] 
    sId[0] = 0 
    set_task(380.0,"notify_hook_status",0,sId,31) 
    return PLUGIN_CONTINUE 
} 

public set_hookgrabbed(id) 
{ 
   if(get_cvar_num("sv_hook") == 0) return PLUGIN_CONTINUE 
   grabbed[id] = id 
   new origin1[3], origin2[3] 
   get_user_origin(grabbed[id], origin1) 
   get_user_origin(grabbed[id], origin2,3) 
   set_user_gravity(id,get_cvar_float("sv_hook_on_gravity")+0.1) 
   set_user_maxspeed(id,get_cvar_float("sv_hook_on_maxspeed")+0.1) 
   new msgcvar = get_cvar_num("sv_hookmsgs") 
   if ((msgcvar == 1) || (msgcvar == 3)) 
   { 
      client_print(grabbed[id],print_notify,"[AMX] Your hooked onto the wall") 
   } 
   set_beam(id) 
   new soundcvar = get_cvar_num("sv_hooksound") 
   if (soundcvar == 1) 
   { 
      emit_sound(id, CHAN_STATIC, "weapons/xbow_hit1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM) 
   } 

   new hooktarget, body 
   get_user_aiming(grabbed[id],hooktarget,body) 

   if(hooktarget) 
   { 
      get_user_origin(hooktarget,grabbedorigin2[id]) 
      playerhit_sound(hooktarget) 
      new name[33] 
      get_user_name(hooktarget,name,32) 
      new msgcvar2 = get_cvar_num("sv_hookmsgs") 
      if ((msgcvar2 == 2) || (msgcvar2 == 3)) 
      { 
         client_print(grabbed[id],print_chat,"[AMX] You hooked onto %s",name) 
      } 
   } 
   new parm[1] 
   parm[0] = id 
   set_task(DELTA_T, "hookgrabtask", 101+id, parm, 1, "b") 
   return PLUGIN_CONTINUE 
} 

public set_beam(id) 
{ 

   new p_origin[3] 
   get_user_origin(grabbed[id], p_origin) 
   get_user_origin(grabbed[id], look2[id], 3) 

   new width = get_cvar_num("sv_hookwidth") 
   new noise = get_cvar_num("sv_hooknoise") 
   new color = get_cvar_num("sv_hookcolor") 
   new brightness = get_cvar_num("sv_hookbrightness") 
   new speed = get_cvar_num("sv_hookspeed") 

   message_begin( MSG_BROADCAST, SVC_TEMPENTITY ) 
   write_byte( TE_BEAMENTPOINT ) 
   write_short ( grabbed[id] ) 
   write_coord(look2[id][0]) 
   write_coord(look2[id][1]) 
   write_coord(look2[id][2]) 
   write_short ( beam ) 
   write_byte( 0 ) // framestart 
   write_byte( 0 ) // framerate 
   write_byte( BEAMLIFE ) // life in 0.1's 
   write_byte( width ) // width 
   write_byte( noise ) // noise 
   if (color == 1) 
   { 
      if (get_user_team(id) == 1) 
      {// T 
         write_byte( 255 ) // r, g, b 
         write_byte( 0 ) // r, g, b 
         write_byte( 0 ) // r, g, b 
      } 
      else 
      { 
         write_byte( 0 ) // r, g, b 
         write_byte( 0 ) // r, g, b 
         write_byte( 255 ) // r, g, b 
      } 
   } 
   else 
   { 
      write_byte( 255 ) 
      write_byte( 255 ) 
      write_byte( 255 ) 
   } 
   write_byte( brightness ) // brightness 
   write_byte( speed ) // speed 
   message_end() 
   beamcreated[id] = get_gametime() 
   return PLUGIN_CONTINUE 
} 

public hookgrabtask(parm[]) 
{ 
   new id = parm[0] 

   if (grabbed[id]) 
   { 
      new origin[3],direction[3], moveto[3], velocity[3], length 

      if (!is_user_alive(grabbed[id])) 
      { 
         unhook(id) 
         return PLUGIN_CONTINUE 
      } 

      if (beamcreated[id] + BEAMLIFE/10 <= get_gametime()) 
      { 
         set_beam(grabbed[id]) 
      } 

      get_user_origin(grabbed[id], origin, 1) 
      get_user_origin(grabbed[id], grabbedorigin2[id]) 

      if(get_cvar_num("sv_hook_redploy_when_firing") == 1) 
      {       /* 
                 when client fires, the hook will redploy at what 
                 the person just fired at.  default is off. 
              */ 
              new hooktarget,body 
              get_user_aiming(grabbed[id],hooktarget,body) 
              if (hooktarget) 
              { 
                 get_user_origin(hooktarget,look2[id]) 
              } 
      } 

      direction[0]=look2[id][0]-origin[0] 
      direction[1]=look2[id][1]-origin[1] 
      direction[2]=look2[id][2]-origin[2] 
      length = get_distance(look2[id],origin) 

      new speed = get_cvar_num("sv_hookforce") 

      moveto[0]=origin[0]+direction[0]*speed/length 
      moveto[1]=origin[1]+direction[1]*speed/length 
      moveto[2]=origin[2]+direction[2]*speed/length 

      velocity[0]=(moveto[0]-grabbedorigin2[id][0]) 
      velocity[1]=(moveto[1]-grabbedorigin2[id][1]) 
      velocity[2]=(moveto[2]-grabbedorigin2[id][2]) 

      set_user_velocity(grabbed[id], velocity) 
   } 
   return PLUGIN_CONTINUE 
} 

public playerhit_sound(id) 
{ 
   new soundcvar2 = get_cvar_num("sv_hooksound") 
   if (soundcvar2 == 1) 
   { 
      emit_sound(id, CHAN_STATIC, "common/bodydrop4.wav", 1.0, ATTN_NORM, 0, PITCH_NORM) 
   } 
   return PLUGIN_CONTINUE 
} 

public unhook(id) 
{ 
   if(get_cvar_num("sv_hook") == 1) 
   { 
           killbeam(id) 
           grabbed[id]=false 
           remove_task(101+id) 
           new msgcvar3 = get_cvar_num("sv_hookmsgs") 
           if ((msgcvar3 == 1) || (msgcvar3 == 3)) 
           { 
               client_print(grabbed[id],print_notify,"[AMX] You have let go of the wall") 
           } 
           set_user_gravity(id,get_cvar_float("sv_hook_off_gravity")) 
           set_user_maxspeed(id,get_cvar_float("sv_hook_off_maxspeed")+0.1) 
   } 
   return PLUGIN_HANDLED 
} 

public unhook_aftershock(svIndex[]) 
{ 
   // Later this will be called to allow a person to gracefully fall down, etc.... 
   // 
   //set_user_gravity(id,1.2) 
   //set_user_maxspeed(id,110.0) 
   //set_user_rendering(id) 
   return PLUGIN_CONTINUE 
} 

public killbeam(id) 
{ 
   message_begin( MSG_BROADCAST, SVC_TEMPENTITY ) 
   write_byte( TE_KILLBEAM ) 
   write_short( grabbed[id] ) 
   message_end() 
   return PLUGIN_CONTINUE 
} 

public new_round(id) 
{ 
   if (grabbed[id]) 
   { 
      unhook(id) 
   } 
   return PLUGIN_CONTINUE 
} 

public plugin_precache() 
{ 
   beam = precache_model("sprites/dot.spr") 
   precache_sound("weapons/xbow_hit1.wav") 
   precache_sound("common/bodydrop4.wav") 
   return PLUGIN_CONTINUE 
} 

public help_motd(id) 
{ 

   new hook_motd[1300] 
   new text[768] 
   text = "There are two different types of hooks, one lets you^n\ 
      swing (+hook), and the other will pull you directly towards the^n\ 
      location you hooked onto.^n^n\ 
      To bind the keys follow these directions:^n^n" 
   add(hook_motd,1299,text) 
   text = "- First open your console with the tilde ` key^n\ 
      - Choose the keys that you want to use for the hooks^n\ 
      - Type in bind ^"The key you chose^" ^"+hook^" <-- Swinging hook^n\ 
      - Press enter to complete the bind, It should look like this^n^n\ 
      examples: bind ^"f^" ^"+hook^" | bind ^"t^" ^"+hookgrab^"^n^n" 
   add(hook_motd,1299,text) 
   text = "+hook does not give you any momentum by default, it^n\ 
      can only be used for swinging, so you either need to jump off^n\ 
      a ledge or use the +hookgrab to get momentum to use the swing.^n^n\ 
      +hookgrab lets you point at a wall, roof, sky, and mostly any^n\ 
      object in any map and it will pull you toward that point with^n\ 
      a set amount of speed, This hook is used well in conjuction^n\ 
      with the swinging hook.^n^n" 
   add(hook_motd,1299,text) 
   text = "It takes some time to get used to the speed, momentum and^n\ 
      swing. After a few minutes you should start getting the^n\ 
      hang of it.  <----- No pun intended^n^n\ 
      Have Fun!!" 
   add(hook_motd,1299,text) 
   show_motd(id,hook_motd,"Hook Help:") 

   return PLUGIN_CONTINUE 
} 

public plugin_init() 
{ 
   register_plugin("Hook Grab","0.9.8","{W`C}Bludy|GeekGod|Ivn-Software") 
   register_cvar("sv_hook","1") 
   register_cvar("sv_hook_notify_when_active","1") 
   register_cvar("sv_hook_off_maxspeed","280.0") 
   register_cvar("sv_hook_redploy_when_firing","0") 
   register_cvar("sv_hook_off_gravity","0") 
   register_cvar("sv_hook_auto_bind","0") 
   register_cvar("sv_hook_on_maxspeed","0.001") 
   register_cvar("sv_hook_on_gravity","00.1") 
   register_cvar("sv_hook_allow_admin","1") 
   register_cvar("sv_hookforce","600") 
   register_cvar("sv_hookwidth","5") 
   register_cvar("sv_hooknoise","1") 
   register_cvar("sv_hookcolor","0") 
   register_cvar("sv_hookbrightness","100") 
   register_cvar("sv_hookspeed","1") 
   register_cvar("sv_hookmsgs","0") 
   register_cvar("sv_hooksound","1") 
   register_clcmd("+hook","hookgrab") 
   register_clcmd("-hook","unhook") 
   register_clcmd("say /hook","help_motd") 
   register_clcmd("say hook","help_motd") 
   register_event("ResetHUD", "new_round", "b") 
   new sId[32] 
   sId[0] = 0 
   set_task(380.0,"notify_hook_status",0,sId,31) 
} 



