
/***************************************************************************
 * amx_ejl_jedipunish.sma     version 1.3  Date: 1/12/2003
 *  Author: Eric Lidman      ejlmozart@hotmail.com
 *  Alias: Ludwig van        Upgrade: http://lidmanmusic.com/cs/plugins.html           
 *
 * A retribution plugin with a Starwars Jedi theme to it. The final version
 *  will include several Jedi-like methods of dealing with players who need
 *  to be punished. Currently there is only the lighnining that the emperor
 *  shoots out at young Skywalyker just like in Return of the Jedi. But we've
 *  been having so much fun with it, it was good enough to relase with even
 *  just this one -- more to come. It also has a non lethal version just so 
 *  you can enjoy the special effects without hurting anyone. Go ahead and
 *  spam with it -- lots of blue lightning is cool! Lighning goes from the 
 *  admin to the player being zapped, if the admin zaps himself, lighning
 *  origin is random. There is an option to zap whoever is in your
 *  crosshairs. I would suggest you bind "amx_zap_aim" to a key, and use
 *  that as your zapping 'fire button' so to speak.
 *  
 *
 * COMMANDS:
 * 
 *    amx_zap <part of nick> <optional health to take - default is to kill>
 *    amx_zap_jk <part of nick>
 *    amx_zap_aim <optional health to take - default is to kill>
 *
 * EXAMPLES OF ACTUAL USAGE:
 *
 *    amx_zap Lud     --- zaps Lud and kills him
 *    amx_zap Lud 45  --- zaps Lud and takes 45 health away 
 *    amx_zap_jk Lud  --- zaps Lud and takes no health away
 *    amx_zap_aim     --- zaps player in your crosshairs and kills him
 *    amx_zap_aim 10  --- zaps player in your crosshairs and takes 5 health
 *
 * ADDITIONAL SETUP:
 *  There is a sound cut from Return of the Jedi that can be used to enhance
 *  the effect. You may need to make/edit some res files to get it to 
 *  download to your clients or use my (releasing soon) sound download
 *  manager plugin. The sound goes in the ..sound/misc folder on your server.
 *  Thanks to maddmaxx from the AMXmod forums for getting the sound clip.
 *  Get the sound off the forum amx_jedizap.zip, or at this link:
 *  http://lidmanmusic.com/cs/amx_jedizap_v3.zip
 *
 **************************************************************************/

#include <amxmod>
#include <fun>

new light 
new smoke 
new just_k[33]
new ZAP_WIDTH = 100
new Float:LastZapTime[33]

lightning(vec1[3],vec2[3]) 
{ 
   //Lightning 
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY) 
   write_byte( 0 ) 
   write_coord(vec1[0]) 
   write_coord(vec1[1]) 
   write_coord(vec1[2]) 
   write_coord(vec2[0]) 
   write_coord(vec2[1]) 
   write_coord(vec2[2]) 
   write_short( light ) 
   write_byte( 1 ) // framestart 
   write_byte( 5 ) // framerate 
   write_byte( 2 ) // life 
   write_byte( 20 ) // width 
   write_byte( 30 ) // noise 
   write_byte( 12 ) // r, g, b 
   write_byte( 50 ) // r, g, b 
   write_byte( 200 ) // r, g, b 
   write_byte( 200 ) // brightness 
   write_byte( 200 ) // speed 
   message_end() 
   //Sparks 
   message_begin( MSG_PVS, SVC_TEMPENTITY,vec2) 
   write_byte( 9 ) 
   write_coord( vec2[0] ) 
   write_coord( vec2[1] ) 
   write_coord( vec2[2] ) 
   message_end() 
   //Smoke    
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec2) 
   write_byte( 5 ) // 5 
   write_coord(vec2[0]) 
   write_coord(vec2[1]) 
   write_coord(vec2[2]) 
   write_short( smoke ) 
   write_byte( 10 )  // 10
   write_byte( 10 )  // 10
   message_end() 
}

public punish_zap(sidargs[]){
	new iid,iplayer,uht,sb
	iplayer = sidargs[0]
	iid = sidargs[1]
	new origin[3]
	new origin1[3]
	get_user_origin(iid,origin1)
	get_user_origin(iplayer,origin)
	if(iid == iplayer){
		origin1[0] = random(3000)
		origin1[1] = random(3000)
		origin1[2] = random(1000)
		sb = random(2)
		if(sb == 0)
			origin1[0] = origin1[0] * -1
		sb = random(2)
		if(sb == 0)
			origin1[1] = origin1[1] * -1
	}	
	lightning(origin1,origin)
	if(just_k[iid] == 0){
		uht = get_user_health(iplayer)-5
		if(uht < 1)
			user_kill(iplayer,1)
		else
			set_user_health(iplayer,uht)
	}
	new e_snd = random(3)
	client_cmd(0, "spk ^"weapons/electro%d^"",e_snd+4)
	return PLUGIN_CONTINUE
}

public admin_zap(id)
{
	if (!(get_user_flags(id)&ADMIN_LEVEL_H)){
		client_print(id,print_console,"[AMX] You have no access to that command")
		return PLUGIN_HANDLED
	}
	new cmd[32]
	new hp_take[8]
	new aname[32]
	new name[32]
	new idargs[3]
	new ihp_take 
	read_argv(0,cmd,32)
	new player
	if(equal(cmd[8],"a",1)){
		new aorigin[3]
		new vorigin[3]
		get_user_origin(id,aorigin,3)
		new maxpl = get_maxplayers() +1
		for(new a = 1; a < maxpl; a++) {			
			if(is_user_alive(a) != 0){
				get_user_origin(a,vorigin)
				if (get_distance(aorigin,vorigin)<ZAP_WIDTH){
					player = a
				}
			}
		}
		read_argv(1,hp_take,8)	
	}else{
		new argc = read_argc()
		if (argc < 2) {
			client_print(id,print_console,"[AMX] Usage:  amx_zap < part of nick >  < health > ")
			return PLUGIN_HANDLED
		}
		read_argv(1,name,32)
		read_argv(2,hp_take,8)
		player= find_player("b",name)
	}

	if (player)	{
		if (get_user_flags(player)&ADMIN_IMMUNITY){
			client_print(id,print_console,"[AMX] The player has immunity")
			return PLUGIN_HANDLED
		}
		get_user_name(player,name,32)
		get_user_name(id,aname,32)
		ihp_take = strtonum(hp_take)
		if( (ihp_take > get_user_health(player)) || (ihp_take < 1 ) )
			ihp_take = get_user_health(player) + 20

		idargs[0] = player
		idargs[1] = id
		if(equal(cmd[8],"j",1)){
			just_k[id] = 1
			ihp_take = 150
			log_message("[AMX]  %s  used command amx_zap_jk  %s",aname,name)
			set_task(0.2,"punish_zap",0,idargs,2,"a",ihp_take/5-1)
		}else{
			just_k[id] = 0
			client_print(id,print_console,"[AMX] Client ^"%s^" is being eletrocuted",name)
			log_message("[AMX]  %s  used command amx_zap  %s %s",aname,name,hp_take)
			if(ihp_take >= get_user_health(player)){
				if (get_gametime() > (LastZapTime[player] + 10.0)){
					LastZapTime[player] = get_gametime()
	 				client_print(0,print_chat,"[AMX]  %s  :  And now, young %s , ...... you will die.",aname,name)
					client_cmd(0,"spk misc/amx_jedizap_v3")
				}
				idargs[2] = ihp_take/5-1
				set_task(6.5,"delayed_zap",0,idargs,3)	
			}else{
	 			client_print(0,print_chat,"[AMX]  Admin: %s  is zapping  %s",aname,name)
				set_task(0.2,"punish_zap",0,idargs,2,"a",ihp_take/5-1)
			}
		}
	}else {
		client_print(id,print_console,"[AMX] Client in your aim or with that part of nick not found")
	}
	return PLUGIN_HANDLED
}

public delayed_zap(idargs[]){
	set_task(0.2,"punish_zap",0,idargs,2,"a",idargs[2])
	return PLUGIN_CONTINUE
}

public plugin_precache(){ 
	light = precache_model("sprites/lgtning.spr") 
	smoke = precache_model("sprites/steam1.spr") 
	return PLUGIN_CONTINUE 
} 

public plugin_init()
{
	register_plugin("Jedi Punsishments","0.8","EJL")
	register_clcmd("amx_zap","admin_zap",ADMIN_LEVEL_H,"amx_zap < part of nick > < health > -- real")
	register_clcmd("amx_zap_jk","admin_zap",ADMIN_LEVEL_H,"amx_zap_jk < part of nick > < health > -- fake")
	register_clcmd("amx_zap_aim","admin_zap",ADMIN_LEVEL_H,"amx_zap_aim < health > -- real")
	return PLUGIN_CONTINUE
}





