
/* AMXMOD script.
*
* (c) Copyright 2000-2002, Vantage (aka Mouse)
* This file is provided as is (no warranties).
*
* mapcapscore.sma
*
*/

/*
*	THIS PLUGIN DOES NOT CHANGE YOUR SERVER'S NAME! (sorry for caps!)
*
*	This plugin replaces server name on client's scoreboard with the map cap score.
*/

#include <amxmod>

#define MAXCAPS 12  // Total cap points there can be on any one map

new cap_points[MAXCAPS]
new map_cap_score[2]
new max_cap_points   // Total cap points in the map currently playing

public allies_cap()
{
	new cap_point_num = read_data(1)
	
	if(cap_point_num > max_cap_points)
		max_cap_points = cap_point_num

	cap_points[cap_point_num] = 1

	return PLUGIN_CONTINUE
}


public axis_cap()
{
	new cap_point_num = read_data(1)

	if(cap_point_num > max_cap_points)
		max_cap_points = cap_point_num

	cap_points[cap_point_num] = 2
	
	return PLUGIN_CONTINUE
}


public caps_reset()
{
	new cap_point_num = read_data(1)
	
	if(cap_point_num > max_cap_points)
		max_cap_points = cap_point_num
	
	new map_is_capped = 1
	if(cap_points[0]){ // So code below won't keep repeating when reset - dumb
		for(new i ; i < max_cap_points; i++){ // Dumb code but it happens only when map is reset so no worry
				if(cap_points[i] != cap_points[i+1]){
					map_is_capped = 0
				}
		}

		if(map_is_capped){
			++map_cap_score[(cap_points[0] - 1)]
			
			new score[21]
			format(score,20,"Allies %d - Axis %d",map_cap_score[0],map_cap_score[1])
	
			message_begin( MSG_ALL, 84, {0,0,0})
			write_string(score)
			message_end()
		}
	}

	cap_points[cap_point_num] = 0

	return PLUGIN_CONTINUE
}


public gmsg_ServerName(id)
{
	new score[21]
	format(score,20,"Allies %d - Axis %d",map_cap_score[0],map_cap_score[1]) // When first connecting send player score

	message_begin( MSG_ONE, 84, {0,0,0},id)
	write_string(score)
	message_end()

	return PLUGIN_CONTINUE

}


public clan_reset_delay(id)
{
	new time_till = read_data(1)

	set_task(float(time_till),"clan_reset_round",0)

	return PLUGIN_CONTINUE

}


public clan_reset_round()
{
	map_cap_score[0] = 0 // reset scores
	map_cap_score[1] = 0

	new score[21]
	format(score,20,"Allies %d - Axis %d",map_cap_score[0],map_cap_score[1]) 

	message_begin( MSG_ALL, 84, {0,0,0}) // Send reset scores
	write_string(score)
	message_end()
}


public plugin_init()
{
	register_plugin("Map Cap Score","0.9.3.1","Vantage aka Mouse")

	register_event("SetObj", "caps_reset","a","2=0")
	register_event("SetObj", "allies_cap","a","2=1") // allies cap a point
	register_event("SetObj", "axis_cap","a","2=2") // axis caps a point

	register_event("ServerName", "gmsg_ServerName","b")

	register_event("ClanTimer", "clan_reset_delay","a")

	return PLUGIN_CONTINUE
}

