/* AMX Mod script.
*
* Mapsearch Menu 0.3
*  by SniperBeamer
*
* Description:
*  This plugin allows users to search through all the maps on the server.
*  The results are shown in a menu, so you can simply change the map.
*
* Usage:
*  mapsearch <name>
*
* Example:
*  mapsearch rats
*
*/

#include <amxmod>
#include <amxmisc>

#define MAX_MAPS      512
#define MAX_RESULTS   30

new g_Maps[MAX_MAPS][32]
new g_MapsNum
new g_MenuPosition[33]
new g_ResultsNum[33]
new g_Results[33][MAX_RESULTS]
new g_Search[33][32]
new g_logFile[16]
new g_cstrikeRunning

public plugin_init() {
  register_plugin("Mapsearch Menu","0.3","SniperBeamer")

  register_menucmd(register_menuid("[MAPSEARCH]"), 1023, "ActionMenu")
  register_clcmd("mapsearch","searchMap",ADMIN_MAP,"<name> - lists available maps with it in their name")

  get_logfile(g_logFile,15)
  g_cstrikeRunning = is_running("cstrike")
  loadMaplist()
}

public searchMap(id,level,cid)
{
  if (!cmd_access(id,level,cid,2))
    return PLUGIN_HANDLED

  read_argv(1,g_Search[id],31)  

  g_ResultsNum[id] = 0

  for (new i=0;i<g_MapsNum && g_ResultsNum[id] < MAX_RESULTS;++i)
    if ( containi(g_Maps[i],g_Search[id])!=-1 )
      g_Results[id][g_ResultsNum[id]++] = i

  if ( g_ResultsNum[id] )
  {
    ShowMenu(id,g_MenuPosition[id] = 0)
  }
  else
  {
    new buffer[64]
    format( buffer , 63 , g_cstrikeRunning ? "\y[MAPSEARCH] ^"%s^":\w^n^n%s" :
      "[MAPSEARCH] ^"%s^":^n^n%s" , g_Search[id] , "0. No maps found" )
    show_menu( id , (1<<9) , buffer )
  }

  return PLUGIN_HANDLED
}

public ActionMenu(id,key)
{
  switch(key)
  {
    case 8: ShowMenu(id,++g_MenuPosition[id])
    case 9: ShowMenu(id,--g_MenuPosition[id])
    default:
    {
      new a = g_MenuPosition[id] * 8 + key
      new authid[32],name[32]
      get_user_authid(id,authid,31)
      get_user_name(id,name,31)

      switch (get_cvar_num("amx_show_activity"))  {
        case 2: client_print(0,print_chat,"ADMIN %s: changelevel %s",name,g_Maps[g_Results[id][a]])
        case 1: client_print(0,print_chat,"ADMIN: changelevel %s",g_Maps[g_Results[id][a]])
      }

      log_to_file(g_logFile,"Cmd: ^"%s<%d><%s><>^" changelevel ^"%s^"",name,get_user_userid(id),authid,g_Maps[g_Results[id][a]])

      set_cvar_string( "amx_nextmap" , g_Maps[g_Results[id][a]] )
      set_cvar_float(  "mp_timelimit" , 0.001 )


    }
  }

  return PLUGIN_HANDLED
}

ShowMenu(id,pos)
{
   if ( pos<0 ) return PLUGIN_HANDLED

   new menubody[512]
   new start = pos * 8
   new b = 0

   if ( start>=g_ResultsNum[id] )
      start = pos = g_MenuPosition[id] = 0

   new len = format(menubody,511,g_cstrikeRunning ? "\y[MAPSEARCH] ^"%s^":\R%d/%d^n\w^n" : "[MAPSEARCH] ^"%s^": (%d/%d)^n^n",
      g_Search[id],pos+1,((g_ResultsNum[id] / 8) + ((g_ResultsNum[id] % 8) ? 1 : 0)))

   new keys = (1<<9)
   new end = start + 8

   if ( end > g_ResultsNum[id]) 
    end = g_ResultsNum[id]

   for (new a=start;a<end;++a)
   {
      keys |= (1<<b)
      len += format(menubody[len],511-len,"%d. %s^n",++b,g_Maps[g_Results[id][a]])
   }

   if ( end!=g_ResultsNum[id] )
   {
      format(menubody[len],511-len,"^n9. More^n0. %s",pos ? "Back" : "Exit")
      keys |= (1<<8)
   }
   else format(menubody[len],511-len,"^n0. %s",pos ? "Back" : "Exit")

   show_menu(id,keys,menubody)

   return PLUGIN_HANDLED
}

loadMaplist()
{
  new a = 0,b
  g_MapsNum = 0

  while ( g_MapsNum<MAX_MAPS && (a = read_dir("maps",a,g_Maps[g_MapsNum],31,b)) != 0 )
  {
    if ( (b = containi(g_Maps[g_MapsNum],".bsp"))!=-1 )
      g_Maps[g_MapsNum++][b] = 0
  }
}
