
/* AMX Mod Script
 *
 * Nightvision Plugin
 *
 * 2003 - Lazy (the_lazy_one_09@hotmail.com)
 *
 * This plugin adds nightvision goggles to mods that don't have it already,
 * help is available when users say !help nightvision.
 *
 * Changelog:
 *
 * 0.1 : First builds and general setup
 * 0.2 : Fixed nightvision effect problem
 * 0.3 : Added screenfade effect
 * 0.4 : Nightvision tweaks
 * 0.5 : Nightvision tweaks
 * 0.6 : Removed some useless code
 * 0.7 : Added support for SvenCoop
 * 0.8 : Fixed stupid bug
 * 0.9 : Tweaked battery
 * 1.0 : Fixed fatal bug
*/

#include <amxmod>

new nvg_running[33]
new nvg_recharging[33]
new gmsgFade

public plugin_init()
{
	register_plugin("Nightvision", "0.9", "Lazy")
	
	register_cvar("mp_nightvision", "1", FCVAR_SERVER)
	register_cvar("mp_batterylife", "180.0", FCVAR_SERVER)
	register_cvar("mp_rechargetime", "120.0", FCVAR_SERVER)
	
	register_clcmd("nvg_on", "InitNVG", 0, "Turns on nightvision")
	register_clcmd("nvg_off", "KillNVG", 0, "Turns off nightvision")
	register_clcmd("say", "HandleSay", 0, "For Help")
	
	gmsgFade = get_user_msgid("ScreenFade")
	
	register_event("DeathMsg", "Grab_Death", "a")
	
	return PLUGIN_CONTINUE
}

public client_connect(id)
{
	nvg_running[id] = 0
	nvg_recharging[id] = 0
	
	return PLUGIN_CONTINUE
}

public client_disconnect(id)
{
	nvg_running[id] = 0
	nvg_recharging[id] = 0
	
	remove_task(144)
	remove_task(145)
	remove_task(147)
	
	return PLUGIN_CONTINUE
}

public Grab_Death()
{
	new victim = read_data(2)
	
	client_cmd(victim, "nvg_off")
}

public InitNVG(id)
{
	new player[32]
	new nvg_is_enabled
	new Float:BatteryTime
	
	nvg_is_enabled = get_cvar_num("mp_nightvision")
	BatteryTime = get_cvar_float("mp_batterylife")
	
	get_user_name(id, player, 32)
	
	if (nvg_is_enabled == 0)
		return PLUGIN_HANDLED
	if (is_user_alive(id) == 0)
		return PLUGIN_HANDLED
		
	if (nvg_running[id] == 1)
	{
		return PLUGIN_HANDLED
	}
	else
	{
		if (nvg_recharging[id] == 1)
		{
			client_print(id, print_center, "Not enough power")
			
			return PLUGIN_HANDLED
		}
		else
		{
			nvg_running[id] = 1
			
			emit_sound(id, CHAN_ITEM, "items/flashlight1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
			
			set_task(0.10, "RunNVG", 144, player, 32, "b")
			set_task(0.10, "RunNVG2", 147, player, 32, "b")
			set_task(BatteryTime, "RemoveNVG", 145, player, 32)
		}
	}
	
	return PLUGIN_HANDLED
}

public RunNVG(player[])
{
	new origin[3]
	new id
	
	id = get_user_index(player)
	
	get_user_origin(id, origin)
    
   	message_begin(MSG_ONE, SVC_TEMPENTITY, {0,0,0}, id) 
    
   	write_byte( 27 ) 
    
   	write_coord( origin[0] ) 
   	write_coord( origin[1] ) 
   	write_coord( origin[2] ) 
    
   	write_byte( 125 ) 

   	write_byte( 0 ) 
   	write_byte( 255 ) 
   	write_byte( 0 ) 
    
   	write_byte( 1 ) 
   	write_byte( 10 ) 
    
   	message_end()

	// Svencoop
	if (is_user_alive(id) == 0)
	{
		emit_sound(id, CHAN_ITEM, "items/flashlight1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		
		remove_task(144)
		remove_task(145)
		remove_task(147)
		
		nvg_running[id] = 0
		
		if (nvg_recharging[id] == 1)
			nvg_recharging[id] = 0
	}
}

public RunNVG2(player[])
{
	new id
	
	id = get_user_index(player)

	message_begin(MSG_ONE, gmsgFade, {0,0,0}, id)
	
	write_short(1000)
	write_short(1000)
	write_short(1<<12)
	
	write_byte(0)
	write_byte(255)
	write_byte(0)
	
	write_byte(150)
	
	message_end()
}

public RemoveNVG(player[])
{
	new id
	new Float:Recharge
	
	id = get_user_index(player)
	Recharge = get_cvar_float("mp_rechargetime")
	
	emit_sound(id, CHAN_ITEM, "items/flashlight1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
	
	client_print(id, print_center, "Battery dead")
	
	nvg_recharging[id] = 1
	nvg_running[id] = 0
	
	set_task(Recharge, "BattFull", 146, player, 32)
	
	remove_task(144)
	remove_task(147)
}

public BattFull(player[])
{
	new id
	
	id = get_user_index(player)
	
	nvg_recharging[id] = 0
	
	client_print(id, print_center, "Battery Charged")
}

public KillNVG(id)
{
	new nvg_is_enabled
	
	nvg_is_enabled = get_cvar_num("mp_nightvision")
	
	if (nvg_is_enabled == 0)
		return PLUGIN_HANDLED
	
	if (nvg_running[id] == 0)
	{
		return PLUGIN_HANDLED
	}
	else
	{
		emit_sound(id, CHAN_ITEM, "items/flashlight1.wav", 1.0, ATTN_NORM, 0, PITCH_NORM)
		
		remove_task(144)
		remove_task(145)
		remove_task(147)
		
		nvg_running[id] = 0
		
		if (nvg_recharging[id] == 1)
			nvg_recharging[id] = 0
	}
	
	return PLUGIN_HANDLED
}

public HandleSay(id)
{
	new chatstr[256]
	new msgbox[256]
	
	read_args(chatstr, 256)
	
	format(msgbox, 256, "Nightvision:^n===========^n^nTo turn on nightvision type nvg_on.^nTo shut it off type nvg_off.^nType all nightvision commands in your console.^nWarning, nightvision may slow down some computers.")
	
	if (containi(chatstr, "!help nightvision") == 1)	
		show_motd(id, msgbox, "Nightvision Help")
	
	return PLUGIN_CONTINUE
}

