/* Flight Mode 0.9.5.3 by -]ToC[-Bludy

0.9.5.3 - Added multi-directional control, most direction combos are supported, even triple combos (i.e MOVERIGHT + FORWARD + JUMP)

0.9.5.2 - Added New movement directions, You now can use your MOVERIGHT, and MOVELEFT keys to maneuver yourself
		  in those directions
		  Removed cvars amx_fly_upforce, and amx_fly_downforce, their speed is now also controlled by amx_flyspeed
		  

0.9.5.1 - Added New effect when engaging Flight mode
		  Added cvar to control gravity when hovering (note, this number is a multiplier not the actual gravity)
		  Added Flying(swimming) Animation when a player lifts off to certain height.  Player must be moving
		  in order for the animation to take place.

Ever wished you could fly, well its time.

Requires Vexd_Utilities and Xtrafun to operate!!

----------------------------------------------------

Description:  This plugin enables not only admin, but with the proper settings, for all players on your server.
Set amx_allfly to 1 for everyone to fly, otherwise only admins with proper access can use their admin fly commands
to fly.  Flying can be completly disabled by changing the cvar amx_flymode to 0.

While Flight Mode is engaged the player will hover in one spot. Press Forward, or Backward in order to fly in that direction.
Control where you fly by pointing your crosshairs in the direction you wish to travel.

Speed is controlled by amx_flyspeed.  Higher number = greater speed
You can also toggle up/down force when using Jump and Crouch while in Flight mode with these cvars: amx_fly_upforce, amx_fly_downforce

When a player fly's he will leave a temporary streak of color indicating which direction he came from, Plus it looks really cool,
These can be turned off or on with amx_flytrails 0 or 1. You can change the brightness of the trails with amx_flytrailbrightness

It is possible to start flying before freezetime at the start of a new round has ended.  By enabling amx_flybeforeftime not any
player (even admins) can fly until the freezetime has expired.

This plugin includes a connection message ONLY when amx_allfly is set to 1.

-----------------------------------------------------

CVARS:

amx_flymode 0 or 1						(default is 1)        - Toggles Flying on and off
amx_allfly 0 or 1						(default is 0)		  - Toggles Flying for all players (admin or not)	
amx_flyspeed 0 or greater				(default is 500)	  - Toggles speed of flight when moving forwards or backwards
amx_flytrails 0 or 1					(default is 1)		  - Toggles players trails when flying on and off
amx_flytrailbrightness 0 or greater		(default is 40)		  - Toggles brightness of player trails
amx_flybeforeftime 1 or 0				(default is 1)		  - Toggles whether anyone can fly before the freezetime is up (admin or not)
amx_hover_grav 0 or greater             (default is 0.001)    - Toggles gravity when hovering

------------------------------------------------------

COMMANDS:

+fly 				- This is what the players without admin have to bind to fly when amx_allfly is set to 1
+adminfly			- This is what admins can use to fly even when amx_allfly is set to 0

fly_toggle			- This does the same thing as +fly except you have to press once to engage, and again to disengage
adminfly_toggle     - This is the same as fly_toggle except only admins with proper access can use it whether amx_allfly is 0 or 1

say /flighthelp		- This brings up the Flight Mode Help Menu

-------------------------------------------------------

Have Fun!!
*/

#include <amxmod>
#include <amxmisc>
#include <fun>
#include <Vexd_Utilities>
#include <VexdUM_stock>

// Change this line to the access level you want and recompile if you wish to set it differently.
#define ADMIN_ACCESS ADMIN_IMMUNITY

new bool: isflying[33]
new bool: flytoggle[33]
new bool: ftime
new Float: Velocity[33][3]
new fly_trail
new light

public plugin_precache()
{
	fly_trail = precache_model("sprites/zbeam4.spr")
	light = precache_model("sprites/lgtning.spr") 
	
	return PLUGIN_CONTINUE
}

public plugin_init() {
	register_plugin("Flight","0.9.5.3","-]ToC[-Bludy")
	
	register_clcmd("+adminfly","make_fly",ADMIN_ACCESS,": Makes you change into fly mode - admins only")
	register_clcmd("+fly","make_fly",0,": Makes you change into fly mode")
	register_clcmd("-adminfly","stop_fly",0,": Makes you change back from fly mode to normal - admins only")
	register_clcmd("-fly","stop_fly",0,": Makes you change back from fly mode to normal")
	register_clcmd("fly_toggle","make_fly",0,": Makes you change into flymode, no need to hold button")
	register_clcmd("adminfly_toggle","make_fly",ADMIN_ACCESS,": Makes you change into flymode, no need to hold button - admins only")
	register_clcmd("say /flighthelp","flyhelp",0,": Brings up Flight help menu")
	
	register_cvar("amx_flymode","1")
	register_cvar("amx_flyspeed","500")
	register_cvar("amx_allfly","0")
	register_cvar("amx_flybeforeftime","1")
	register_cvar("amx_flytrailbrightness","40")
	register_cvar("amx_flytrails","1")
	register_cvar("amx_hover_grav","0.001")
	
	register_event("SendAudio","ftime_up","b","2=%!MRAD_GO","2=%!MRAD_MOVEOUT","2=%!MRAD_LETSGO","2=%!MRAD_LOCKNLOAD")
	register_event("SendAudio","end_round","a","2=%!MRAD_terwin","2=%!MRAD_ctwin","2=%!MRAD_rounddraw") 
	register_event("ResetHUD", "new_round", "b")
}

public client_connect(id)
{
	if(get_cvar_num("amx_allfly") == 1) client_cmd(id, "echo ;echo ^" **** This server has Flight Mode enabled, say /flighthelp for details ****^"")
	
	return PLUGIN_CONTINUE
}


public flyhelp(id)
{
  new buffer[1024] 
  new len = copy( buffer ,  1023 ,  "To enable Flight Mode you can:^n^n\ 
  bind a key to +fly^n-- OR --^nbind a key to fly_toggle^n\ 
  In order to bind a key you must open your console and use the bind command: ^n^n\ 
  bind ^"key^" ^"command^" ^n^n" ) 
  len += copy( buffer[len] ,  1023-len , "In this case the command is ^"+fly^", or ^"fly_toggle^"^n.  Here are some examples:^n^n\ 
  bind f +fly            bind MOUSE3 fly_toggle^n^n\ 
  - Using +fly, hold the key to engage Flight mode, release it to disengage ^n\ 
  - Using fly_toggle means, press once to engage, then again to disengage^n\ 
  - Press Jump or Duck to move up or down while Flight mode is engaged^n" ) 
  copy( buffer[len] ,  1023-len ,"- Press Forward, Backward, Right, or Left to move in the corresponding direction^n\ 
  - While pressing no keys in Flight mode you will be able to hover.^n^n\ 
  - Use your mouse to control your direction^n\ 
  you will move in the direction you aim" ) 
  show_motd(id,buffer ,"Flight Mode Help:") 
  return PLUGIN_HANDLED 
}


public new_round(id)
{

	if(flytoggle[id] || isflying[id])
	{
	stop_fly(id)
	}
	
	return PLUGIN_HANDLED
}

public end_round()
{
	ftime = true
	
	return PLUGIN_HANDLED
}

public ftime_up()
{
	ftime = false
	return PLUGIN_HANDLED
}

public make_fly(id)
{
	if(get_cvar_num("amx_flymode") == 0 || !is_user_alive(id)) return PLUGIN_HANDLED
	
	if(flytoggle[id])
	{
	stop_fly(id)
	return PLUGIN_HANDLED
	}
	
	new arg[20]
	read_argv(0,arg,19)
	
	if(equal(arg,"fly_toggle") || equal(arg,"adminfly_toggle"))
	flytoggle[id] = true
	
	if(get_cvar_num("amx_allfly") == 0)
	{
	if (!(get_user_flags(id)&ADMIN_ACCESS)) return PLUGIN_HANDLED
	}
	
	if(isflying[id]) client_print(id,print_center,"You are already flying")
	
	if(ftime && get_cvar_num("amx_flybeforeftime") == 1) 
	{
	client_print(id,print_notify,"You must wait until freezetime is up to fly")
	return PLUGIN_HANDLED
	}
	
	client_print(id,print_center,"You have entered Flying mode")
	
	new teamname[20]
	get_user_team(id,teamname,19)
	
	if(get_cvar_num("amx_flytrails") == 1)
	{
	message_begin( MSG_BROADCAST, SVC_TEMPENTITY )
	write_byte(22)
	write_short(id)
	write_short(fly_trail)
	write_byte(50)
	write_byte(10)
	if(equal(teamname,"TERRORIST"))
	{
	write_byte(200)
	write_byte(0)
	write_byte(0)
	}
	else
	{
	write_byte(0)
	write_byte(0)
	write_byte(200)
	}
	write_byte(get_cvar_num("amx_flytrailbrightness"))
	message_end()
	
	new Origin[3]
	get_user_origin(id,Origin)
	
	message_begin(MSG_ALL,SVC_TEMPENTITY)
	write_byte(19)
	write_coord(Origin[0])
	write_coord(Origin[1])
	write_coord(Origin[2])
	write_coord(Origin[0] + 24)
	write_coord(Origin[1] + 45)
	write_coord(Origin[2] + -66)
	write_short(light)
	write_byte(0) // starting frame
	write_byte(15) // frame rate in 0.1s
	write_byte(10) // life in 0.1s
	write_byte(20) // line width in 0.1s
	write_byte(1) // noise amplitude in 0.01s
	if(equal(teamname,"TERRORIST"))
	{
	write_byte(200)
	write_byte(0)
	write_byte(0)
	}
	else
	{
	write_byte(0)
	write_byte(0)
	write_byte(200)
	}
	write_byte(400) // brightness
	write_byte(1) // scroll speed in 0.1s
	message_end()
	}
	
	new parm[1]
	parm[0] = id
	
	set_user_gravity(id, get_cvar_float("amx_hover_grav"))
	
	set_task(0.1,"user_fly",5327+id, parm,1, "b")
	
	isflying[id] = true
	

	return PLUGIN_HANDLED
}

public user_fly(parm[])
{

	if(get_cvar_num("amx_flymode") == 0) return PLUGIN_HANDLED
	
	new Float: xAngles[3]
	new Float: xOrigin[3]
	
	new xEnt
	
	new id
	id = parm[0]
	
	if(!is_user_alive(id)) stop_fly(id)
	
	if(get_user_button(id)&IN_FORWARD && get_user_button(id)&IN_MOVERIGHT && get_user_button(id)&IN_JUMP)  // FORWARD + MOVERIGHT + JUMP
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = -45.0
	xAngles[1] -= 45
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_FORWARD && get_user_button(id)&IN_MOVERIGHT && get_user_button(id)&IN_DUCK)  // FORWARD + MOVERIGHT + DUCK
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 45.0
	xAngles[1] -= 45
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_FORWARD && get_user_button(id)&IN_MOVELEFT && get_user_button(id)&IN_JUMP)  // FORWARD + MOVELEFT + JUMP
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = -45.0
	xAngles[1] += 45
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_FORWARD && get_user_button(id)&IN_MOVELEFT && get_user_button(id)&IN_DUCK)  // FORWARD + MOVELEFT + DUCK
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 45.0
	xAngles[1] += 45
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_JUMP && get_user_button(id)&IN_MOVERIGHT && get_user_button(id)&IN_BACK)  // BACK + MOVERIGHT + JUMP
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = -45.0
	xAngles[1] -= 135
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_BACK && get_user_button(id)&IN_MOVERIGHT && get_user_button(id)&IN_DUCK)  // BACK + MOVERIGHT + DUCK
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 45.0
	xAngles[1] -= 135
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_JUMP && get_user_button(id)&IN_MOVELEFT && get_user_button(id)&IN_BACK)  // BACK + MOVELEFT + JUMP
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = -45.0
	xAngles[1] += 135
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_BACK && get_user_button(id)&IN_MOVELEFT && get_user_button(id)&IN_DUCK)  // BACK + MOVELEFT + DUCK
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 45.0
	xAngles[1] += 135
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_MOVERIGHT && get_user_button(id)&IN_FORWARD) //  MOVERIGHT  + FORWARD
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 0.0
	xAngles[1] -= 45
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_MOVERIGHT && get_user_button(id)&IN_BACK) // MOVERIGHT + BACK
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 0.0
	xAngles[1] -= 135
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_MOVELEFT && get_user_button(id)&IN_FORWARD) // MOVELEFT + FORWARD
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 0.0
	xAngles[1] += 45
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_MOVELEFT && get_user_button(id)&IN_BACK) // MOVELEFT + BACK
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 0.0
	xAngles[1] += 135
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_FORWARD && get_user_button(id)&IN_JUMP)  // FORWARD + JUMP
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = -45.0

	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_FORWARD && get_user_button(id)&IN_DUCK)  // FORWARD + DUCK
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 45.0
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_BACK && get_user_button(id)&IN_JUMP)  // BACK + JUMP
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = -45.0
	xAngles[1] += 180
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_BACK && get_user_button(id)&IN_DUCK)  // BACK + DUCK
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 45.0
	xAngles[1] += 180
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}	
	else if(get_user_button(id)&IN_MOVERIGHT && get_user_button(id)&IN_JUMP)  // MOVERIGHT + JUMP
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = -45.0
	xAngles[1] -= 90
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_MOVERIGHT && get_user_button(id)&IN_DUCK)  // MOVERIGHT + DUCK
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 45.0
	xAngles[1] -= 90
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_MOVELEFT && get_user_button(id)&IN_JUMP)  // MOVELEFT + JUMP
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = -45.0
	xAngles[1] += 90
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_MOVELEFT && get_user_button(id)&IN_DUCK)  // MOVELEFT + DUCK
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 45.0
	xAngles[1] += 90
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_FORWARD) // FORWARD
	VelocityByAim(id, get_cvar_num("amx_flyspeed") , Velocity[id])
	else if(get_user_button(id)&IN_BACK) // BACK
	VelocityByAim(id, -get_cvar_num("amx_flyspeed") , Velocity[id])
	else if(get_user_button(id)&IN_DUCK) // DUCK
	{
	Velocity[id][0] = 0.0
	Velocity[id][1] = 0.0
	Velocity[id][2] = -get_cvar_num("amx_flyspeed") * 1.0
	}
	else if(get_user_button(id)&IN_JUMP) // JUMP
	{
	Velocity[id][0] = 0.0
	Velocity[id][1] = 0.0
	Velocity[id][2] = get_cvar_num("amx_flyspeed") * 1.0
	}
	else if(get_user_button(id)&IN_MOVERIGHT) // MOVERIGHT
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 0.0
	xAngles[1] -= 90
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else if(get_user_button(id)&IN_MOVELEFT) // MOVELEFT
	{
	Entvars_Get_Vector(id, EV_VEC_v_angle, xAngles)
	Entvars_Get_Vector(id, EV_VEC_origin, xOrigin)
	
	xEnt = CreateEntity("info_target")
	if(xEnt == 0) { 
	return PLUGIN_HANDLED_MAIN 
	}
	
	xAngles[0] = 0.0
	xAngles[1] += 90
	
	ENT_SetOrigin(xEnt, xOrigin)
	Entvars_Set_Vector(xEnt, EV_VEC_v_angle, xAngles)
	
	VelocityByAim(xEnt, get_cvar_num("amx_flyspeed"), Velocity[id])
	
	RemoveEntity(xEnt)
	}
	else
	{
	Velocity[id][0] = 0.0
	Velocity[id][1] = 0.0
	Velocity[id][2] = 0.0
	}
	
	
	Entvars_Set_Vector(id, EV_VEC_velocity, Velocity[id])
	
	new Float: pOrigin[3]
	new Float: zOrigin[3]
	new Float: zResult[3]
	
	Entvars_Get_Vector(id, EV_VEC_origin, pOrigin)
	
	zOrigin[0] = pOrigin[0]
	zOrigin[1] = pOrigin[1]
	zOrigin[2] = pOrigin[2] - 1000
	
	TraceLn(id,pOrigin, zOrigin, zResult)
	
	if(Entvars_Get_Int(id, EV_INT_sequence) != 8 && (zResult[2] + 100) < pOrigin[2] && is_user_alive(id) && (Velocity[id][0] > 0.0 && Velocity[id][1] > 0.0 && Velocity[id][2] > 0.0)) 
	Entvars_Set_Int(id, EV_INT_sequence, 8)
	
	return PLUGIN_HANDLED
}

public stop_fly(id)
{
	if(get_cvar_num("amx_flymode") == 0) return PLUGIN_HANDLED

	if(!isflying[id]) return PLUGIN_HANDLED
	
	if(get_cvar_num("amx_flytrails") == 1)
	{
	message_begin( MSG_ONE,SVC_TEMPENTITY,{0,0,0},id )
	write_byte(99)
	write_short(id)
	message_end()
	}
	
	client_print(id,print_center,"You have exited Flying mode")
	
	set_user_gravity(id)
	
	isflying[id] = false
	flytoggle[id] = false
	remove_task(5327+id)
	
	return PLUGIN_HANDLED
}
