/* AMX Mod script.
*
* Quiz Bot 0.4
*  by SniperBeamer
*
*
*  Description:
*  If you are dead or bored you can answer the questions. Simply say the answer.
*
*  CVARs:
*  The CVARs only take effect when you restart the quiz (quiz_start)
*  quiz_file		- Question file ("addons\amx\questions.txt", default)
*  quiz_questions	- How many questions are there
*					  (wrong value could crash the server!)
*  quiz_onlydead	- Only dead player are able to play (1, default)
*  quiz_timer		- Time after question are solved (15.0, default)
*  quiz_money		- How many money on right answer (100, default)
*  quiz_mysql_host	- MySQL Host (if not set it's read from mysql.cfg)
*  quiz_mysql_user	- MySQL User (if not set it's read from mysql.cfg)
*  quiz_mysql_pass	- MySQL Password (if not set it's read from mysql.cfg)
*  quiz_mysql_db	- MySQL Database (if not set it's read from mysql.cfg)
*
*  Commands:
*  say !quiz	- Infos about the quiz (public)
*  say !mystats	- How many right questions (public)
*  say !next	- Next question
*  say !reset	- Reset points
*  quiz_start	- Start the Quiz
*  quiz_stop	- Stop the Quiz
*
* This file is provided as is (no warranties).
*
*/

//----------------------------------------------------------------------------------------------
#include <amxmod>
#include <fun>

#define USE_MYSQL					// Use MySQL? (to disable comment)
#define REM_QUESTS 10				// Number of remembered question (to disable comment)
#define QUIZ_ADMIN ADMIN_LEVEL_B	// Access level for quiz commands
//----------------------------------------------------------------------------------------------
#if defined USE_MYSQL
	#include <mysql>
#endif
//----------------------------------------------------------------------------------------------
new question[256]
new answer[32][4]
new answers

new bool:curOK = false

new pPoints[33]	// points of each player
new pBest[2]	// [0]id, [1]points

#if defined REM_QUESTS
new lastQuest[REM_QUESTS]
new lastQcount = 0
#endif

new bool:q_bot = true
new q_file[32]		// quiz_file
new q_quests		// quiz_questions
new bool:q_onlydead	// quiz_onlydead
new Float:q_timer	// quiz_timer
new q_money			// quiz_money

#if defined USE_MYSQL
	new mhost[64],muser[32],mpass[32],mdb[32]
#endif
//----------------------------------------------------------------------------------------------
public plugin_init(){
	register_plugin("Quiz Bot","0.4","SniperBeamer")
	register_cvar("quiz_bot","0.4",FCVAR_SPONLY)
	register_cvar("quiz_file","addons\amx\questions.txt")
	register_cvar("quiz_questions","50")
	register_cvar("quiz_onlydead","1")
	register_cvar("quiz_timer","15.0")
	register_cvar("quiz_money","100")
	register_cvar("quiz_mysql_host","")
	register_cvar("quiz_mysql_user","")
	register_cvar("quiz_mysql_pass","")
	register_cvar("quiz_mysql_db","")
	register_concmd("quiz_start","start_quiz",QUIZ_ADMIN,"- Start Quiz Bot")
	register_concmd("quiz_stop","stop_quiz",QUIZ_ADMIN,"- Stop Quiz Bot")
	register_clcmd("say","check_say")
	register_clcmd("say_team","check_say")
	set_task(5.0,"init_quiz",801)
}
//----------------------------------------------------------------------------------------------
public ask_question(){
	if (!q_bot) return PLUGIN_HANDLED
	new bool:numOK
	new curQuest
	do{
		numOK = true
		curQuest = random_num(1,q_quests)
#if defined REM_QUESTS
		for (new i=0; i<REM_QUESTS; i++){
			if (curQuest==lastQuest[i]){
				numOK = false
				break
			}
		}
#endif
		read_question(curQuest)
	} while (!numOK)
	
#if defined REM_QUESTS
	lastQuest[lastQcount] = curQuest
	++lastQcount
	if (lastQcount==REM_QUESTS) lastQcount = 0
#endif
	new plist[32],pnum
	if (q_onlydead) get_players(plist,pnum,"bc")
		else get_players(plist,pnum,"c")
	for (new i=0; i<pnum; i++)
		client_print(plist[i],print_chat,"[QUIZ] %s",question)
	curOK = true
	set_task(q_timer,"new_question",802)

	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
#if defined USE_MYSQL
public read_question(Quest){
	new merror[128]

	new mysql = mysql_connect(mhost,muser,mpass,mdb,merror,127)
	if(mysql < 1){
		server_print("[QUIZ] MySQL error: can't connect: '%s'",merror)
		q_bot = false
	}
	if (mysql_query(mysql,"SELECT question,answera,answerb,answerc,answerd FROM quiz") < 1){
		mysql_error(mysql,merror,127)
		server_print("[QUIZ] MySQL error: can't load questions: '%s'",merror)
		q_bot = false
	}
	for (new i=0; i<Quest; i++)
		mysql_nextrow(mysql)

	mysql_getfield(mysql,1,question,255)
	mysql_getfield(mysql,2,answer[0],31)
	mysql_getfield(mysql,3,answer[1],31)
	mysql_getfield(mysql,4,answer[2],31)
	mysql_getfield(mysql,5,answer[3],31)
	answers = 4
	if (strlen(answer[1]) == 0) answers = 1
	if (strlen(answer[2]) == 0) answers = 2
	if (strlen(answer[3]) == 0) answers = 3

	mysql_close(mysql)
}
//----------------------------------------------------------------------------------------------
#else
public read_question(Quest){
	--Quest
	new Text[266],Length
	read_file(q_file,Quest,Text,265,Length)
	answers = parse(Text,question,255,answer[0],31,answer[1],31,answer[2],31,answer[3],31)
}
#endif
//----------------------------------------------------------------------------------------------
public check_say(id){
	if (!q_bot) return PLUGIN_CONTINUE
	new said[32]
	read_args(said,31)
	remove_quotes(said)
	new flags = get_user_flags(id)
	new bool:admin = (flags & QUIZ_ADMIN) ? true : false

	if ( ((q_onlydead && !is_user_alive(id)) || !q_onlydead) && curOK )
		switch (answers){
			case 2: if ( equali(said,answer[0]) ) right_answer(id)
			case 3: if ( equali(said,answer[0]) || equali(said,answer[1]) ) right_answer(id)
			case 4: if ( equali(said,answer[0]) || equali(said,answer[1]) || equali(said,answer[2]) ) right_answer(id)
			case 5: if ( equali(said,answer[0]) || equali(said,answer[1]) || equali(said,answer[2]) || equali(said,answer[3]) ) right_answer(id)
		}
	if ( equali(said,"!quiz") ) quiz_info(id,admin)
	if ( equali(said,"!mystats") ) my_stats(id)
	if ( equali(said,"!next") && admin ) new_question()
	if ( equali(said,"!reset") && admin ) reset_pnts()

	return PLUGIN_CONTINUE
}
//----------------------------------------------------------------------------------------------
public right_answer(id){
	curOK = false
	remove_task(802)
	new pName[32]
	get_user_name(id,pName,31)

	++pPoints[id]
	if (pPoints[id] > pBest[1]){
		pBest[0] = id
		pBest[1] = pPoints[id]
	}
	set_user_money(id,get_user_money(id)+q_money)

	new plist[32],pnum
	if (q_onlydead) get_players(plist,pnum,"bc")
		else get_players(plist,pnum,"c")
	for (new i=0; i<pnum; i++)
		client_print(plist[i],print_chat,"[QUIZ] Right, %s (Answer: %s)",pName,answer[0])
	set_task(1.0,"ask_question",803)
}
//----------------------------------------------------------------------------------------------
public new_question(){
	curOK = false
	remove_tasks()
	new plist[32],pnum
	if (q_onlydead) get_players(plist,pnum,"bc")
		else get_players(plist,pnum,"c")
	for (new i=0; i<pnum; i++)
		client_print(plist[i],print_chat,"[QUIZ] Right Answer: %s",answer[0])
	set_task(1.0,"ask_question",803)
}
//----------------------------------------------------------------------------------------------
public init_quiz()
	start_quiz(-1)
//----------------------------------------------------------------------------------------------
public start_quiz(id){
	if (id != -1){
		new flags = get_user_flags(id)
		if (!(flags & QUIZ_ADMIN)){
			console_print(id,"[QUIZ] You have no access to that command")
			return PLUGIN_HANDLED
		}
	}

	get_cvar_string("quiz_file",q_file,31)
	q_quests = get_cvar_num("quiz_questions")
	q_onlydead = (get_cvar_num("quiz_onlydead")) ? true : false
	q_timer = get_cvar_float("quiz_timer")
	q_money = get_cvar_num("quiz_money")

	remove_tasks()
	q_bot = true
	curOK = false

#if defined USE_MYSQL
	server_cmd("exec addons/amx/mysql.cfg")
	get_cvar_string("quiz_mysql_host",mhost,63)
	get_cvar_string("quiz_mysql_user",muser,31)
	get_cvar_string("quiz_mysql_pass",mpass,31)
	get_cvar_string("quiz_mysql_db",mdb,31)
	if (strlen(mhost) == 0) get_cvar_string("amx_mysql_host",mhost,63)
	if (strlen(muser) == 0) get_cvar_string("amx_mysql_user",muser,31)
	if (strlen(mpass) == 0) get_cvar_string("amx_mysql_pass",mpass,31)
	if (strlen(mdb) == 0) get_cvar_string("amx_mysql_db",mdb,31)

	new mquery[512],merror[128]
	format(mquery,511,"CREATE TABLE IF NOT EXISTS `quiz` ( `question` TEXT NOT NULL default '', `answera` TEXT NOT NULL default '', `answerb` TEXT NOT NULL default '', \
	       `answerc` TEXT NOT NULL default '', `answerd` TEXT NOT NULL default '' ) TYPE=MyISAM COMMENT='Quiz Bot Questions';")
	new mysql = mysql_connect(mhost,muser,mpass,mdb,merror,127)
	if(mysql < 1){
		server_print("[QUIZ] MySQL error: can't connect: '%s'",merror)
		q_bot = false
		return PLUGIN_HANDLED
	}
	mysql_query(mysql,mquery)
	mysql_close(mysql)
#else
	if (!file_exists(q_file)){
		if (id != -1) console_print(id,"[QUIZ] Questions file does not exist")
		else server_print("[QUIZ] Questions file does not exist")
		q_bot = false
		return PLUGIN_HANDLED
	}
#endif
	if (q_quests == 0){
		if (id != -1) console_print(id,"[QUIZ] No Questions")
		else server_print("[QUIZ] No Questions")
		q_bot = false
		return PLUGIN_HANDLED
	}
#if defined REM_QUESTS
	new rem_q = REM_QUESTS
	if (rem_q >= q_quests){
		if (id != -1) console_print(id,"[QUIZ] Too many questions to remember")
		else server_print("[QUIZ] Too many questions to remember")
		q_bot = false
		return PLUGIN_HANDLED
	}
	for (new i=0; i<REM_QUESTS; i++)
		lastQuest[i] = 0
#endif
	for (new i=0; i<33; i++)
		pPoints[i] = 0

	if (id != -1) client_print(0,print_chat,"[QUIZ] Start")
	set_task(0.5,"ask_question",804)

	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public stop_quiz(id){
	new flags = get_user_flags(id)
	if (!(flags & QUIZ_ADMIN)){
		console_print(id,"[QUIZ] You have no access to that command")
		return PLUGIN_HANDLED
	}

	q_bot = false
	remove_tasks()

	client_print(0,print_chat,"[QUIZ] Stop")

	return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public reset_pnts()
	for (new i=0; i<33; i++)
		pPoints[i] = 0
//----------------------------------------------------------------------------------------------
public quiz_info(id,admin){
	new pName[32], pPs[8]
	get_user_name(pBest[0],pName,31)
	if (pBest[1]==0) copy(pName,31,"[nobody]")
	if (pBest[1]==1) copy(pPs,7,"Point")
		else copy(pPs,7,"Points")

	if (admin){
		new plist[32],pnum
		if (q_onlydead) get_players(plist,pnum,"bc")
			else get_players(plist,pnum,"c")
		for (new i=0; i<pnum; i++){
			client_print(plist[i],print_chat,"[QUIZ] Quiz Bot 0.4 by SniperBeamer")
			client_print(plist[i],print_chat,"[QUIZ] Questions: %d",q_quests)
			client_print(plist[i],print_chat,"[QUIZ] Best Quizzer: %s (%d %s)",pName,pBest[1],pPs)
		}
	}
	else{
		client_print(id,print_chat,"[QUIZ] Quiz Bot 0.4 by SniperBeamer")
		client_print(id,print_chat,"[QUIZ] Questions: %d",q_quests)
		client_print(id,print_chat,"[QUIZ] Best Quizzer: %s (%d %s)",pName,pBest[1],pPs)
	}
}
//----------------------------------------------------------------------------------------------
public my_stats(id){
	new pPs[8]
	if (pBest[1]==1) copy(pPs,7,"Point")
		else copy(pPs,7,"Points")
	client_print(id,print_chat,"[QUIZ] Your Stats: %d %s",pPoints[id],pPs)
}
//----------------------------------------------------------------------------------------------
public remove_tasks(){
	remove_task(802)
	remove_task(803)
	remove_task(804)
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
	pPoints[id] = 0
//----------------------------------------------------------------------------------------------
public client_disconnect(id){
	if (pBest[0]==id){
		pBest[0] = 0
		pBest[1] = 0
	}
	pPoints[id] = 0
}
//----------------------------------------------------------------------------------------------
