

/* AMX Mod script. 
* 
* AMX Random Server Password v1.0 (amx_rndpass) 
* 
* (c) Copyright 2003 by Marach (marach@phreaker.net, ICQ: 242122535, AIM: marach24, MSN IM: marach24@hotmail.com) 
* 
* This file is provided as is (no warranties). 
* 
* Usage: 
*   - open file addons\amx\admin.cfg 
*   - add this line to admin.cfg to make a list of passwords: 
*      amx_rndpass_list pass1 pass2 pass3 ... 
*      (where 'passX' is the password you're adding to the list) 
*   - save the changes to file admin.cfg  
*   - when playing on server just enter this command in console: 
*       amx_rndpass 
* 
* Random password from the list will be set and announced. Plugin will also 
* set 'password' CVAR at all clients to match the current server password. 
* So if a player needs to reconnect he'll already have the correct password 
* set and will be able to connect to the server. 
* 
* Example (admin.cfg): 
*    amx_rndpass_list cw war fight fw private 
* 
* This will add five password to the list. Plugin will choose one password 
* of all five when 'amx_rndpass' command is executed. 
*
* usage of randmopass is logged to hlds standard logs like this
*  L 01/28/2004 - 22:41:03: [AMX] RndPass - '_KaszpiR_<4294967295>' changed server password to 'YoncpOJDn_wyOwFfaWNzld_6kQ5IsVV'. 
* 
* 
* 
* Done:
*    + make plugin able to generate new random passwords instead of only choosing them from the list 
*    + if no defined passwords from list then genrate one 8 chars long
* 
* To do: 
*    - new random password generation by user's criteria (number of characters, character set, etc.) 
*		i wonder if it is necessary :P
*    - silent pass change without announcement or showing to admins with rcon access
*      in example if length is defined with first char, after that would be a number
	! = hide totally announcement (except for admin that used it an dhlds logs)
	@ = show to admins
	# = set pass on server and NOT set on clients
*    - more logging ine xample mysql, but i guess this can be achieved by other plugins like adminlog
*    - autochange pass every X minutes, but i guess admins can use here some other amx plugins like amx_task or roundtask
*    - amx_rndpass 0 could remove password from clients 
*
*  Known Bugs:
*    - when using amx_rndpass 32 or values higher or equal to 32 it will produce pass with some strange length
*    
*
* Changelog:
*	1.0 official release by Marach
*	
*	1.0b added by _KaszpiR_ nvt_kaszpir@go2.pl 
*	- random generator
*	- standard hlds logging
*	- comments to the code
*	tested on AMXMOD 0.9.7 cs 1.5 Small Compiler 2.10
*/ 

#include <amxmod> 
#include <amxmisc> 

#define MAX_PWDS 32 
//maximum password length
#define MAX_PWDLENGTH 32 
//default pwd lengh on autogenerating and not having list of predefined passwords
#define DEF_PWDLENGTH 8 

#define HASH_MAX 64
// 26+26+10+1 see upper line and below line, 63 +1 (+1 for string terminating)
// if you add to below line other chars make sure you will increase te HASH_MAX value
new hashtable[HASH_MAX] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789_"

new pwds[MAX_PWDS][32] //here are stored passwords form the cfg file
new pwdpos = 0 
new pwd[MAX_PWDLENGTH] //here is the password tat will be inserted to sv_password

//function for clearing the amx var pwd
public amx_rndpassClr(){
   for (new i=0;i<MAX_PWDLENGTH;i++) pwd[i] = 0 // clearing old values , important, otherwise the password will bi with old chars
   //i guess could be fixed with the adding null termination, but... i prefer this way
}

//function to generate a random pass defined by the number of length given by argument, writing directly to pwd var
public amx_rndpassGen(len){
   for (new i=0; i<len && i< MAX_PWDLENGTH; i++)
	pwd[i] = hashtable[random_num(0,HASH_MAX-1)]
   //get random char from hast table, well a char from a string in fact
}

public amx_rndpass(id, level, cid) { 
   if (!cmd_access(id, level, cid, 1)) 
                return PLUGIN_HANDLED 
   
   new arg[32] //the passwords will be up to 99chars long :P, otherwise if used [2] it would be up to 9 chars long
   read_argv(1,arg,2)
   new length = strtonum(arg)
   amx_rndpassClr() //clear the old pass (amx var)

   if(!length)
   {
      // if we call without the lenght argument make the old way random pass choice from pwds that are in cfg
     if (pwdpos < 1) { 
     //if the passwords from cfg are not present make a messgae to admin and generate random pass
      length = DEF_PWDLENGTH //i would say 8 is safe, freakers can set 32 chars :P
      console_print(id, "[AMX] RndPass - No passwords in list (amx_rndpass). Generating Random pass with %d chars long.", length) 
      amx_rndpassGen(length)
     } 
     else{
         console_print(id, "[AMX] RndPass - Setting pass to one of the defined values from cfg") 
         pwd = pwds[random_num(0, pwdpos - 1)]
	 }
   }
   else
   {   amx_rndpassGen(length)
   //if the length is specified make random pass
   }

   set_cvar_string("sv_password", pwd) 

   client_print(0, print_chat, "[AMX] RndPass - Server password changed to: %s", pwd) 
   //adding to hlds logs
   new authid[32],name[32] 
   get_user_authid(id,authid,15) 
   get_user_name(id,name,31) 
   log_message("[AMX] RndPass - '%s<%s>' changed server password to '%s'.",name, authid,pwd) 
   
   
   new msg[256] //1024???? too big , we could even 128 here
   format(msg, 511, "Server password changed to:^n%s", pwd) 
   set_hudmessage(255, 255, 255, -1.0, 0.32, 0, 2.0, 6.0, 0.8, 0.8, 2) 
   show_hudmessage(0, msg) 
   new players[32], n 
   get_players(players, n, "c", "") 
   if (n > 0) //i guess the for() fucnton can habdle it anyway by using while
      for(new a = 0; a < n; ++a) 
         if (!is_user_bot(players[a])) { 
            client_cmd(players[a], "password %s", pwd) 
	    //debug
            //client_print(players[a], print_chat, "* [AMX] CVAR 'password' changed to match server password") 
         } 
   return PLUGIN_HANDLED 
} 

public add_pwd_to_list(id, level, cid) { 
   if (!cmd_access(id, level, cid, 2)) 
      return PLUGIN_HANDLED 
   new argc = read_argc() 
   for(new i = 1; i < argc; i++) { 
      if (pwdpos < MAX_PWDS) { 
         new tmp[32] 
         read_argv(i, tmp, 31) 
         pwds[pwdpos] = tmp 
         pwdpos++ 
      } 
      else { 
         console_print(id, "[AMX] RndPass - Too many passwords added to list (amx_rndpass). Limit is %d entries", MAX_PWDS) 
         return PLUGIN_HANDLED 
      } 
   } 
   return PLUGIN_HANDLED 
} 

public plugin_init() { 
   register_plugin("AMX Random Server Password", "1.0b", "Marach") 
   register_concmd("amx_rndpass", "amx_rndpass", ADMIN_PASSWORD, " [length] - sets random server password and announces it.If value given generates random pass.") 
   register_srvcmd("amx_rndpass_list", "add_pwd_to_list") 
   return PLUGIN_CONTINUE 
} 


