/* vi:set ts=8 sts=0 sw=4 syntax=cpp: 
 *
 * AMX Mod script.
 * amx_regnam by t0d0r
 * You can register names(nicks) in IRC(nickserv) style
 *
 * /amx_register nick password passwordagain
 * /amx_ident nick password
 * /amx_chpass nick oldpassword newpassword
 *
 * This file is provided as is (no warranties).

--
-- Table structure for table 'passwd'
--

CREATE TABLE passwd (
  ID int(11) NOT NULL auto_increment,
  name varchar(32) default NULL,
  password varchar(16) default NULL,
  timestamp datetime default NULL,
  PRIMARY KEY  (ID),
  UNIQUE KEY name (name)
) TYPE=MyISAM;

 
sample regname.txt file, overwrite clients settings:
---- begin of file----
cl_rate "9999"
cl_forwardspeed "400"
cl_backspeed "400"
fps_max "100.0"
cl_lc "1"
cl_lw "1"
---- end of file ----
// #include <mthread> for next version ;)

*/
#include <amxmod>
#include <mysql> 

#define SETGLOBALSETTINGS 1
#define DEBUG 0
#define MAX_NAME_LENGTH	33

#if SETGLOBALSETTINGS == 1
	new gsetfile[] = "addons/amx/regname.txt"
#endif

new sqlerror[128], sqlhost[16], sqluser[32], sqlpass[32], sqldb[32] 
new mysql = 0
new bool:dontcheck[33]
new bool:dontrename[33]
new TheNick[32] = "PleaseRegName"

public client_putinserver(id){
        new name[MAX_NAME_LENGTH] 
        get_user_name(id,name,MAX_NAME_LENGTH - 1 )

	#if DEBUG == 1
	server_print("[AMX_regnam] client_putinserver name: %s", name)
	#endif
	if(!check_name(id,name)) {
		new parm[1]
		parm[0] = id
		set_task(15.0,"ident_msg",123,parm,2)
		set_task(30.0,"delay_rename",124,parm,2)
	}
        return PLUGIN_CONTINUE
}

public client_connect(id) {
        new name[MAX_NAME_LENGTH] 
        get_user_name(id,name,MAX_NAME_LENGTH - 1 )

        amx_wlcmsg(id)
	amx_glsetting(id)
	dontrename[id] = false
	#if DEBUG == 1
	server_print("[AMX_regnam] client_connect name: %s", name)
	#endif
	return PLUGIN_CONTINUE
}

public client_infochanged(id){
	if(dontrename[id]) { 
		dontrename[id] = false
	} else {
		if(dontcheck[id]){
			dontcheck[id] = false
		}
		else if(is_user_connected(id)){
			new newname[MAX_NAME_LENGTH] 
			new oldname[MAX_NAME_LENGTH] 
			get_user_info(id,"name",newname,MAX_NAME_LENGTH - 1 )
			get_user_name(id,oldname,MAX_NAME_LENGTH - 1 )
			
			if(!equal(oldname,newname)) {
				dontcheck[id] = true
				client_print(id,print_chat,"** [AMX_regnam] You are not allowed to change your name")
				client_print(id,print_chat,"** [AMX_regnam] Type amx_help for more info")
				set_user_info(id,"name",oldname)
			}
		}
	}
	return PLUGIN_CONTINUE
}
public ident_msg(parm[]) {
	new id = parm[0]
	set_hudmessage(0, 100, 200, -1.0, 0.40, 0, 6.0, 20.0, 0.1, 0.1, 9)
	show_hudmessage(id, "This name is owned by someone else, please type: amx_help in console")
	return PLUGIN_CONTINUE
}

public name_msg(parm[]) {
	new id = parm[0]
	set_hudmessage(0, 100, 200, -1.0, 0.40, 0, 6.0, 20.0, 0.1, 0.1, 9)
	show_hudmessage(id, "[AMX_regnam] You are not allowed to change your name")
	return PLUGIN_CONTINUE
}

public amx_wlcmsg(id) {
        new name[MAX_NAME_LENGTH] 
        get_user_name(id,name,MAX_NAME_LENGTH - 1 )
	
	client_cmd(id,"echo *")
	client_cmd(id,"echo *")
	client_cmd(id,"echo * ========================================")
	client_cmd(id,"echo ^"* Prepare to be DooMed, %s^"", name)
	client_cmd(id,"echo * Type amx_help to see commands.")
	client_cmd(id,"echo * ========================================")
	client_cmd(id,"echo *")
	client_cmd(id,"echo *")
	
	return PLUGIN_CONTINUE
}

public amx_glsetting(id) {
	if (file_exists(gsetfile)) {
		#if DEBUG == 1
		server_print("[AMX_regnam] set global settings to userID: %d.", id)
		#endif
		new cmd[192], len, line = 0
		while(read_file(gsetfile,line++,cmd,191,len))
			client_cmd(id,"%s", cmd)
	}	
	return PLUGIN_CONTINUE
}

public amx_help(id) {
	client_print(id,print_console,"amx_help - show this.")
	client_print(id,print_console,"amx_motd - show message of the day.")
	client_print(id,print_console,"amx_register <name> <password1> <password1> - register NAME with PASSWORD.")
	client_print(id,print_console,"amx_ident <name> <password> - identify to server with NAME and PASSWORD.")
	client_print(id,print_console,"amx_chpass <name> <oldpassword> <newpassword> - change old password to new")
	#if DEBUG == 1
	server_print("amx_help - show this.")
	server_print("amx_motd - show message of the day.")
	server_print("amx_register <name> <password1> <password1> - register NAME with PASSWORD.")
	server_print("amx_ident <name> <password> - identify to server with NAME and PASSWORD.")
	server_print("amx_chpass <name> <oldpassword> <newpassword> - change old password to new")
	#endif
	return PLUGIN_CONTINUE
}

public amx_register(id) {
	if (read_argc() < 4) {
		client_print(id,print_console,"Usage: amx_register < name > < password > < password >")
		#if DEBUG == 1
		server_print("[AMX_regnam] Usage: amx_register < name > < password > < password >")
		#endif
		return PLUGIN_CONTINUE
	}
	new text[MAX_NAME_LENGTH]
	new name[MAX_NAME_LENGTH]
	new pass1[16]
	new pass2[16]   
	
	read_args(text,255)
        parse(text,name,32,pass1,16,pass2,32)
        #if DEBUG == 1
	server_print("[AMX_regnam] name: %s, pass1: %s, pass2: %s.", name, pass1, pass2)
	#endif
	if(equal(name,TheNick)) {
		client_print(id,print_console,"[AMX_regnam] This name is reserved.")
	}
	else if(check_name(id,name)) {
		if (!equal(pass1,pass2)) {
			client_print(id,print_console,"[AMX_regnam] Error, password1 and password2 must be equal!")
			#if DEBUG == 1
			server_print("[AMX_regnam] Error, password1 and password2 must be equal!")
			#endif
			return PLUGIN_CONTINUE
		}
		reg_name(id,name,pass1)
	}
	return PLUGIN_CONTINUE
}

public amx_motd(id) {
	#if DEBUG == 1
	server_print("[AMX_regnam] amx_motd - display message of the day") 
	#endif
	return PLUGIN_CONTINUE
}

public amx_ident(id) {
	if (read_argc() < 3) {   
		client_print(id,print_console,"Usage: amx_ident < name > < password >")
		#if DEBUG == 1
		server_print("[AMX_regnam] Usage: amx_ident < name > < password >")
		#endif
		return PLUGIN_CONTINUE
	}
	new text[MAX_NAME_LENGTH]
	new name[MAX_NAME_LENGTH]
	new pass[16]

	read_args(text,255)
        parse(text,name,32,pass,16)

	if(check_password(id,name,pass)) {
		client_print(id,print_console,"[AMX_regnam] Password accepted, execute autorename...")
		dontrename[id] = true
		if(is_user_connected(id)) {
			set_user_info(id,"name",name)
			client_cmd(id,"setinfo _pw %s",pass)
		} 
		else
			server_print("[AMX_regnam] Player #%d not connected!", id)
	} else {
		client_print(id,print_console,"[AMX_regnam] Wrong name or password!")
	}
	return PLUGIN_CONTINUE
}

public amx_chpass(id) {
	if (read_argc() < 4) {
		client_print(id,print_console,"Usage: amx_chpass < name > < oldpassword > < newpassword >")
		#if DEBUG == 1
		server_print("[AMX_regnam] Usage: amx_chpass < name > < oldpassword > < newpassword >")
		#endif
		return PLUGIN_CONTINUE
	}
	new text[MAX_NAME_LENGTH]
	new name[MAX_NAME_LENGTH]
	new oldpass[16]
	new newpass[16]   
	
	read_args(text,255)
        parse(text,name,32,oldpass,16,newpass,32)
        #if DEBUG == 1
	server_print("[AMX_regnam] name: %s, oldpassword: %s, newpassword: %s.",name,oldpass,newpass)
	#endif
	if(equal(name,TheNick)) {
		client_print(id,print_console,"[AMX_regnam] This name is reserved.")
	} 
	else if(check_password(id,name,oldpass)) {
		change_password(id,name,newpass)
	}
	return PLUGIN_CONTINUE
}

public delay_rename(parm[]) {
	new id = parm[0]
	if(is_user_connected(id) && !dontrename[id]){
		server_print("[AMX_regnam] Try to rename ID#%d to %s",id, TheNick)
		dontrename[id] = true
		set_user_info(id,"name",TheNick)
	}
        return PLUGIN_CONTINUE
}

reg_name(id,name[MAX_NAME_LENGTH], password[16]) {
	new query[256]
	format(query,255,"INSERT INTO passwd (name,password,timestamp) VALUES ('%s','%s',NOW())",name, password)
	mysql_query(mysql, query)
	client_print(id,print_console,"[AMX_regnam] Done.")
	#if DEBUG == 1
	server_print("[AMX_regnam] Done.")
	#endif
}

change_password(id,name[MAX_NAME_LENGTH], password[16]) {
	if (containi(name,"'") != -1 || containi(password,"'") != -1 ) {
		#if DEBUG == 1
		server_print("[AMX_regnam] You cannot use symbol ' in player name or password!")
		#endif
		client_print(id,print_console,"[AMX_regnam] You cannot use symbol ' in player name or password!")
	} 
	else {
		new query[256]
		format(query,255,"UPDATE passwd set password = '%s' WHERE name = '%s'",password,name)
		mysql_query(mysql, query)
		client_print(id,print_console,"[AMX_regnam] Done.")
		#if DEBUG == 1
		server_print("[AMX_regnam] Done.")
		#endif
	}
}

check_name(id, name[MAX_NAME_LENGTH]) {
	new bool:match = true
	new query[256]
	new result[33]
	new pwdoom[16]
	if (containi(name,"'") != -1) {
		#if DEBUG == 1
		server_print("[AMX_regnam] You cannot use symbol ' in player name !")
		#endif
		client_print(id,print_console,"[AMX_regnam] You cannot use symbol ' in player name !")
		return false
	}

	get_user_info(id,"_pwdoom",pwdoom,16)
	if(check_password(id,name,pwdoom)){
		#if DEBUG == 1
		server_print("[AMX_regnam] Player %s already authorized !",name)
		#endif
	}
	else {
	    format(query,255,"SELECT name FROM passwd WHERE name = '%s'",name)
	    if(mysql_query(mysql,query)>0) {
		    if(mysql_nextrow(mysql) > 0) {
			    mysql_getfield(mysql,1,result,32)
			    if (equal(result,name)) {
				    #if DEBUG == 1
				    server_print("[AMX_regnam] Sorry, this name already taken.")
				    #endif
				    client_print(id,print_console,"[AMX_regnam] Sorry, this name already taken.")
				    match = false
			    }
		    }
	    }
	}
	return match
}
check_password(id, name[MAX_NAME_LENGTH], password[16]) {
	new bool:match = false
	new query[256]
	new result[33]
	
	if (containi(name,"'") != -1 || containi(password,"'") != -1 ) {
		#if DEBUG == 1
		server_print("[AMX_regnam] You cannot use symbol ' in player name or password!")
		#endif
		client_print(id,print_console,"[AMX_regnam] You cannot use symbol ' in player name or password!")
		return false
	}
	
	format(query,255,"SELECT name FROM passwd WHERE name = '%s' AND password = '%s' LIMIT 1",name,password)
	if(mysql_query(mysql,query)>0) {
		if(mysql_nextrow(mysql) > 0) {
			mysql_getfield(mysql,1,result,32)
			if (equal(result,name)) {
				#if DEBUG == 1
				server_print("[AMX_regnam] Player %s and password %s match.", name, password)
				#endif
				match = true
			}
		}
	}
	return match
}

public plugin_init() {  
        register_plugin("regnam","1.9","t0d0r")
	
	register_clcmd("amx_reghelp","amx_help")
	register_clcmd("amx_motd","amx_motd")
	register_clcmd("amx_register","amx_register")
	register_clcmd("amx_ident","amx_ident")
	register_clcmd("amx_chpass","amx_chpass")
	
	register_cvar("amx_mysql_host","127.0.0.1")
	register_cvar("amx_mysql_user","amx")
	register_cvar("amx_mysql_pass","")
	register_cvar("amx_mysql_db","amx")

	get_cvar_string("amx_mysql_host",sqlhost,16)
	get_cvar_string("amx_mysql_user",sqluser,32)
	get_cvar_string("amx_mysql_pass",sqlpass,32)
	get_cvar_string("amx_mysql_db",sqldb,32) 

	mysql = mysql_connect(sqlhost,sqluser,sqlpass,sqldb,sqlerror,127)
	if(mysql < 1){
		mysql_error(mysql,sqlerror,127) 
		server_print("[AMX_regnam] MySQL error : could not connect : '%s'",sqlerror) 
	}
	return PLUGIN_CONTINUE
}
public plugin_end(){
    if (mysql > 0)
        mysql_close(mysql)
    return PLUGIN_CONTINUE
}
