/* AMX Mod script.
*
* Soundcheck 1.10
*  by SniperBeamer
*
*
* Description:
*  Soundcheck converted for AMX Mod.
*
* Settings:
*  sc_soundcheck 0/1 - enable/disable SoundCheck
*  sc_weaponcheck 0/1 - enable/disable for weapon models
*  sc_exactweapons 0/1 - weapon models must match exact
*  sc_wadcheck 0/1 - enable/disable for WADs
*  sc_separatelog 0/1 - enabe/disable logging to a seperate log file
*
* Files:
*  Settings: addons/amx/soundcheck.cfg
*  Seperatelog: addons/amx/logs/soundcheck.log
*
*/

#include <amxmod>

#define NEW_AMX // AMX 0.9.4+

new bool:g_separatelog = false
new g_logfile[32]

public plugin_init()
{
	register_plugin("Soundcheck","1.10","SniperBeamer")
	register_cvar("sc_version","1.10",FCVAR_SERVER|FCVAR_EXTDLL|FCVAR_SPONLY)
}

public inconsistent_file(id, const filename[], reason[64])
{
	new msg[64],Name[32],Authid[32],Team[32]
	get_user_name(id,Name,31)
	get_user_authid(id,Authid,31)
	get_user_team(id,Team,31)

	format(msg,63,"^"%s<%d><%s><%s>^" has inconsistent file ^"%s^"",Name,get_user_userid(id),Authid,Team,filename)

	if ( g_separatelog )
		log_to_file(g_logfile,msg)
	else
		log_message("[sc] %s",msg)

	server_cmd("say ^"%s^"",msg)
}

public plugin_precache()
{
	register_cvar("sc_soundcheck","1")
	register_cvar("sc_weaponcheck","0")
	register_cvar("sc_exactweapons","0")
	register_cvar("sc_wadcheck","0")
	register_cvar("sc_separatelog","0")

	#if defined NEW_AMX
	new basedir[32]
	get_localinfo("amx_basedir",basedir,31)
	server_cmd("exec %s/soundcheck.cfg",basedir)
	#else
	server_cmd("exec addons/amx/soundcheck.cfg")
	#endif
	server_exec()

	// Log
	if ( get_cvar_num("sc_separatelog")==1 )
	{
		g_separatelog = true
		#if defined NEW_AMX
		copy(g_logfile,31,"soundcheck.log")
		#else
		copy(g_logfile,31,"addons/amx/logs/soundcheck.log")
		#endif
	}

	if ( get_cvar_num("sc_soundcheck")==1 )
	{
		// Sounds
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/bhit_flesh-1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/bhit_flesh-2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/bhit_flesh-3.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/bhit_helmet-1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/bhit_kevlar-1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/headshot1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/headshot2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/headshot3.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_dirt1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_dirt2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_dirt3.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_dirt4.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_duct1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_duct2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_duct3.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_duct4.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_fallpain2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_fallpain3.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_grate1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_grate2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_grate3.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_grate4.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_jump1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_jump2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_jumpland2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_ladder1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_ladder2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_ladder3.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_ladder4.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_metal1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_metal2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_metal3.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_metal4.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_pain2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_pain4.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_pain5.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_pain6.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_pain7.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_shot1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_step1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_step2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_step3.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_step4.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_tile1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_tile2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_tile3.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_tile4.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"player/pl_tile5.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/boltdown.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/boltpull1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/clipin1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/clipout1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/c4_disarm.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/flashbang-1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/flashbang-2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/generic_reload.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/grenade_hit1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/grenade_hit2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/grenade_hit3.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/he_bounce-1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/headshot2.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/knife_deploy1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/m4a1_silencer_off.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/m4a1_silencer_on.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/m4a1-1.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/usp_silencer_off.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/usp_silencer_on.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/zoom.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/dryfire_pistol.wav")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"weapons/dryfire_rifle.wav")

		// Sprites
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"sprites/eexplo.spr")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"sprites/fexplo.spr")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"sprites/fexplo1.spr")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"sprites/muzzleflash1.spr")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"sprites/muzzleflash2.spr")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"sprites/muzzleflash3.spr")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"sprites/muzzleflash4.spr")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"sprites/radar320.spr")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"sprites/radar640.spr")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"sprites/grass_01.spr")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"sprites/grass_03.spr")
	}

	// Weapon Models
	if ( get_cvar_num("sc_weaponcheck") )
	{
		new force_mode = get_cvar_num("sc_exactweapons") ? force_exactfile : force_model_samebounds
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_aug.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_ak47.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_awp.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/w_c4.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_c4.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_deagle.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/w_flashbang.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_flashbang.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_glock18.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/w_hegrenade.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_hegrenade.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_knife.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_m4a1.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_mp5.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_scout.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/w_smokegrenade.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_smokegrenade.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_usp.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_sg552.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_famas.mdl")
		force_unmodified(force_mode,{0,0,0},{0,0,0},"models/p_galil.mdl")
	}

	// WADs
	if ( get_cvar_num("sc_wadcheck") )
	{
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"chateau.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"cs_cbble.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"cs_dust.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"cs_office.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"cstrike.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"de_aztec.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"de_storm.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"itsitaly.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"jos.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"prodigy.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"torntextures.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"halflife.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"liquids.wad")
		force_unmodified(force_exactfile,{0,0,0},{0,0,0},"xeno.wad")
	}
}
