DROP TABLE IF EXISTS amx_mystatus_admin;
CREATE TABLE amx_mystatus_admin (
  admin_id smallint(5) unsigned NOT NULL auto_increment,
  user varchar(20) NOT NULL default '',
  pass varchar(32) NOT NULL default '',
  PRIMARY KEY  (admin_id)
) TYPE=MyISAM;

DROP TABLE IF EXISTS amx_mystatus_player_info;
CREATE TABLE amx_mystatus_player_info (
  server_id tinyint(3) unsigned NOT NULL default '0',
  wonid varchar(20) default NULL,
  team varchar(16) default NULL,
  name varchar(32) default NULL,
  status tinyint(3) unsigned default NULL,
  frags smallint(5) unsigned default NULL,
  deaths smallint(5) unsigned default NULL,
  ping smallint(5) unsigned default NULL,
  loss smallint(5) unsigned default NULL,
  UNIQUE KEY wonid (wonid)
) TYPE=MyISAM;

DROP TABLE IF EXISTS amx_mystatus_server_info;
CREATE TABLE amx_mystatus_server_info (
  server_id smallint(6) NOT NULL default '1',
  hostname varchar(64) default NULL,
  hostport smallint(6) default NULL,
  map varchar(20) default NULL,
  maxplayers tinyint(3) unsigned default NULL,
  modname varchar(10) default NULL,
  mp_autokick tinyint(3) unsigned default NULL,
  mp_autoteambalance tinyint(3) unsigned default NULL,
  mp_c4timer smallint(5) unsigned default NULL,
  mp_flashlight tinyint(3) unsigned default NULL,
  mp_footsteps tinyint(3) unsigned default NULL,
  mp_forcechasecam tinyint(3) unsigned default NULL,
  mp_freezetime tinyint(3) unsigned default NULL,
  mp_friendlyfire tinyint(3) unsigned default NULL,
  mp_hostagepenalty tinyint(3) unsigned default NULL,
  mp_limitteams tinyint(3) unsigned default NULL,
  mp_logmessages tinyint(3) unsigned default NULL,
  mp_mapvoteratio decimal(4,2) unsigned default NULL,
  mp_roundtime smallint(5) unsigned default NULL,
  mp_timelimit mediumint(8) unsigned default NULL,
  mp_startmoney mediumint(8) unsigned default NULL,
  mp_tkpunish tinyint(3) unsigned default NULL,
  net_address varchar(20) default NULL,
  nextmap varchar(20) default NULL,
  timeleft int(11) default NULL,
  ct_score tinyint(3) unsigned NOT NULL default '0',
  terrorist_score tinyint(3) unsigned NOT NULL default '0',
  PRIMARY KEY  (server_id)
) TYPE=MyISAM;

INSERT INTO `amx_mystatus_server_info` (`server_id`, `hostname`, `hostport`, `map`, `maxplayers`, `modname`, `mp_autokick`, `mp_autoteambalance`, `mp_c4timer`, `mp_flashlight`, `mp_footsteps`, `mp_forcechasecam`, `mp_freezetime`, `mp_friendlyfire`, `mp_hostagepenalty`, `mp_limitteams`, `mp_logmessages`, `mp_mapvoteratio`, `mp_roundtime`, `mp_timelimit`, `mp_startmoney`, `mp_tkpunish`, `net_address`, `nextmap`, `timeleft`, `ct_score`, `terrorist_score`) VALUES ('1', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0', '0'); 

DROP TABLE IF EXISTS amx_mystatus_style;
CREATE TABLE amx_mystatus_style (
  server_id tinyint(3) unsigned NOT NULL default '1',
  table_bgcolor varchar(10) NOT NULL default '#CCCCCC',
  table_font_color varchar(10) NOT NULL default '#000000',
  body_bgcolor varchar(10) NOT NULL default '#000000',
  td_font_size varchar(10) NOT NULL default '12',
  td_font_family varchar(255) NOT NULL default 'Verdana, A',
  td_cthead_font_size varchar(10) NOT NULL default '12',
  td_cthead_font_color varchar(10) NOT NULL default '#ffffff',
  td_cthead_bgcolor varchar(10) NOT NULL default '#336699',
  td_tshead_font_size varchar(10) NOT NULL default '12',
  td_tshead_font_color varchar(10) NOT NULL default '#ffffff',
  td_tshead_bgcolor varchar(10) NOT NULL default '#990033',
  tr_plr_live_font_size varchar(10) NOT NULL default '10',
  tr_plr_live_font_color varchar(10) NOT NULL default 'lime',
  tr_plr_live_bgcolor varchar(10) NOT NULL default '#666666',
  tr_plr_dead_font_size varchar(10) NOT NULL default '10',
  tr_plr_dead_font_color varchar(10) NOT NULL default 'lime',
  tr_plr_dead_bgcolor varchar(10) NOT NULL default '#666666',
  tr_plr_head_font_size varchar(10) NOT NULL default '10',
  tr_plr_head_font_color varchar(10) NOT NULL default 'lime',
  tr_plr_head_bgcolor varchar(10) NOT NULL default '#666666',
  td_cvar_font_size varchar(10) NOT NULL default '10',
  td_cvar_font_color varchar(10) NOT NULL default 'lime',
  td_cvar_bgcolor varchar(10) NOT NULL default '#333333',
  PRIMARY KEY  (server_id)
) TYPE=MyISAM;

INSERT INTO amx_mystatus_style VALUES (1, '#000000', '#FFFFFF', '#003366', '12', 'Verdana, Arial', '12', '#FFFFFF', '#336699', '12', '#ffffff', '#990033', '10', 'lime', '#666666', '10', '#CCCCCC', '#555555', '10', '#CCCCCC', '#666666', '10', '#66ccff', '#333333');
INSERT INTO amx_mystatus_style VALUES (0, '#000000', '#FFFFFF', '#003366', '12', 'Verdana, Arial', '12', '#FFFFFF', '#336699', '12', '#FFFFFF', '#990033', '10', 'lime', '#666666', '10', '#CCCCCC', '#555555', '10', '#CCCCCC', '#666666', '10', '#66ccff', '#333333');