/* AMXMOD script. 
* 
* (c) Copyright 2000-2002, RAV 
* This file is provided as is (no warranties). 
* 
* 
* Players will be punised for swearing 
* 
* Changelog: 
*  0.6  - Updated read_file for amx 0.6 (JustinHoMi) 
*        Words are no longer case sensitive thanks to 0.6 (JustinHoMi) 
*  0.51 - Reads words from wordlist.cfg (JustinHoMi) 
*  0.5  - Initial Relase 
* 
*/ 

#include <amxmod> 

// max number of words in word list 
#define MAX_WORDS 64 

// file to read words from 
new wordlist[32] = "addons/amx/wordlist.cfg" 

new swears[MAX_WORDS][32] 
new num_words = 0 

new light 
new smoke 

lightning(vec1[3],vec2[3]) 
{ 
   //Lightning 
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY) 
   write_byte( 0 ) 
   write_coord(vec1[0]) 
   write_coord(vec1[1]) 
   write_coord(vec1[2]) 
   write_coord(vec2[0]) 
   write_coord(vec2[1]) 
   write_coord(vec2[2]) 
   write_short( light ) 
   write_byte( 1 ) // framestart 
   write_byte( 5 ) // framerate 
   write_byte( 2 ) // life 
   write_byte( 20 ) // width 
   write_byte( 30 ) // noise 
   write_byte( 200 ) // r, g, b 
   write_byte( 200 ) // r, g, b 
   write_byte( 200 ) // r, g, b 
   write_byte( 200 ) // brightness 
   write_byte( 200 ) // speed 
   message_end() 

   //Sparks 
   message_begin( MSG_PVS, SVC_TEMPENTITY,vec2) 
   write_byte( 9 ) 
   write_coord( vec2[0] ) 
   write_coord( vec2[1] ) 
   write_coord( vec2[2] ) 
   message_end() 

   //Smoke 
   message_begin( MSG_BROADCAST,SVC_TEMPENTITY,vec2) 
   write_byte( 5 ) 
   write_coord(vec2[0]) 
   write_coord(vec2[1]) 
   write_coord(vec2[2]) 
   write_short( smoke ) 
   write_byte( 10 ) 
   write_byte( 10 ) 
   message_end() 

} 


public swear_punish(id) 
{ 
   new said[128] 
   read_args(said,128) 

   for (new i=0; i<=num_words; i++) 
   { 
       if (containi(said,swears[i]) != -1) 
       { 
           user_slap(id,10) 
           new origin[3] 
           get_user_origin(id,origin) 
           origin[2] = origin[2] - 26 
           new sorigin[3] 
           sorigin[0] = origin[0] + 150 
           sorigin[1] = origin[1] + 150 
           sorigin[2] = origin[2] + 400 
           lightning(sorigin,origin) 
           emit_sound(id,CHAN_ITEM, "ambience/thunder_clap.wav", 1.0, ATTN_NORM, 0, PITCH_NORM) 
           set_hudmessage(140, 0, 0, 0.75, 0.50, 0, 3.0, 3.0, 0.5, 0.15, 4) 
           show_hudmessage(id,"WATCH YOUR LANGUAGE^nSlap loss 10 Health") 
           return PLUGIN_HANDLED 
       } 
   } 
   return PLUGIN_CONTINUE 
} 

public plugin_precache() 
{ 
   light = precache_model("sprites/lgtning.spr") 
   precache_sound( "ambience/thunder_clap.wav") 
   precache_sound( "weapons/headshot2.wav") 
   return PLUGIN_CONTINUE 
} 

public read_list() 
{ 
    new index=0, line[32] 
    if (file_exists(wordlist)) 
    { 
      new length 
        while(read_file(wordlist,index++,line,32,length)) 
            swears[index] = line 
        num_words = index 
    } 
    else log_message("[AMX] Swear file not found") 

    return PLUGIN_CONTINUE 
} 

public plugin_init() 
{ 
    register_plugin("SWEAR PUNISH","0.6","Rav") 
    register_clcmd("say","swear_punish") 
    register_clcmd("say_team","swear_punish") 
    register_cvar("Rav_SwearPunish", "1.3",FCVAR_SERVER) 
    read_list() 
    return PLUGIN_CONTINUE 
} 

