#include <amxmod>

// Unreal Tournament Killing Spree Plugin
// PsychoGuard's Code, modified by Duca
// 
// CVARs:
//
// ut_streak_mode - default "abe"
//
// a - announce to all players by sound
// b - announce to all players by hud message
// c - announce to scorer by sound
// d - announce to scorer by hud message
// e - announce current death/killstreak at round start

new kills[33] = {0,...};
new deaths[33] = {0,...};

#define LEVELS 6

new levels[6] = {2, 5, 6, 7, 8, 10};
new sounds[6][] = {"misc/doublekill", "misc/killingspree", "misc/rampage",
                   "misc/dominating", "misc/unstoppable", "misc/godlike"};
new messages[6][] = {"%s: DOUBLE-KILL!!!", "%s IS ON A KILLING SPREE!!!",
                     "%s IS ON A RAMPAGE!!!", "%s IS DOMINATING!!!",
                     "%s IS UNSTOPPABLE!!!", "%s IS GODLIKE!!!" };

is_mode_set(bits) {
    new mode[9];
    get_cvar_string("ut_streak_mode", mode, 8);
    return read_flags(mode) & bits;
}

public death_event(id) {
    new killer = read_data(1);
    new victim = read_data(2);

    kills[killer] += 1;
    kills[victim] = 0;
    deaths[killer] = 0;
    deaths[victim] += 1;

    for (new i = 0; i < LEVELS; i++) {
        if (kills[killer] == levels[i]) {
            announce(killer, i);
            return PLUGIN_CONTINUE;
        }
    }

    return PLUGIN_CONTINUE;
}

announce(killer, level) {
    new name[33];

    get_user_name(killer, name, 32);
    set_hudmessage(0, 100, 200, 0.05, 0.65, 2, 0.02, 6.0, 0.01, 0.1, 2);

    if (is_mode_set(2)) {
        show_hudmessage(0, messages[level], name);
    } else if (is_mode_set(8)) {
        show_hudmessage(killer, messages[level], name);
    }
    if (is_mode_set(1)) {
        client_cmd(0, "spk %s", sounds[level]);
    } else if (is_mode_set(4)) {
        client_cmd(killer, "spk %s", sounds[level]);
    }
}

public reset_hud(id) {
    if (is_mode_set(16)) {
        if (kills[id] > levels[0]) {
            client_print(id, print_chat,
                         "* You are on a killstreak with %d kills.",
                         kills[id]);
        } else if (deaths[id] > 1) {
            client_print(id, print_chat,
                         "* Take care, you are on a deathstreak with %d deaths in a row.",
                         deaths[id]);
        }
    }
}

public client_connect(id) {
    kills[id] = 0;
    deaths[id] = 0;
}

public plugin_init() {
    register_plugin("UT Killing Spree", "0.9.2", "Duca");

    register_cvar("ut_streak_mode", "abe");

    register_event("ResetHUD", "reset_hud", "b");
    register_event("DeathMsg", "death_event", "a");

    return PLUGIN_CONTINUE;
}
