/* AMX Mod script.
*
* (c) Copyright 2003, Phreak
* This file is provided as is (no warranties).
*
* The Plugin logs lines from the chat containing specific keywords in a file
*
* Usage:
*  put amx_logword "word" in amx.cfg/admin.cfg (one for each word)
* Example:
*  amx_logword "admin"
*  amx_logword "lamer"
*  amx_logword "cheat"
*
* Changelog:
* v0.2
*  - now working with amx 0.9.4 and higher
*  - fixed multiple loggings of the same line
* v0.1
*  Initial Version
*/

#include <amxmod>

// comment this out if you use amx 0.9.3 or older
#define NEW_AMX
#define MAX_WORDS 16

new words[MAX_WORDS][32]
new num_words = 0
#if defined NEW_AMX
	new logfilename[256] = "wordlog.log"
#else
	new logfilename[256] = "addons/amx/logs/wordlog.log"
#endif

public check_say(id) {
	new message[256],name[32],steamid[32]
	read_args(message,255)
	remove_quotes(message)
	for (new i=0;i<num_words;i++) {
		if (containi(message,words[i])!=-1) {
			get_user_authid(id, steamid, 31)
			get_user_name(id,name,31)
			log_to_file(logfilename,"%s <%d>: ^"%s^"",name,steamid,message)
			return PLUGIN_CONTINUE
		}
	}
	return PLUGIN_CONTINUE
}

public logword() {
	if (num_words>=MAX_WORDS) {
		server_print("[AMX] Maximum number of logwords exceeded (%d)",MAX_WORDS)
		return PLUGIN_HANDLED
	}
	new arg[32]
	read_argv(1,arg,31)
	copy(words[num_words++],31,arg)
	return PLUGIN_HANDLED
}

public plugin_init() {
	register_plugin("WordLog","0.2","Phreak")
	register_clcmd("say","check_say")
	register_clcmd("say_team","check_say")
	register_srvcmd("amx_logword","logword");
}
